BSCASynergy = BSCASynergy or {}
local BSCAS = BSCASynergy

local UI_HIGHT = 30
local UI_WIDTH = 250
local MAX_UI_COUNT = 25
local MAX_FILL_WIDTH = 0
local bossUnitTags = {}
local ALKOSH_LIST = { } -- contains info of the alkosh buff
local ALKOSH_HITVAL = 0
BSCAS.AlkoshBuffActive = false

local function IsUnitBoss(UnitTag)
	if UnitTag == nil then return false end
	for k, v in pairs(bossUnitTags) do
		if k == UnitTag then 
			return true 	
		end
	end
	return false
end
local debug_mode = false
function BSCAS.AlkoshDebugMode()
	debug_mode = not debug_mode
	BSCAS:PrintDebug("Debug Mode (Alkosh) "..zo_strformat("<<1>>[<<2>><<3>><<4>>]", "|cb3b6b7", (debug_mode and BSCAS.color_red or BSCAS.color_green), (debug_mode and 'Enabled' or 'Disabled'), "|cb3b6b7"))
end
local function SetAlkoshMode(enable)
	if not BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ALKOSHCHECK then return end
	if BSCAS.AlkoshBuffActive == enable then return end
	BSCAS.AlkoshBuffActive = enable
	if debug_mode then
		BSCAS:PrintDebug("AlkoshBuffActive = "..zo_strformat("<<1>>[<<2>><<3>><<4>>]", "|cb3b6b7", (enable and BSCAS.color_red or BSCAS.color_green), (enable and 'true' or 'false'), "|cb3b6b7"))
	end
end
local function ReApplyAlkosh()	
	local duration = 0	
	for i=1, MAX_BOSSES do
		duration = ALKOSH_LIST[i].EndTime - (GetGameTimeMilliseconds()/1000)
		if ALKOSH_LIST[i].Ident ~= 0 then
			if duration <= BSCAS.SV.ALKOSH_REAPPLY then
				SetAlkoshMode(false)
			end
		end
	end
end
local function AlkoshUpdateUI()
	local counter = 0
	local cdControl = nil
	local duration = 0	
	local BG_R = 255
	local BG_G = 0
	local UI_FILL = 0
	
	for i=1, BSCAS.SV.ALKOSH_LIST_COUNT do
		cdControl = BSCASAlkoshUI:GetNamedChild("Debuff_" .. i)		
		duration = ALKOSH_LIST[i].EndTime - (GetGameTimeMilliseconds()/1000)
		if ALKOSH_LIST[i].Ident ~= 0 and duration > 0 then
			UI_FILL = MAX_FILL_WIDTH
			BG_R = 255
			BG_G = 0
			
			UI_FILL = duration/(ALKOSH_LIST[i].EndTime-ALKOSH_LIST[i].BeginTime) * MAX_FILL_WIDTH
			BG_R = (UI_FILL > (MAX_FILL_WIDTH / 2) and (UI_FILL *2/(MAX_FILL_WIDTH / 4))) or 1
			BG_G = (UI_FILL < (MAX_FILL_WIDTH / 2) and (UI_FILL *2/(MAX_FILL_WIDTH / 3))) or 1				
	
			cdControl:GetNamedChild("Bar"):SetWidth(UI_FILL)
			cdControl:GetNamedChild("Bar"):SetCenterColor(BG_R, BG_G, 0, 0.60)	
			--
			cdControl:SetHidden(false)
			cdControl:ClearAnchors()
			cdControl:SetAnchor(TOPLEFT, BSCASAlkoshUI, TOPLEFT, math.floor(UI_WIDTH / 10), math.floor(UI_HIGHT / 10) + counter * (UI_HIGHT + math.floor(UI_HIGHT / 10)))
			cdControl:GetNamedChild("Label"):SetText(ALKOSH_LIST[i].unitName)
			cdControl:GetNamedChild("Timer"):SetText(string.format("%.1f", duration))	
			
			-- playing sound			
			if i < MAX_BOSSES and duration <= BSCAS.SV.ALKOSH_SOUND_INC and ALKOSH_LIST[i].playSound and BSCAS.SV.ALKOSH_SOUND_PLAY then
				ALKOSH_LIST[i].playSound = false				
				BSCAS.PlaySound(BSCAS.SV.ALKOSH_SOUND_LOOP, BSCAS.SV.ALKOSH_SOUND_ID) 				
			end			
			-- update counter
			counter = counter +1
		else
			if ALKOSH_LIST[i].Ident ~= 0 and ALKOSH_LIST[i].EndTime ~= 0 then
				if i < MAX_BOSSES then SetAlkoshMode(false) end
				ALKOSH_LIST[i] = { Ident = 0, UnitTag = "", BeginTime = 0, EndTime = 0, unitName = "", playSound = false }
			end
			cdControl:SetHidden(true)
		end
	end
	-- Show Value	
	if counter > 0 then
		BSCASAlkoshUI:GetNamedChild("Value"):SetHidden(false)
		BSCASAlkoshUI:GetNamedChild("Value"):SetText(zo_strformat("Pen. Value <<1>>", ALKOSH_HITVAL))
	else
		BSCASAlkoshUI:GetNamedChild("Value"):SetHidden(true)
	end
end
function BSCAS.AlkoshDummyList()
	for i=1, MAX_UI_COUNT do
		local Utag = "TestUnit_"..i
		local pSound = false
		if i < MAX_BOSSES then
			Utag = "boss"..i
			pSound = true
		end
		ALKOSH_LIST[i] = { Ident = i, UnitTag = Utag, BeginTime = (GetGameTimeMilliseconds()/1000), EndTime = (GetGameTimeMilliseconds()/1000) +20, unitName = Utag, playSound = pSound }
	end
	AlkoshUpdateUI()
end
function BSCAS.ClearDummyList()
	for i=1, MAX_UI_COUNT do
		local Utag = "TestUnit_"..i
		local pSound = false
		if i < MAX_BOSSES then
			Utag = "boss"..i
			pSound = true
		end
		ALKOSH_LIST[i] = { Ident = i, UnitTag = Utag, BeginTime = (GetGameTimeMilliseconds()/1000), EndTime = (GetGameTimeMilliseconds()/1000), unitName = Utag, playSound = pSound }
	end
	AlkoshUpdateUI()
end
local function CreateControls()
	bossUnitTags = {}
	for i = 1, MAX_BOSSES do
        bossUnitTags["boss"..i] = true
    end	
	ALKOSH_LIST = { }
	for i=1, MAX_UI_COUNT do
		WINDOW_MANAGER:CreateControlFromVirtual("$(parent)Debuff_", BSCASAlkoshUI, "BSCASAlkoshUIVirtual", i)				
		table.insert(ALKOSH_LIST, { Ident = 0, UnitTag = "", BeginTime = 0, EndTime = 0, unitName = "", playSound = false })	
	end	
	BSCAS.AlkoshUIChanges()
end
function BSCAS.AlkoshUIChanges()
	UI_HIGHT = BSCAS.SV.UI_HIGHT
	UI_WIDTH = BSCAS.SV.UI_WIDTH
	local control = nil
	for i=1, MAX_UI_COUNT do
		control = BSCASAlkoshUI:GetNamedChild("Debuff_" .. i)		
		control:SetHidden(true)
		-- Background
		--Bg 
		control:GetNamedChild("Back"):SetDimensions(BSCAS.SV.UI_WIDTH, BSCAS.SV.UI_HIGHT)
		-- Icon
		control:GetNamedChild("Icon"):SetTexture(GetAbilityIcon(BSCAS.ALKOSH_DBUFF_ID))		
		control:GetNamedChild("Icon"):SetDimensions(BSCAS.SV.UI_HIGHT-4, BSCAS.SV.UI_HIGHT-4)		
		-- Statusbar
		MAX_FILL_WIDTH = BSCAS.SV.UI_WIDTH - (BSCAS.SV.UI_HIGHT *2) - 4
		control:GetNamedChild("Bar"):SetDimensions(MAX_FILL_WIDTH, BSCAS.SV.UI_HIGHT)		
		control:GetNamedChild("Bar"):SetCenterColor(255, 0, 0, 0.60)		
		-- Timer
		control:GetNamedChild("Timer"):SetFont("$(BOLD_FONT)|$(KB_" .. BSCAS.FontCheck(math.floor(BSCAS.SV.UI_HIGHT / 2)) .. ")|soft-shadow-thick")
		control:GetNamedChild("Timer"):SetText(string.format("%.1f", 10))
		control:GetNamedChild("Timer"):SetDimensions(BSCAS.SV.UI_WIDTH - (BSCAS.SV.UI_HIGHT *2) - 4, BSCAS.SV.UI_HIGHT)
		-- Label (name of targed)
		control:GetNamedChild("Label"):SetFont("$(MEDIUM_FONT)|$(KB_" .. BSCAS.FontCheck(math.floor(BSCAS.SV.UI_HIGHT / 2)) .. ")|soft-shadow-thin")
		control:GetNamedChild("Label"):SetText("Debuff_"..i)
		control:GetNamedChild("Label"):SetDimensions(BSCAS.SV.UI_WIDTH, BSCAS.SV.UI_HIGHT)
		
		control:GetNamedChild("Marker"):SetDimensions(3, BSCAS.SV.UI_HIGHT + 4) 
		control:GetNamedChild("Marker"):ClearAnchors()
		control:GetNamedChild("Marker"):SetAnchor(LEFT, control:GetNamedChild("Bar"), LEFT, (BSCAS.SV.ALKOSH_SOUND_INC / (10) * MAX_FILL_WIDTH), 0)	
		if i < MAX_BOSSES then		
			if BSCAS.SV.ALKOSH_ENABLE_MARK then
				control:GetNamedChild("Marker"):SetHidden(false)
			else
				control:GetNamedChild("Marker"):SetHidden(true)
			end
		end
	end
	BSCASAlkoshUI:GetNamedChild("Value"):SetFont("$(BOLD_FONT)|$(KB_" .. BSCAS.FontCheck(math.floor(BSCAS.SV.UI_HIGHT / 2)) .. ")|soft-shadow-thick")
	BSCASAlkoshUI:GetNamedChild("Value"):SetWidth(BSCAS.SV.UI_WIDTH)
	BSCASAlkoshUI:SetAlpha(BSCAS.SV.UI_ALPHA)
end
local function ToggleUI(oldState, newState)
	if not BSCAS.SV.ALKOSH_CHECK then return end
	if newState == SCENE_SHOWN then
		BSCASAlkoshUI:SetHidden(false)
	elseif newState == SCENE_HIDDEN then
		BSCASAlkoshUI:SetHidden(true)
	end
end
function BSCAS.AlkoshOnMoveStop()
	BSCAS.SV.UI_LEFT = BSCASAlkoshUI:GetLeft()
	BSCAS.SV.UI_TOP = BSCASAlkoshUI:GetTop()
end
local function RestorePosition()
	BSCASAlkoshUI:ClearAnchors()
	BSCASAlkoshUI:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, BSCAS.SV.UI_LEFT, BSCAS.SV.UI_TOP)
	BSCASAlkoshUI:SetMovable(not BSCAS.SV.ALKOSH_LOCK_UI)
end
local function RemoveBossFromNormal(Idt)
	for i = MAX_BOSSES, MAX_UI_COUNT do	
		if ALKOSH_LIST[i].Ident == Idt then		
			ALKOSH_LIST[i] = { Ident = 0, UnitTag = "", BeginTime = 0, EndTime = 0, unitName = "", playSound = false }
			break
		end		
	end	
end
local function UpdateTableData(Idt, UTag, BTime, ETime, UName, changeType)
	-- remove from list
	if changeType == EFFECT_RESULT_FADED then
		if IsUnitBoss(UTag) then
			SetAlkoshMode(false)
		end
		for i = 1, MAX_UI_COUNT do	
			if ALKOSH_LIST[i].Ident == Idt then		
				ALKOSH_LIST[i] = { Ident = 0, UnitTag = "", BeginTime = 0, EndTime = 0, unitName = "", playSound = false }
				break
			end		
		end	
		return
	-- update
	elseif changeType == EFFECT_RESULT_UPDATED then
		local updated = false
		for i = 1, MAX_UI_COUNT do	
			if ALKOSH_LIST[i].Ident == Idt then		
				ALKOSH_LIST[i] = { Ident = Idt, UnitTag = UTag, BeginTime = BTime, EndTime = ETime, unitName = UName, playSound = true }				
				updated = true
				break
			end
		end	
		if updated then return end
	else
		-- add 	
		if IsUnitBoss(UTag) then -- remeber the first 5 are for boss only
			for i = 1, MAX_BOSSES do
				if ALKOSH_LIST[i].Ident == Idt or ALKOSH_LIST[i].Ident == 0 then		
					ALKOSH_LIST[i] = { Ident = Idt, UnitTag = UTag, BeginTime = BTime, EndTime = ETime, unitName = UName, playSound = true }
					SetAlkoshMode(true)
					RemoveBossFromNormal(Idt)
					break
				end
			end
		else	
			-- its not a boss
			for i = MAX_BOSSES, MAX_UI_COUNT do	
				if ALKOSH_LIST[i].Ident == Idt or ALKOSH_LIST[i].Ident == 0 then		
					ALKOSH_LIST[i] = { Ident = Idt, UnitTag = UTag, BeginTime = BTime, EndTime = ETime, unitName = UName, playSound = true }
					break
				end		
			end	
		end
	end
end
local function CalcolatePlayerStat()
	local WP = GetPlayerStat(STAT_POWER)
	local SP = GetPlayerStat(STAT_SPELL_POWER)
	if WP > SP then
		ALKOSH_HITVAL = WP
	else
		ALKOSH_HITVAL = SP
	end
end
-- EVENT_EFFECT_CHANGED (eventCode, changeType, effectSlot, effectName, unitTag, beginTime, endTime, stackCount, iconName, buffType, effectType, abilityType, statusEffectType, unitName, unitId, abilityId, sourceType)
local function AlkoshOnEffectChanged( _,  changeType,  _,  _,  unitTag, beginTime, endTime,  _,  _,  _,  effectType, _,  _,  unitName, unitId, abilityId, sourceType)
	--changeType  1 -- add 2 -- remove	3 -- update	
	local ident = zo_strformat("<<1>><<2>>", unitId, abilityId)	
	UpdateTableData(ident, unitTag, beginTime, endTime, zo_strformat("<<!aC:1>>", unitName), changeType)
	if debug_mode then
		BSCAS:PrintDebug(zo_strformat("ID[<<1>>] Name[<<2>>] Tag[<<3>>] changeType[<<4>>]", ident, unitName, unitTag, changeType))
	end
	CalcolatePlayerStat()
end
function BSCAS.AlkoshEnable()
	BSCAS.ClearDummyList()
	if BSCAS.SV.ALKOSH_CHECK then 
		BSCASAlkoshUI:SetHidden(false)
		--
		EVENT_MANAGER:RegisterForUpdate('BSCAS_AlkoshUpdate', BSCAS.UPDATE_INTERVAL, AlkoshUpdateUI)
	end	
end
function BSCAS.AlkoshDisable()
	BSCAS.ClearDummyList()
	if BSCAS.SV.ALKOSH_CHECK then 
		BSCASAlkoshUI:SetHidden(true)
		EVENT_MANAGER:UnregisterForUpdate('BSCAS_AlkoshUpdate')
	end
end
function BSCAS.AlkoshInit()	
	-- Build the menu
	BSCAS.InitAlkoshMenu()
	CreateControls()
	AlkoshUpdateUI()
	RestorePosition()
	SCENE_MANAGER:GetScene("hud"):RegisterCallback("StateChange", ToggleUI)
	SCENE_MANAGER:GetScene("hudui"):RegisterCallback("StateChange", ToggleUI)
	-- debuff time
	EVENT_MANAGER:RegisterForEvent("BSCAS_AlkoshOnEffectChanged", EVENT_EFFECT_CHANGED, AlkoshOnEffectChanged)
	EVENT_MANAGER:AddFilterForEvent("BSCAS_AlkoshOnEffectChanged", EVENT_EFFECT_CHANGED, REGISTER_FILTER_ABILITY_ID, BSCAS.ALKOSH_DBUFF_ID)	
	EVENT_MANAGER:RegisterForUpdate('BSCAS_AlkoshCheckApply', BSCAS.UPDATE_INTERVAL, ReApplyAlkosh)
	CalcolatePlayerStat()
end
