BSCASynergy = BSCASynergy or {}
local BSCAS = BSCASynergy

local optionsTable = {}
local s_sounds = { }
local s_choices = { }

local function AddSendFeedBack()
    table.insert(optionsTable, {
        type = "button",
        name = "Donate",
        tooltip = "Main - EU Server",
        func = function()
              local function PrefillMail()
                ZO_MailSendToField:SetText(BSCAS.Author)
                ZO_MailSendSubjectField:SetText(BSCAS.NameSpaced)
                ZO_MailSendBodyField:TakeFocus()
              end
                SCENE_MANAGER:Show('mailSend')
                zo_callLater(PrefillMail, 250)
        end,
        width = "half",
        warning = "",	
    })
end

local function AddTexture(control, strIcon, strDesciption)
	table.insert(control, {
        type = "texture",
        image =  strIcon,
		tooltip = strDesciption,
        imageWidth = 32,
        imageHeight = 32,
        width = "half",
	})
end

local function ShowBSCUI()
	BSCAS.AlkoshDummyList()
	-- new
	if BSCASAlkoshUI:IsHidden() then BSCASAlkoshUI:SetHidden(false) else BSCASAlkoshUI:SetHidden(true) end
end

local function AddAlkoshSetting()	
	table.insert(optionsTable, {
        type = "header",
        name = GetString(SI_SYNERGY_NAME_ALKOSH),
    })
	-- UI
	table.insert(optionsTable, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_ALKOSHUI_AUTO),
		tooltip = GetString(SI_SYNERGY_ALKOSHUI_AUTO_DESC),
		getFunc = function() return BSCAS.SV.ALKOSH_CHECK_AUTO end,
		setFunc = function(value) 
			BSCAS.SV.ALKOSH_CHECK_AUTO = value
			BSCAS:CheckEquipment()
		end,
	})
	table.insert(optionsTable, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_ALKOSHUI),
		getFunc = function() return BSCAS.SV.ALKOSH_CHECK end,
		setFunc = function(value) 
			BSCAS.SV.ALKOSH_CHECK = value
			if value then
				BSCAS.AlkoshEnable()
			else
				BSCAS.AlkoshDisable()
			end
		end,
	})
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.ALKOSH_CHECK end,
		name = GetString(SI_SYNERGY_UI_LOCK),
		getFunc = function() return BSCAS.SV.ALKOSH_LOCK_UI end,
		setFunc = function(v) 
			BSCAS.SV.ALKOSH_LOCK_UI = v
			BSCASAlkoshUI:SetMovable(not BSCAS.SV.ALKOSH_LOCK_UI)
		end,
	})
	table.insert(optionsTable, {
		type = "slider",
		disabled = function() return not BSCAS.SV.ALKOSH_CHECK end,
		name = GetString(SI_SYNERGY_UI_WIDTH),
		tooltip = "",
		min = 100,
		max = 600,
		step = 1,
		default = 250,	
		getFunc = function() return BSCAS.SV.UI_WIDTH end,
		setFunc = function(value)
			BSCAS.SV.UI_WIDTH = value
			BSCAS.AlkoshUIChanges()
			BSCAS.AlkoshDummyList()
		end,
	})
	table.insert(optionsTable, {
		type = "slider",
		disabled = function() return not BSCAS.SV.ALKOSH_CHECK end,
		name = GetString(SI_SYNERGY_UI_HIGHT),
		tooltip = "",
		min = 20,
		max = 250,
		step = 1,
		default = 40,	
		getFunc = function() return BSCAS.SV.UI_HIGHT end,
		setFunc = function(value)
			BSCAS.SV.UI_HIGHT = value
			BSCAS.AlkoshUIChanges()
			BSCAS.AlkoshDummyList()
		end,
	})	
	
	table.insert(optionsTable, {
		type = "slider",
		disabled = function() return not BSCAS.SV.ALKOSH_CHECK end,
		name = GetString(SI_SYNERGY_UI_ALPHA),
		tooltip = "",
		min = 0.1,
		max = 1,
		step = 0.1,
		default = 1,	
		getFunc = function() return BSCAS.SV.UI_ALPHA end,
		setFunc = function(value)
			BSCAS.SV.UI_ALPHA = value
			BSCAS.AlkoshUIChanges()
			BSCAS.AlkoshDummyList()
		end,
	})	
	table.insert(optionsTable, {
		type = "slider",
		disabled = function() return not BSCAS.SV.ALKOSH_CHECK end,
		name = GetString(SI_SYNERGY_ALKOSH_LIST),
		tooltip = GetString(SI_SYNERGY_ALKOSH_COUNT),
		min = (MAX_BOSSES-1),
		max = 25,
		step = 1,
		default = 10,	
		getFunc = function() return BSCAS.SV.ALKOSH_LIST_COUNT end,
		setFunc = function(value)
			BSCAS.SV.ALKOSH_LIST_COUNT = value
			BSCAS.AlkoshUIChanges()
			BSCAS.AlkoshDummyList()
		end,
	})
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.ALKOSH_CHECK end,
		name = GetString(SI_SYNERGY_NAME_SOUND_ON_OFF),
		getFunc = function() return BSCAS.SV.ALKOSH_SOUND_PLAY end,
		setFunc = function(value) 
			BSCAS.SV.ALKOSH_SOUND_PLAY = value
			if BSCAS.SV.MSLAYER_SOUND_PLAY and value then BSCAS.SV.MSLAYER_SOUND_PLAY = false end
		end,
	})
	table.insert( optionsTable, { 
		type = "dropdown", 
		disabled = function() return not BSCAS.SV.ALKOSH_CHECK or not BSCAS.SV.ALKOSH_SOUND_PLAY end,
		name = GetString(SI_SYNERGY_NAME_SOUND_CHOOSE), 
		choices = s_choices,
		getFunc = function()
			for i = 1, #s_sounds do
				if s_sounds[i] == BSCAS.SV.ALKOSH_SOUND_ID then return s_choices[i] end
			end
			return "Voice_Chat_Alert_Channel_Made_Active"
		end,
		setFunc = function(value)
			for i = 1, #s_choices do
				if s_choices[i] == value then
					BSCAS.SV.ALKOSH_SOUND_ID = s_sounds[i]
					BSCAS.PlaySound(BSCAS.SV.ALKOSH_SOUND_LOOP, BSCAS.SV.ALKOSH_SOUND_ID)
					return
				end
			end
		end,
		scrollable = 12,
		default = "Voice_Chat_Alert_Channel_Made_Active",
	})	
	table.insert(optionsTable, {
		type = "slider",
		disabled = function() return not BSCAS.SV.ALKOSH_CHECK or not BSCAS.SV.ALKOSH_SOUND_PLAY end,
		name = GetString(SI_SYNERGY_SOUND_VOLL),
		min = 1,
		max = 10,
		step = 1,
		default = 1,	
		getFunc = function() return BSCAS.SV.ALKOSH_SOUND_LOOP end,
		setFunc = function(value)
			BSCAS.SV.ALKOSH_SOUND_LOOP = value
		end,
	})
	table.insert(optionsTable, {
		 type = "button",
		 disabled = function() return not BSCAS.SV.ALKOSH_CHECK or not BSCAS.SV.ALKOSH_SOUND_PLAY end,
		 name = GetString(SI_SYNERGY_SOUND_TEST),
		 func = function(value)
			  BSCAS.PlaySound(BSCAS.SV.ALKOSH_SOUND_LOOP, BSCAS.SV.ALKOSH_SOUND_ID)
		 end,
	})
	table.insert(optionsTable, {
		type = "slider",
		disabled = function() return not BSCAS.SV.ALKOSH_CHECK end,
		name = GetString(SI_SYNERGY_NAME_SOUND_TIME),
		min = 0,
		max = 4,
		step = 1,
		default = 1,	
		getFunc = function() return BSCAS.SV.ALKOSH_SOUND_INC end,
		setFunc = function(value)
			BSCAS.SV.ALKOSH_SOUND_INC = value
		end,
	})	
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.ALKOSH_CHECK end,
		name = GetString(SI_SYNERGY_UI_MARK)..GetString(SI_SYNERGY_UI_MARK_BOSS),
		tooltip = GetString(SI_SYNERGY_UI_MARK_DESC),
		getFunc = function() return BSCAS.SV.ALKOSH_ENABLE_MARK end,
		setFunc = function(value) 
			BSCAS.SV.ALKOSH_ENABLE_MARK = value
			BSCAS.AlkoshUIChanges()
			BSCAS.AlkoshDummyList()
		end,
	})
end

function BSCAS.InitAlkoshMenu()
	-- the panel for the addons menu
	local panelData = {
		type = "panel",
		name = BSCAS.NameMenu.."2. Alkosh UI",
		displayName = BSCAS.NameSpaced.." - Alkosh UI",
		author = BSCAS.Author,
		version = BSCAS.VersionDisplay,
		registerForRefresh = true,
		slashCommand = "/bscasa",
	}	
	
	for k, v in pairs(BSCAS.SOUNDLIST) do
		table.insert(s_choices, v)
		table.insert(s_sounds, k)
	end
	
	AddSendFeedBack()
	AddAlkoshSetting()
	
    local addonpanel = LibAddonMenu2:RegisterAddonPanel(BSCAS.NameSpaced.."Alkosh", panelData)
    LibAddonMenu2:RegisterOptionControls(BSCAS.NameSpaced.."Alkosh", optionsTable)
		
	CALLBACK_MANAGER:RegisterCallback("LAM-PanelOpened", function(currentpanel) if addonpanel == currentpanel then BSCAS.AlkoshDummyList() BSCASAlkoshUI:SetHidden(false) end end )
	CALLBACK_MANAGER:RegisterCallback("LAM-PanelClosed", function(currentpanel) if addonpanel == currentpanel then BSCAS.ClearDummyList() BSCASAlkoshUI:SetHidden(true) end end )
end