BSCASynergy = BSCASynergy or {}
local BSCAS = BSCASynergy

BSCAS.bDebugTab = false
--/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
-- Debug Tab stuff only
--/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
local chatTabName = 'DebugChat'
local function Colorize(text, color)
     local combineTable = { "|c", color, tostring(text), "|r" }
     return table.concat(combineTable)
end
function BSCAS:PrintToDebugTab(chatmsg)
	if not BSCAS.bDebugTab then return end
	BSCAS.ChatContainer:AddMessageToWindow(BSCAS.ChatWindow, Colorize("["..GetTimeString().."]", "A0A0A0")..Colorize(chatmsg, "FFFFFF"))
end
local function GetChatTab()
	for k, v in ipairs(CHAT_SYSTEM.containers) do
		for i = 1, #v.windows do
			if v:GetTabName(i) == chatTabName then
				return v, v.windows[i], i
			end
		end
	end
	local container = CHAT_SYSTEM.primaryContainer
	local window, key = container.windowPool:AcquireObject()
	window.key = key
	container:AddRawWindow(window, chatTabName)
	local tabIndex = window.tab.index
	container:SetInteractivity(tabIndex, true)
	container:SetLocked(tabIndex, true)
	container:SetTimestampsEnabled(tabIndex, true)
	for category = 1, GetNumChatCategories() do
		container:SetWindowFilterEnabled(tabIndex, category, false)
	end
	return container, window
end
function BSCAS:AddChatTab()
	if ZO_ChatWindowTabTemplate1 then		
		BSCAS.bDebugTab = true
		BSCAS.ChatContainer, BSCAS.ChatWindow = GetChatTab()
	else
		zo_callLater(function() BSCAS:AddChatTab() end, 200)
	end
end
function BSCAS:InitializeDebugChat()
	if ZO_ChatWindowTabTemplate1 then
		if GetUnitDisplayName('player') ~= '@BloodStainChild666' then 
			for k, v in ipairs(CHAT_SYSTEM.containers) do
				for i = 1, #v.windows do
					if v:GetTabName(i) == chatTabName then
						 v.RemoveWindow(i)
						 BSCAS.bDebugTab = false
					end
				end
			end 
		else
			BSCAS.bDebugTab = true
			BSCAS.ChatContainer, BSCAS.ChatWindow = GetChatTab()
		end
	else
		zo_callLater(function() BSCAS:InitializeDebugChat() end, 200)
	end
end