BSCASynergy = BSCASynergy or {}
local BSCAS = BSCASynergy

local debug_mode = false
function BSCAS.BlockDebugMode()
	if debug_mode then
		debug_mode = false
		BSCAS:PrintDebug("Debug Mode (Block Synergie) Disabled!")
	else
		debug_mode = true
		BSCAS:PrintDebug("Debug Mode (Block Synergie) Enabled!")
	end
end
local function PrintDebug(FormatedText)
	if debug_mode then
		BSCAS:PrintDebug(FormatedText)
	end
end

------------------------------------------------------------------------------
-- Basic stuff
------------------------------------------------------------------------------
local default_setting = 
{
	LOKKECHECK = false,
	ALKOSHCHECK = false,
	ONLYINCOMBAT = false,
	NEW_BARCHECK = -1,
	BERSERK_CHECK = false,
	-- Resource Settings
	RESOURCES_CHECK_SETS = false,
	RESOURCES_CHECK = false,
	RESOURCES_VALUE_S = 80,
	RESOURCES_VALUE_M = 80,

	-- UNDAUNTED
	UNDAUNTED_ALTAR = true,
	UNDAUNTED_WEBS = true,
	UNDAUNTED_FIRE = true,
	UNDAUNTED_BONE = true,
	UNDAUNTED_ORB = true,
	UNDAUNTED_ORB_HEALING = true,	
	
	UNDAUNTED_ALTAR_IGCHK = false,
	UNDAUNTED_WEBS_IGCHK = false,
	UNDAUNTED_FIRE_IGCHK = false,
	UNDAUNTED_BONE_IGCHK = false,
	UNDAUNTED_ORB_IGCHK = false,
	UNDAUNTED_ORB_HEALING_IGCHK = false,
	-- Templar
	TEMPLAR_SHARDS = true,
	TEMPLAR_SHARDS_DMG = true,	
	TEMPLAR_PURGE = true,
	TEMPLAR_NOVA = true,	
	
	TEMPLAR_SHARDS_IGCHK = false,	
	TEMPLAR_SHARDS_DMG_IGCHK = false,	
	TEMPLAR_PURGE_IGCHK = false,
	TEMPLAR_NOVA_IGCHK = false,
	-- Sorc
	SORC_ATRO = true,
	SORC_CONDUIT = true,	
	SORC_ATRO_IGCHK = false,
	SORC_CONDUIT_IGCHK = false,
	-- DK
	DK_IMPALE = true,
	DK_STANDARTE = true,	
	DK_IMPALE_IGCHK = false,
	DK_STANDARTE_IGCHK = false,
	-- NB
	NB_DARK = true,
	NB_SOUL = true,		
	NB_DARK_IGCHK = false,
	NB_SOUL_IGCHK = false,
	-- wardn
	WARDEN_HARVEST = true,	
	WARDEN_ICYESC = true,	
	WARDEN_HARVEST_IGCHK = false,
	WARDEN_ICYESC_IGCHK = false,
	-- Necro
	NECRO_BONEYARD = true,
	NECRO_TOTEM = true,	
	NECRO_BONEYARD_IGCHK = false,
	NECRO_TOTEM_IGCHK = false,
	-- Arcanist
	ARCANIST_RUNE  = true,
	ARCANIST_PORTAL = true,
	ARCANIST_RUNE_IGCHK = false,
	ARCANIST_PORTAL_IGCHK = false,
	-- WW
	WW_HUNT = true,	
	WW_HUNT_IGCHK = false,
	WW_DEVOUR = true,
	WW_DEVOUR_IGCHK = false,	
	-- Vamp
	VAMP_EAT = true,	
	VAMP_EAT_IGCHK = false,
	-- BH
	HOOD_BLADE = true,	
	HOOD_BLADE_IGCHK = false,
	
	-- Trail
	CR_PORTAL = true,
	CR_PORTAL_BLOCK_DB = false,
	HRC_CONFIRM = false,
	SS_PORTAL = true,
	KA_PORTAL = true,
	KA_EXECRATION = true,
	DSR_SURGING_WATERS = true,
	DSR_SURGING_WATERS_BLOCK_DB = false,
	DSR_SURGING_WATERS_CD = 20,
		
	CR_PORTAL_IGCHK = true,
	HRC_CONFIRM_IGCHK = true,
	SS_PORTAL_IGCHK = true,
	KA_PORTAL_IGCHK = true,
	KA_EXECRATION_IGCHK = true,	
	DSR_SURGING_WATERS_IGCHK = true,
	
	RG_PURGE_BLOCK = true,
	RG_PURGE_BLOCK_CD = 2000,
	RG_PURGE_BLOCK_ALERT = true,
	RG_PURGE_BLOCK_IGCHK = true,
	
	SE_VANTONS_CLARITY = true,
	SE_VANTONS_CLARITY_IGCHK = true,
	
	SE_ATTUNEMENT = true,
	SE_ATTUNEMENT_IGCHK = true,
	
	LC_MIRROR = true,
	LC_MIRROR_IGCHK = true,
	LC_MIRROR_BLOCK_DB = false,
	
	-- Arena
	ARENA_RESURRECTION = true,
	ARENA_DEFENSE = true,
	ARENA_HEALING = true,
	ARENA_SUSTAIN = true,
	ARENA_POWER = true,
	ARENA_HASTE = true,
	
	ARENA_RESURRECTION_IGCHK = true,
	ARENA_DEFENSE_IGCHK = true,
	ARENA_HEALING_IGCHK = true,
	ARENA_SUSTAIN_IGCHK = true,
	ARENA_POWER_IGCHK = true,
	ARENA_HASTE_IGCHK = true,
	
	-- item sets
	ITEM_URSUS = true,
	ITEM_KRAGLEN = true,
	ITEM_SANGUINE = true,
	ITEM_GPREPRISAL = true,
	
	ITEM_URSUS_IGCHK = true,
	ITEM_KRAGLEN_IGCHK = true,
	ITEM_SANGUINE_IGCHK = true,
	ITEM_GPREPRISAL_IGCHK = true,	
}
------------------------------------------------------------------------------
-- Checking functions 
------------------------------------------------------------------------------
local CHECK_RESOURCES = false
local function isLowStamina()	
	local s_cur, s_max_nor, s_max_boost = GetUnitPower("player", POWERTYPE_STAMINA)
	local perc = 100
	perc = s_cur/s_max_nor * 100
	if perc <= BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].RESOURCES_VALUE_S then return true end
end
local function isLowMagica()
	local m_cur, m_max_nor, m_max_boost = GetUnitPower("player", POWERTYPE_MAGICKA)
	local perc = 100
	perc = m_cur/m_max_nor * 100
	if perc <= BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].RESOURCES_VALUE_M then return true end
end
local function lokkeCheck()	
	if not BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].LOKKECHECK then return true end	
	local PLokke, NLokke = 0
	_,_,_,PLokke = GetItemLinkSetInfo(BSCAS.LOKKE_ITEM[1], true)
	_,_,_,NLokke = GetItemLinkSetInfo(BSCAS.LOKKE_ITEM[2], true)		
	PrintDebug(zo_strformat("Wearing Set info (Normal)[<<1>>] (Perfekt)[<<2>>]", NLokke, PLokke)) -- Debug check
	if (NLokke == 0) and (PLokke == 0) then return true end		-- if No lokke equiped and check is still on	
	if (NLokke >= 1 and NLokke <= 2) or (PLokke >= 1 and PLokke <= 2) then 
		ZO_Alert(UI_ALERT_CATEGORY_ERROR, SOUNDS.NEGATIVE_CLICK, "Check your Lokke gear setup!!!") -- check if only one or 2 equpid and send warning!
	end
	if (NLokke >= 5) then return true end	
	if (PLokke >= 5) then return true end	
	return false
end
local function HasAlkosh()
	if not BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ALKOSHCHECK then return true end
	if BSCAS.AlkoshBuffActive then return false end	
	local alkosh = 0
	_,_,_,alkosh = GetItemLinkSetInfo(BSCAS.ALKOSH_ITEM, true)
	PrintDebug(zo_strformat("Wearing Set info [<<1>>]", alkosh))	
	if (alkosh == 0) then return true end	
	if (alkosh >= 1 and alkosh <= 2) then
		ZO_Alert(UI_ALERT_CATEGORY_ERROR, SOUNDS.NEGATIVE_CLICK, "Check your Alkosh gear setup!!!")
	end	
	if (alkosh >= 5) then return true end	
	return false
end
function BSCAS:CheckEquipment()
	local setItemCount_B = 0
	local setItemCount_C = 0
	local setItemCount_MK = 0
	local setItemCount_Alkosh = 0
	local setItemCount_Pearls = 0
	for equipSlot = EQUIP_SLOT_ITERATION_BEGIN, EQUIP_SLOT_ITERATION_END do		
		if HasItemInSlot(BAG_WORN, equipSlot) then		
			local itemtype = GetItemType(BAG_WORN, equipSlot)			
			if itemtype == ITEMTYPE_ARMOR or itemtype == ITEMTYPE_WEAPON then
				local count = 1
				if itemtype == ITEMTYPE_WEAPON then 
					if select(6, GetItemInfo(BAG_WORN, equipSlot)) == EQUIP_TYPE_TWO_HAND then
						count = 2 
					end
				end	
				local setId = select(6, GetItemLinkSetInfo(GetItemLink(BAG_WORN, equipSlot)))
				--
				if setId == BSCAS.B_SETID_N or setId == BSCAS.B_SETID_P then
					setItemCount_B = setItemCount_B + count
				end	
				--
				if setId == BSCAS.C_SETID_N or setId == BSCAS.C_SETID_P then
					setItemCount_C = setItemCount_C + count
				end	
				--
				if setId == BSCAS.MAKNO then
					setItemCount_MK = setItemCount_MK + count
				end	
				-- Alkosh
				if setId == BSCAS.ALKOSH_ITEM_SETID then
					setItemCount_Alkosh = setItemCount_Alkosh + count					
				end
				-- pearls mythic
				if setId == BSCAS.PEARLSOE then
					setItemCount_Pearls = setItemCount_Pearls + count	
				end
			end
		end
	end	
	-- Auto Enable Alkosh UI
	if setItemCount_Alkosh >= 5 then
		if BSCAS.SV.ALKOSH_CHECK_AUTO and not BSCAS.SV.ALKOSH_CHECK then
			BSCAS.SV.ALKOSH_CHECK = true
			BSCAS.AlkoshEnable()
		end
	else
		if BSCAS.SV.ALKOSH_CHECK_AUTO and BSCAS.SV.ALKOSH_CHECK then
			BSCAS.SV.ALKOSH_CHECK = false
			BSCAS.AlkoshDisable()
		end
	end
	-- Item set for resource check	
	if not BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].RESOURCES_CHECK_SETS then 
		CHECK_RESOURCES = false 
		return
	end	
	if setItemCount_B >= 5 then
		CHECK_RESOURCES = true	
	elseif setItemCount_C >= 5 then
		CHECK_RESOURCES = true
	elseif setItemCount_MK >= 5 then
		CHECK_RESOURCES = true
	elseif setItemCount_Pearls >= 1 then
		CHECK_RESOURCES = true
	else 
		CHECK_RESOURCES = false
	end		
end
------------------------------------------------------------------------------
-- Check Synergies
------------------------------------------------------------------------------
local function CheckPresets()
	for name, v in pairs(BSCAS.SV_acc.SETTING) do	
		if BSCAS.SV_acc.SETTING[name] == nil then BSCAS.SV_acc.SETTING[name] = default_setting end				
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		-- Resource Settings
		if BSCAS.SV_acc.SETTING[name].LOKKECHECK == nil then BSCAS.SV_acc.SETTING[name].LOKKECHECK = false end
		if BSCAS.SV_acc.SETTING[name].ALKOSHCHECK == nil then BSCAS.SV_acc.SETTING[name].ALKOSHCHECK = false end
		if BSCAS.SV_acc.SETTING[name].ONLYINCOMBAT == nil then BSCAS.SV_acc.SETTING[name].ONLYINCOMBAT = false end
		if BSCAS.SV_acc.SETTING[name].NEW_BARCHECK == nil then BSCAS.SV_acc.SETTING[name].NEW_BARCHECK = -1 end
		if BSCAS.SV_acc.SETTING[name].BERSERK_CHECK == nil then BSCAS.SV_acc.SETTING[name].BERSERK_CHECK = false end

		if BSCAS.SV_acc.SETTING[name].RESOURCES_CHECK_SETS == nil then BSCAS.SV_acc.SETTING[name].RESOURCES_CHECK_SETS = false end
		if BSCAS.SV_acc.SETTING[name].RESOURCES_CHECK == nil then BSCAS.SV_acc.SETTING[name].RESOURCES_CHECK = false end
		if BSCAS.SV_acc.SETTING[name].RESOURCES_VALUE_S == nil then BSCAS.SV_acc.SETTING[name].RESOURCES_VALUE_S = 80 end
		if BSCAS.SV_acc.SETTING[name].RESOURCES_VALUE_M == nil then BSCAS.SV_acc.SETTING[name].RESOURCES_VALUE_M = 80 end
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		-- UNDAUNTED
		if BSCAS.SV_acc.SETTING[name].UNDAUNTED_ALTAR == nil then BSCAS.SV_acc.SETTING[name].UNDAUNTED_ALTAR = true end				-- UNDAUNTED
		if BSCAS.SV_acc.SETTING[name].UNDAUNTED_WEBS == nil then BSCAS.SV_acc.SETTING[name].UNDAUNTED_WEBS = true end				-- UNDAUNTED
		if BSCAS.SV_acc.SETTING[name].UNDAUNTED_FIRE == nil then BSCAS.SV_acc.SETTING[name].UNDAUNTED_FIRE = true end				-- UNDAUNTED
		if BSCAS.SV_acc.SETTING[name].UNDAUNTED_BONE == nil then BSCAS.SV_acc.SETTING[name].UNDAUNTED_BONE = true end				-- UNDAUNTED
		if BSCAS.SV_acc.SETTING[name].UNDAUNTED_ORB == nil then BSCAS.SV_acc.SETTING[name].UNDAUNTED_ORB = true end					-- UNDAUNTED
		if BSCAS.SV_acc.SETTING[name].UNDAUNTED_ORB_HEALING == nil then BSCAS.SV_acc.SETTING[name].UNDAUNTED_ORB_HEALING = true end	-- UNDAUNTED		
		--
		if BSCAS.SV_acc.SETTING[name].UNDAUNTED_ALTAR_IGCHK == nil then BSCAS.SV_acc.SETTING[name].UNDAUNTED_ALTAR_IGCHK = false end				-- UNDAUNTED
		if BSCAS.SV_acc.SETTING[name].UNDAUNTED_WEBS_IGCHK == nil then BSCAS.SV_acc.SETTING[name].UNDAUNTED_WEBS_IGCHK = false end					-- UNDAUNTED
		if BSCAS.SV_acc.SETTING[name].UNDAUNTED_FIRE_IGCHK == nil then BSCAS.SV_acc.SETTING[name].UNDAUNTED_FIRE_IGCHK = false end					-- UNDAUNTED
		if BSCAS.SV_acc.SETTING[name].UNDAUNTED_BONE_IGCHK == nil then BSCAS.SV_acc.SETTING[name].UNDAUNTED_BONE_IGCHK = false end					-- UNDAUNTED
		if BSCAS.SV_acc.SETTING[name].UNDAUNTED_ORB_IGCHK == nil then BSCAS.SV_acc.SETTING[name].UNDAUNTED_ORB_IGCHK = false end					-- UNDAUNTED
		if BSCAS.SV_acc.SETTING[name].UNDAUNTED_ORB_HEALING_IGCHK == nil then BSCAS.SV_acc.SETTING[name].UNDAUNTED_ORB_HEALING_IGCHK = false end	-- UNDAUNTED		
		--
		if BSCAS.SV_acc.SETTING[name].UNDAUNTED_ALTAR_HBCHK == nil then BSCAS.SV_acc.SETTING[name].UNDAUNTED_ALTAR_HBCHK = -1 end				-- UNDAUNTED
		if BSCAS.SV_acc.SETTING[name].UNDAUNTED_WEBS_HBCHK == nil then BSCAS.SV_acc.SETTING[name].UNDAUNTED_WEBS_HBCHK = -1 end					-- UNDAUNTED
		if BSCAS.SV_acc.SETTING[name].UNDAUNTED_FIRE_HBCHK == nil then BSCAS.SV_acc.SETTING[name].UNDAUNTED_FIRE_HBCHK = -1 end					-- UNDAUNTED
		if BSCAS.SV_acc.SETTING[name].UNDAUNTED_BONE_HBCHK == nil then BSCAS.SV_acc.SETTING[name].UNDAUNTED_BONE_HBCHK = -1 end					-- UNDAUNTED
		if BSCAS.SV_acc.SETTING[name].UNDAUNTED_ORB_HBCHK == nil then BSCAS.SV_acc.SETTING[name].UNDAUNTED_ORB_HBCHK = -1 end					-- UNDAUNTED
		if BSCAS.SV_acc.SETTING[name].UNDAUNTED_ORB_HEALING_HBCHK == nil then BSCAS.SV_acc.SETTING[name].UNDAUNTED_ORB_HEALING_HBCHK = -1 end	-- UNDAUNTED		
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		-- TEMPLAR
		if BSCAS.SV_acc.SETTING[name].TEMPLAR_SHARDS == nil then BSCAS.SV_acc.SETTING[name].TEMPLAR_SHARDS = true end			-- Templar
		if BSCAS.SV_acc.SETTING[name].TEMPLAR_SHARDS_DMG == nil then BSCAS.SV_acc.SETTING[name].TEMPLAR_SHARDS_DMG = true end	-- Templar
		if BSCAS.SV_acc.SETTING[name].TEMPLAR_PURGE == nil then BSCAS.SV_acc.SETTING[name].TEMPLAR_PURGE = true end				-- Templar
		if BSCAS.SV_acc.SETTING[name].TEMPLAR_NOVA == nil then BSCAS.SV_acc.SETTING[name].TEMPLAR_NOVA = true end				-- Templar		
		--
		if BSCAS.SV_acc.SETTING[name].TEMPLAR_SHARDS_IGCHK == nil then BSCAS.SV_acc.SETTING[name].TEMPLAR_SHARDS_IGCHK = false end			-- Templar
		if BSCAS.SV_acc.SETTING[name].TEMPLAR_SHARDS_DMG_IGCHK == nil then BSCAS.SV_acc.SETTING[name].TEMPLAR_SHARDS_DMG_IGCHK = false end	-- Templar
		if BSCAS.SV_acc.SETTING[name].TEMPLAR_PURGE_IGCHK == nil then BSCAS.SV_acc.SETTING[name].TEMPLAR_PURGE_IGCHK = false end			-- Templar
		if BSCAS.SV_acc.SETTING[name].TEMPLAR_NOVA_IGCHK == nil then BSCAS.SV_acc.SETTING[name].TEMPLAR_NOVA_IGCHK = false end				-- Templar	
		--
		if BSCAS.SV_acc.SETTING[name].TEMPLAR_SHARDS_HBCHK == nil then BSCAS.SV_acc.SETTING[name].TEMPLAR_SHARDS_HBCHK = -1 end			-- Templar
		if BSCAS.SV_acc.SETTING[name].TEMPLAR_SHARDS_DMG_HBCHK == nil then BSCAS.SV_acc.SETTING[name].TEMPLAR_SHARDS_DMG_HBCHK = -1 end	-- Templar
		if BSCAS.SV_acc.SETTING[name].TEMPLAR_PURGE_HBCHK == nil then BSCAS.SV_acc.SETTING[name].TEMPLAR_PURGE_HBCHK = -1 end			-- Templar
		if BSCAS.SV_acc.SETTING[name].TEMPLAR_NOVA_HBCHK == nil then BSCAS.SV_acc.SETTING[name].TEMPLAR_NOVA_HBCHK = -1 end				-- Templar
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		-- Sorc
		if BSCAS.SV_acc.SETTING[name].SORC_ATRO == nil then BSCAS.SV_acc.SETTING[name].SORC_ATRO = true end				-- Sorc
		if BSCAS.SV_acc.SETTING[name].SORC_CONDUIT == nil then BSCAS.SV_acc.SETTING[name].SORC_CONDUIT = true end		-- Sorc			
		--
		if BSCAS.SV_acc.SETTING[name].SORC_ATRO_IGCHK == nil then BSCAS.SV_acc.SETTING[name].SORC_ATRO_IGCHK = false end		-- Sorc
		if BSCAS.SV_acc.SETTING[name].SORC_CONDUIT_IGCHK == nil then BSCAS.SV_acc.SETTING[name].SORC_CONDUIT_IGCHK = false end	-- Sorc	
		--
		if BSCAS.SV_acc.SETTING[name].SORC_ATRO_HBCHK == nil then BSCAS.SV_acc.SETTING[name].SORC_ATRO_HBCHK = -1 end		-- Sorc
		if BSCAS.SV_acc.SETTING[name].SORC_CONDUIT_HBCHK == nil then BSCAS.SV_acc.SETTING[name].SORC_CONDUIT_HBCHK = -1 end	-- Sorc	
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		-- DK
		if BSCAS.SV_acc.SETTING[name].DK_IMPALE == nil then BSCAS.SV_acc.SETTING[name].DK_IMPALE = true end				-- DK
		if BSCAS.SV_acc.SETTING[name].DK_STANDARTE == nil then BSCAS.SV_acc.SETTING[name].DK_STANDARTE = true end		-- DK
		--
		if BSCAS.SV_acc.SETTING[name].DK_IMPALE_IGCHK == nil then BSCAS.SV_acc.SETTING[name].DK_IMPALE_IGCHK = false end		-- DK
		if BSCAS.SV_acc.SETTING[name].DK_STANDARTE_IGCHK == nil then BSCAS.SV_acc.SETTING[name].DK_STANDARTE_IGCHK = false end	-- DK
		--
		if BSCAS.SV_acc.SETTING[name].DK_IMPALE_HBCHK == nil then BSCAS.SV_acc.SETTING[name].DK_IMPALE_HBCHK = -1 end		-- DK
		if BSCAS.SV_acc.SETTING[name].DK_STANDARTE_HBCHK == nil then BSCAS.SV_acc.SETTING[name].DK_STANDARTE_HBCHK = -1 end	-- DK
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
		-- NB
		if BSCAS.SV_acc.SETTING[name].NB_DARK == nil then BSCAS.SV_acc.SETTING[name].NB_DARK = true end					-- NB
		if BSCAS.SV_acc.SETTING[name].NB_SOUL == nil then BSCAS.SV_acc.SETTING[name].NB_SOUL = true end					-- NB
		
		if BSCAS.SV_acc.SETTING[name].NB_DARK_IGCHK == nil then BSCAS.SV_acc.SETTING[name].NB_DARK_IGCHK = false end	-- NB
		if BSCAS.SV_acc.SETTING[name].NB_SOUL_IGCHK == nil then BSCAS.SV_acc.SETTING[name].NB_SOUL_IGCHK = false end	-- NB	
		
		if BSCAS.SV_acc.SETTING[name].NB_DARK_HBCHK == nil then BSCAS.SV_acc.SETTING[name].NB_DARK_HBCHK = -1 end	-- NB
		if BSCAS.SV_acc.SETTING[name].NB_SOUL_HBCHK == nil then BSCAS.SV_acc.SETTING[name].NB_SOUL_HBCHK = -1 end	-- NB	
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------			
		-- Wardn
		if BSCAS.SV_acc.SETTING[name].WARDEN_HARVEST == nil then BSCAS.SV_acc.SETTING[name].WARDEN_HARVEST = true end	-- wardn
		if BSCAS.SV_acc.SETTING[name].WARDEN_ICYESC == nil then BSCAS.SV_acc.SETTING[name].WARDEN_ICYESC = true end		-- wardn	
		
		if BSCAS.SV_acc.SETTING[name].WARDEN_HARVEST_IGCHK == nil then BSCAS.SV_acc.SETTING[name].WARDEN_HARVEST_IGCHK = false end	-- wardn
		if BSCAS.SV_acc.SETTING[name].WARDEN_ICYESC_IGCHK == nil then BSCAS.SV_acc.SETTING[name].WARDEN_ICYESC_IGCHK = false end		-- wardn	
		
		if BSCAS.SV_acc.SETTING[name].WARDEN_HARVEST_HBCHK == nil then BSCAS.SV_acc.SETTING[name].WARDEN_HARVEST_HBCHK = -1 end	-- wardn
		if BSCAS.SV_acc.SETTING[name].WARDEN_ICYESC_HBCHK == nil then BSCAS.SV_acc.SETTING[name].WARDEN_ICYESC_HBCHK = -1 end		-- wardn
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		-- Necro
		if BSCAS.SV_acc.SETTING[name].NECRO_BONEYARD == nil then BSCAS.SV_acc.SETTING[name].NECRO_BONEYARD = true end 	-- Necro
		if BSCAS.SV_acc.SETTING[name].NECRO_TOTEM == nil then BSCAS.SV_acc.SETTING[name].NECRO_TOTEM = true end	  		-- Necro
		
		if BSCAS.SV_acc.SETTING[name].NECRO_BONEYARD_IGCHK == nil then BSCAS.SV_acc.SETTING[name].NECRO_BONEYARD_IGCHK = false end 	-- Necro
		if BSCAS.SV_acc.SETTING[name].NECRO_TOTEM_IGCHK == nil then BSCAS.SV_acc.SETTING[name].NECRO_TOTEM_IGCHK = false end	  	-- Necro
		
		if BSCAS.SV_acc.SETTING[name].NECRO_BONEYARD_HBCHK == nil then BSCAS.SV_acc.SETTING[name].NECRO_BONEYARD_HBCHK = -1 end 	-- Necro
		if BSCAS.SV_acc.SETTING[name].NECRO_TOTEM_HBCHK == nil then BSCAS.SV_acc.SETTING[name].NECRO_TOTEM_HBCHK = -1 end	  		-- Necro
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
		-- Arcanist
		if BSCAS.SV_acc.SETTING[name].ARCANIST_RUNE == nil then BSCAS.SV_acc.SETTING[name].ARCANIST_RUNE = true end 		-- Arcanist
		if BSCAS.SV_acc.SETTING[name].ARCANIST_PORTAL == nil then BSCAS.SV_acc.SETTING[name].ARCANIST_PORTAL = true end	  	-- Arcanist

		if BSCAS.SV_acc.SETTING[name].ARCANIST_RUNE_IGCHK == nil then BSCAS.SV_acc.SETTING[name].ARCANIST_RUNE_IGCHK = false end 	 -- Arcanist
		if BSCAS.SV_acc.SETTING[name].ARCANIST_PORTAL_IGCHK == nil then BSCAS.SV_acc.SETTING[name].ARCANIST_PORTAL_IGCHK = false end -- Arcanist

		if BSCAS.SV_acc.SETTING[name].ARCANIST_RUNE_HBCHK == nil then BSCAS.SV_acc.SETTING[name].ARCANIST_RUNE_HBCHK = -1 end 		-- Arcanist
		if BSCAS.SV_acc.SETTING[name].ARCANIST_PORTAL_HBCHK == nil then BSCAS.SV_acc.SETTING[name].ARCANIST_PORTAL_HBCHK = -1 end	-- Arcanist
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		-- WW
		if BSCAS.SV_acc.SETTING[name].WW_HUNT == nil then BSCAS.SV_acc.SETTING[name].WW_HUNT = true end					-- WW		
		if BSCAS.SV_acc.SETTING[name].WW_HUNT_IGCHK == nil then BSCAS.SV_acc.SETTING[name].WW_HUNT_IGCHK = false end	-- WW		
		if BSCAS.SV_acc.SETTING[name].WW_HUNT_HBCHK == nil then BSCAS.SV_acc.SETTING[name].WW_HUNT_HBCHK = -1 end		-- WW	
		
		if BSCAS.SV_acc.SETTING[name].WW_DEVOUR == nil then BSCAS.SV_acc.SETTING[name].WW_DEVOUR = true end					-- WW		
		if BSCAS.SV_acc.SETTING[name].WW_DEVOUR_IGCHK == nil then BSCAS.SV_acc.SETTING[name].WW_DEVOUR_IGCHK = false end	-- WW		
		if BSCAS.SV_acc.SETTING[name].WW_DEVOUR_HBCHK == nil then BSCAS.SV_acc.SETTING[name].WW_DEVOUR_HBCHK = -1 end		-- WW	
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------	
		-- Vamp
		if BSCAS.SV_acc.SETTING[name].VAMP_EAT == nil then BSCAS.SV_acc.SETTING[name].VAMP_EAT = true end				-- Vamp		
		if BSCAS.SV_acc.SETTING[name].VAMP_EAT_IGCHK == nil then BSCAS.SV_acc.SETTING[name].VAMP_EAT_IGCHK = true end	-- Vamp	
		if BSCAS.SV_acc.SETTING[name].VAMP_EAT_HBCHK == nil then BSCAS.SV_acc.SETTING[name].VAMP_EAT_HBCHK = -1 end		-- Vamp	
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------	
		-- BH
		if BSCAS.SV_acc.SETTING[name].HOOD_BLADE == nil then BSCAS.SV_acc.SETTING[name].HOOD_BLADE = true end 						-- BH		
		if BSCAS.SV_acc.SETTING[name].HOOD_BLADE_IGCHK == nil then BSCAS.SV_acc.SETTING[name].HOOD_BLADE_IGCHK = true end 			-- BH	
		if BSCAS.SV_acc.SETTING[name].HOOD_BLADE_HBCHK == nil then BSCAS.SV_acc.SETTING[name].HOOD_BLADE_HBCHK = -1 end 			-- BH
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		-- Trails
		if BSCAS.SV_acc.SETTING[name].CR_PORTAL == nil then BSCAS.SV_acc.SETTING[name].CR_PORTAL = true end							-- Trail
		if BSCAS.SV_acc.SETTING[name].CR_PORTAL_IGCHK == nil then BSCAS.SV_acc.SETTING[name].CR_PORTAL_IGCHK = true end				-- Trail
		if BSCAS.SV_acc.SETTING[name].CR_PORTAL_HBCHK == nil then BSCAS.SV_acc.SETTING[name].CR_PORTAL_HBCHK = -1 end				-- Trail
		if BSCAS.SV_acc.SETTING[name].CR_PORTAL_BLOCK_DB == nil then BSCAS.SV_acc.SETTING[name].CR_PORTAL_BLOCK_DB = false end		-- Trail
		
		if BSCAS.SV_acc.SETTING[name].HRC_CONFIRM == nil then BSCAS.SV_acc.SETTING[name].HRC_CONFIRM = false end 				-- Trail		
		if BSCAS.SV_acc.SETTING[name].SS_PORTAL == nil then BSCAS.SV_acc.SETTING[name].SS_PORTAL = true end 					-- Trail
		if BSCAS.SV_acc.SETTING[name].SS_PORTAL_IGCHK == nil then BSCAS.SV_acc.SETTING[name].SS_PORTAL_IGCHK = true end 		-- Trail	
		if BSCAS.SV_acc.SETTING[name].SS_PORTAL_HBCHK == nil then BSCAS.SV_acc.SETTING[name].SS_PORTAL_HBCHK = -1 end 			-- Trail
		
		if BSCAS.SV_acc.SETTING[name].KA_PORTAL == nil then BSCAS.SV_acc.SETTING[name].KA_PORTAL = true end 					-- Trail
		if BSCAS.SV_acc.SETTING[name].KA_PORTAL_IGCHK == nil then BSCAS.SV_acc.SETTING[name].KA_PORTAL_IGCHK = true end 		-- Trail
		if BSCAS.SV_acc.SETTING[name].KA_PORTAL_HBCHK == nil then BSCAS.SV_acc.SETTING[name].KA_PORTAL_HBCHK = -1 end 			-- Trail
		
		if BSCAS.SV_acc.SETTING[name].KA_EXECRATION == nil then BSCAS.SV_acc.SETTING[name].KA_EXECRATION = true end 			-- Trail	
		if BSCAS.SV_acc.SETTING[name].KA_EXECRATION_IGCHK == nil then BSCAS.SV_acc.SETTING[name].KA_EXECRATION_IGCHK = true end -- Trail
		if BSCAS.SV_acc.SETTING[name].KA_EXECRATION_HBCHK == nil then BSCAS.SV_acc.SETTING[name].KA_EXECRATION_HBCHK = -1 end 	-- Trail
		
		if BSCAS.SV_acc.SETTING[name].DSR_SURGING_WATERS == nil then BSCAS.SV_acc.SETTING[name].DSR_SURGING_WATERS = true end 	-- Trail	
		if BSCAS.SV_acc.SETTING[name].DSR_SURGING_WATERS_IGCHK == nil then BSCAS.SV_acc.SETTING[name].DSR_SURGING_WATERS_IGCHK = true end 	-- Trail
		if BSCAS.SV_acc.SETTING[name].DSR_SURGING_WATERS_HBCHK == nil then BSCAS.SV_acc.SETTING[name].DSR_SURGING_WATERS_HBCHK = -1 end 	-- Trail
		if BSCAS.SV_acc.SETTING[name].DSR_SURGING_WATERS_BLOCK_DB == nil then BSCAS.SV_acc.SETTING[name].DSR_SURGING_WATERS_BLOCK_DB = false end				-- Trail	
		if BSCAS.SV_acc.SETTING[name].DSR_SURGING_WATERS_CD == nil then BSCAS.SV_acc.SETTING[name].DSR_SURGING_WATERS_CD = 20 end
		
		if BSCAS.SV_acc.SETTING[name].RG_PURGE_BLOCK == nil then BSCAS.SV_acc.SETTING[name].RG_PURGE_BLOCK = true end 				-- Trail	
		if BSCAS.SV_acc.SETTING[name].RG_PURGE_BLOCK_IGCHK == nil then BSCAS.SV_acc.SETTING[name].RG_PURGE_BLOCK_IGCHK = true end 	-- Trail
		if BSCAS.SV_acc.SETTING[name].RG_PURGE_BLOCK_HBCHK == nil then BSCAS.SV_acc.SETTING[name].RG_PURGE_BLOCK_HBCHK = -1 end 	-- Trail	
		if BSCAS.SV_acc.SETTING[name].RG_PURGE_BLOCK_CD == nil then BSCAS.SV_acc.SETTING[name].RG_PURGE_BLOCK_CD = 2000 end			-- Trail	
		if BSCAS.SV_acc.SETTING[name].RG_PURGE_BLOCK_ALERT == nil then 	BSCAS.SV_acc.SETTING[name].RG_PURGE_BLOCK_ALERT = true end
		
		if BSCAS.SV_acc.SETTING[name].SE_VANTONS_CLARITY == nil then BSCAS.SV_acc.SETTING[name].SE_VANTONS_CLARITY = true end 				-- Trail		
		if BSCAS.SV_acc.SETTING[name].SE_VANTONS_CLARITY_IGCHK == nil then BSCAS.SV_acc.SETTING[name].SE_VANTONS_CLARITY_IGCHK = true end 	-- Trail
		if BSCAS.SV_acc.SETTING[name].SE_VANTONS_CLARITY_HBCHK == nil then BSCAS.SV_acc.SETTING[name].SE_VANTONS_CLARITY_HBCHK = true end 	-- Trail
		
		if BSCAS.SV_acc.SETTING[name].SE_ATTUNEMENT == nil then BSCAS.SV_acc.SETTING[name].SE_ATTUNEMENT = true end 				-- Trail		
		if BSCAS.SV_acc.SETTING[name].SE_ATTUNEMENT_IGCHK == nil then BSCAS.SV_acc.SETTING[name].SE_ATTUNEMENT_IGCHK = true end 	-- Trail
		if BSCAS.SV_acc.SETTING[name].SE_ATTUNEMENT_HBCHK == nil then BSCAS.SV_acc.SETTING[name].SE_ATTUNEMENT_HBCHK = true end 	-- Trail
		
		if BSCAS.SV_acc.SETTING[name].LC_MIRROR == nil then BSCAS.SV_acc.SETTING[name].LC_MIRROR = true end 				-- Trail		
		if BSCAS.SV_acc.SETTING[name].LC_MIRROR_IGCHK == nil then BSCAS.SV_acc.SETTING[name].LC_MIRROR_IGCHK = true end 	-- Trail
		if BSCAS.SV_acc.SETTING[name].LC_MIRROR_HBCHK == nil then BSCAS.SV_acc.SETTING[name].LC_MIRROR_HBCHK = true end 	-- Trail	
		if BSCAS.SV_acc.SETTING[name].LC_MIRROR_BLOCK_DB == nil then BSCAS.SV_acc.SETTING[name].LC_MIRROR_BLOCK_DB = false end 	-- Trail	
		
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		-- Arena
		if BSCAS.SV_acc.SETTING[name].ARENA_RESURRECTION == nil then BSCAS.SV_acc.SETTING[name].ARENA_RESURRECTION = true end	-- Arena		
		if BSCAS.SV_acc.SETTING[name].ARENA_DEFENSE == nil then BSCAS.SV_acc.SETTING[name].ARENA_DEFENSE = true end				-- Arena		
		if BSCAS.SV_acc.SETTING[name].ARENA_HEALING == nil then BSCAS.SV_acc.SETTING[name].ARENA_HEALING = true end				-- Arena		
		if BSCAS.SV_acc.SETTING[name].ARENA_SUSTAIN == nil then BSCAS.SV_acc.SETTING[name].ARENA_SUSTAIN = true end				-- Arena		
		if BSCAS.SV_acc.SETTING[name].ARENA_POWER == nil then BSCAS.SV_acc.SETTING[name].ARENA_POWER = true end					-- Arena		
		if BSCAS.SV_acc.SETTING[name].ARENA_HASTE == nil then BSCAS.SV_acc.SETTING[name].ARENA_HASTE = true end					-- Arena

		if BSCAS.SV_acc.SETTING[name].ARENA_RESURRECTION_IGCHK == nil then BSCAS.SV_acc.SETTING[name].ARENA_RESURRECTION_IGCHK = true end	-- Arena
		if BSCAS.SV_acc.SETTING[name].ARENA_DEFENSE_IGCHK == nil then BSCAS.SV_acc.SETTING[name].ARENA_DEFENSE_IGCHK = true end				-- Arena
		if BSCAS.SV_acc.SETTING[name].ARENA_HEALING_IGCHK == nil then BSCAS.SV_acc.SETTING[name].ARENA_HEALING_IGCHK = true end				-- Arena
		if BSCAS.SV_acc.SETTING[name].ARENA_SUSTAIN_IGCHK == nil then BSCAS.SV_acc.SETTING[name].ARENA_SUSTAIN_IGCHK = true end				-- Arena
		if BSCAS.SV_acc.SETTING[name].ARENA_POWER_IGCHK == nil then BSCAS.SV_acc.SETTING[name].ARENA_POWER_IGCHK = true end					-- Arena
		if BSCAS.SV_acc.SETTING[name].ARENA_HASTE_IGCHK == nil then BSCAS.SV_acc.SETTING[name].ARENA_HASTE_IGCHK = true end					-- Arena
		
		if BSCAS.SV_acc.SETTING[name].ARENA_RESURRECTION_HBCHK == nil then BSCAS.SV_acc.SETTING[name].ARENA_RESURRECTION_HBCHK = -1 end	-- Arena
		if BSCAS.SV_acc.SETTING[name].ARENA_DEFENSE_HBCHK == nil then BSCAS.SV_acc.SETTING[name].ARENA_DEFENSE_HBCHK = -1 end				-- Arena
		if BSCAS.SV_acc.SETTING[name].ARENA_HEALING_HBCHK == nil then BSCAS.SV_acc.SETTING[name].ARENA_HEALING_HBCHK = -1 end				-- Arena
		if BSCAS.SV_acc.SETTING[name].ARENA_SUSTAIN_HBCHK == nil then BSCAS.SV_acc.SETTING[name].ARENA_SUSTAIN_HBCHK = -1 end				-- Arena
		if BSCAS.SV_acc.SETTING[name].ARENA_POWER_HBCHK == nil then BSCAS.SV_acc.SETTING[name].ARENA_POWER_HBCHK = -1 end					-- Arena
		if BSCAS.SV_acc.SETTING[name].ARENA_HASTE_HBCHK == nil then BSCAS.SV_acc.SETTING[name].ARENA_HASTE_HBCHK = -1 end					-- Arena
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		-- Items
		if BSCAS.SV_acc.SETTING[name].ITEM_URSUS == nil then BSCAS.SV_acc.SETTING[name].ITEM_URSUS = true end				-- Item
		if BSCAS.SV_acc.SETTING[name].ITEM_URSUS_IGCHK == nil then BSCAS.SV_acc.SETTING[name].ITEM_URSUS_IGCHK = true end				-- Item
		if BSCAS.SV_acc.SETTING[name].ITEM_URSUS_HBCHK == nil then BSCAS.SV_acc.SETTING[name].ITEM_URSUS_HBCHK = -1 end				-- Item
		if BSCAS.SV_acc.SETTING[name].ITEM_KRAGLEN == nil then BSCAS.SV_acc.SETTING[name].ITEM_KRAGLEN = true end			-- Item
		if BSCAS.SV_acc.SETTING[name].ITEM_KRAGLEN_IGCHK == nil then BSCAS.SV_acc.SETTING[name].ITEM_KRAGLEN_IGCHK = true end			-- Item
		if BSCAS.SV_acc.SETTING[name].ITEM_KRAGLEN_HBCHK == nil then BSCAS.SV_acc.SETTING[name].ITEM_KRAGLEN_HBCHK = -1 end			-- Item
		if BSCAS.SV_acc.SETTING[name].ITEM_SANGUINE == nil then BSCAS.SV_acc.SETTING[name].ITEM_SANGUINE = true end			-- Item	
		if BSCAS.SV_acc.SETTING[name].ITEM_SANGUINE_IGCHK == nil then BSCAS.SV_acc.SETTING[name].ITEM_SANGUINE_IGCHK = true end			-- Item		
		if BSCAS.SV_acc.SETTING[name].ITEM_SANGUINE_HBCHK == nil then BSCAS.SV_acc.SETTING[name].ITEM_SANGUINE_HBCHK = -1 end			-- Item				
		if BSCAS.SV_acc.SETTING[name].ITEM_GPREPRISAL == nil then BSCAS.SV_acc.SETTING[name].ITEM_GPREPRISAL = true end			-- Item	
		if BSCAS.SV_acc.SETTING[name].ITEM_GPREPRISAL_IGCHK == nil then BSCAS.SV_acc.SETTING[name].ITEM_GPREPRISAL_IGCHK = true end			-- Item		
		if BSCAS.SV_acc.SETTING[name].ITEM_GPREPRISAL_HBCHK == nil then BSCAS.SV_acc.SETTING[name].ITEM_GPREPRISAL_HBCHK = -1 end			-- Item
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	end	
end

local function PrintPortalInfo(name, bEnabeld)
	local pstatus = zo_strformat("<<1>>[<<2>><<3>><<4>>]", "|cb3b6b7", (bEnabeld and BSCAS.color_green or BSCAS.color_red), (bEnabeld and 'Enabled' or 'Disabled'), "|cb3b6b7")
	CHAT_ROUTER:AddSystemMessage(zo_strformat("BSCs-AS |cb3b6b7<<1>> <<2>>", name, pstatus))
end

------------------------------------------------------------------------------
-- Update data
------------------------------------------------------------------------------
local enabled_synergie = { }
local ignor_check = { }
local check_hotbar = { }	-- (-1 = ALL, 0 = Primary, 1 = Backup)
function BSCAS.UpdateSetting()
	PrintDebug("UpdateSynergieSetting")		
	if not BSCAS:PresetExist(BSCAS.SV.SELECTED_PRESET) then BSCAS.SV.SELECTED_PRESET = "Default" end	
	-- UNDAUNTED	
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_BLOODALTAR1)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ALTAR
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_BLOODALTAR2)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ALTAR
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_BLACK_WIDOWS1)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_WEBS
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_BLACK_WIDOWS2)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_WEBS
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_INNERFIRE)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_FIRE  
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_BONE1)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_BONE
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_BONE2)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_BONE
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_ORB1)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ORB
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_ORB2)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ORB_HEALING		
	ignor_check[GetString(SI_SYNERGY_ABILITY_BLOODALTAR1)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ALTAR_IGCHK
	ignor_check[GetString(SI_SYNERGY_ABILITY_BLOODALTAR2)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ALTAR_IGCHK
	ignor_check[GetString(SI_SYNERGY_ABILITY_BLACK_WIDOWS1)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_WEBS_IGCHK
	ignor_check[GetString(SI_SYNERGY_ABILITY_BLACK_WIDOWS2)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_WEBS_IGCHK
	ignor_check[GetString(SI_SYNERGY_ABILITY_INNERFIRE)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_FIRE_IGCHK
	ignor_check[GetString(SI_SYNERGY_ABILITY_BONE1)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_BONE_IGCHK
	ignor_check[GetString(SI_SYNERGY_ABILITY_BONE2)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_BONE_IGCHK
	ignor_check[GetString(SI_SYNERGY_ABILITY_ORB1)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ORB_IGCHK
	ignor_check[GetString(SI_SYNERGY_ABILITY_ORB2)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ORB_HEALING_IGCHK		
	check_hotbar[GetString(SI_SYNERGY_ABILITY_BLOODALTAR1)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ALTAR_HBCHK
	check_hotbar[GetString(SI_SYNERGY_ABILITY_BLOODALTAR2)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ALTAR_HBCHK
	check_hotbar[GetString(SI_SYNERGY_ABILITY_BLACK_WIDOWS1)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_WEBS_HBCHK
	check_hotbar[GetString(SI_SYNERGY_ABILITY_BLACK_WIDOWS2)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_WEBS_HBCHK
	check_hotbar[GetString(SI_SYNERGY_ABILITY_INNERFIRE)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_FIRE_HBCHK
	check_hotbar[GetString(SI_SYNERGY_ABILITY_BONE1)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_BONE_HBCHK
	check_hotbar[GetString(SI_SYNERGY_ABILITY_BONE2)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_BONE_HBCHK
	check_hotbar[GetString(SI_SYNERGY_ABILITY_ORB1)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ORB_HBCHK
	check_hotbar[GetString(SI_SYNERGY_ABILITY_ORB2)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ORB_HEALING_HBCHK	
	-- Templar
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_SHARDS1)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_SHARDS
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_SHARDS2)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_SHARDS_DMG
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_PURGE)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_PURGE
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_NOVA1)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_NOVA
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_NOVA2)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_NOVA		
	ignor_check[GetString(SI_SYNERGY_ABILITY_SHARDS1)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_SHARDS_IGCHK
	ignor_check[GetString(SI_SYNERGY_ABILITY_SHARDS2)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_SHARDS_DMG_IGCHK
	ignor_check[GetString(SI_SYNERGY_ABILITY_PURGE)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_PURGE_IGCHK
	ignor_check[GetString(SI_SYNERGY_ABILITY_NOVA1)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_NOVA_IGCHK
	ignor_check[GetString(SI_SYNERGY_ABILITY_NOVA2)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_NOVA_IGCHK
	check_hotbar[GetString(SI_SYNERGY_ABILITY_SHARDS1)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_SHARDS_HBCHK
	check_hotbar[GetString(SI_SYNERGY_ABILITY_SHARDS2)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_SHARDS_DMG_HBCHK
	check_hotbar[GetString(SI_SYNERGY_ABILITY_PURGE)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_PURGE_HBCHK
	check_hotbar[GetString(SI_SYNERGY_ABILITY_NOVA1)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_NOVA_HBCHK
	check_hotbar[GetString(SI_SYNERGY_ABILITY_NOVA2)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_NOVA_HBCHK	
	-- Sorc
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_ATRO)] =  BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SORC_ATRO
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_CONDUIT)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SORC_CONDUIT	
	ignor_check[GetString(SI_SYNERGY_ABILITY_ATRO)] =  BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SORC_ATRO_IGCHK
	ignor_check[GetString(SI_SYNERGY_ABILITY_CONDUIT)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SORC_CONDUIT_IGCHK	
	check_hotbar[GetString(SI_SYNERGY_ABILITY_ATRO)] =  BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SORC_ATRO_HBCHK
	check_hotbar[GetString(SI_SYNERGY_ABILITY_CONDUIT)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SORC_CONDUIT_HBCHK
	-- DK
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_IMPALE)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DK_IMPALE		
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_STANDARTE)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DK_STANDARTE		
	ignor_check[GetString(SI_SYNERGY_ABILITY_IMPALE)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DK_IMPALE_IGCHK
	ignor_check[GetString(SI_SYNERGY_ABILITY_STANDARTE)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DK_STANDARTE_IGCHK	
	check_hotbar[GetString(SI_SYNERGY_ABILITY_IMPALE)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DK_IMPALE_HBCHK
	check_hotbar[GetString(SI_SYNERGY_ABILITY_STANDARTE)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DK_STANDARTE_HBCHK
	-- NB
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_DARK)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NB_DARK		
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_SOUL)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NB_SOUL	
	ignor_check[GetString(SI_SYNERGY_ABILITY_DARK)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NB_DARK_IGCHK
	ignor_check[GetString(SI_SYNERGY_ABILITY_SOUL)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NB_SOUL_IGCHK	
	check_hotbar[GetString(SI_SYNERGY_ABILITY_DARK)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NB_DARK_HBCHK
	check_hotbar[GetString(SI_SYNERGY_ABILITY_SOUL)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NB_SOUL_HBCHK	
	-- wardn
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_HARVEST)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WARDEN_HARVEST	
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_ICYESC)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WARDEN_ICYESC	
	ignor_check[GetString(SI_SYNERGY_ABILITY_HARVEST)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WARDEN_HARVEST_IGCHK
	ignor_check[GetString(SI_SYNERGY_ABILITY_ICYESC)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WARDEN_ICYESC_IGCHK	
	check_hotbar[GetString(SI_SYNERGY_ABILITY_HARVEST)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WARDEN_HARVEST_HBCHK
	check_hotbar[GetString(SI_SYNERGY_ABILITY_ICYESC)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WARDEN_ICYESC_HBCHK	
	-- Necro
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_BONEYARD)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NECRO_BONEYARD	
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_TOTEM)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NECRO_TOTEM	
	ignor_check[GetString(SI_SYNERGY_ABILITY_BONEYARD)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NECRO_BONEYARD_IGCHK
	ignor_check[GetString(SI_SYNERGY_ABILITY_TOTEM)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NECRO_TOTEM_IGCHK		
	check_hotbar[GetString(SI_SYNERGY_ABILITY_BONEYARD)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NECRO_BONEYARD_HBCHK
	check_hotbar[GetString(SI_SYNERGY_ABILITY_TOTEM)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NECRO_TOTEM_HBCHK	
	-- Arcanist
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_RUNE)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARCANIST_RUNE	
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_PORTAL)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARCANIST_PORTAL	
	ignor_check[GetString(SI_SYNERGY_ABILITY_RUNE)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARCANIST_RUNE_IGCHK
	ignor_check[GetString(SI_SYNERGY_ABILITY_PORTAL)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARCANIST_PORTAL_IGCHK		
	check_hotbar[GetString(SI_SYNERGY_ABILITY_RUNE)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARCANIST_RUNE_HBCHK
	check_hotbar[GetString(SI_SYNERGY_ABILITY_PORTAL)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARCANIST_PORTAL_HBCHK	
	-- WW
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_HUNT)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WW_HUNT	
	ignor_check[GetString(SI_SYNERGY_ABILITY_HUNT)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WW_HUNT_IGCHK
	check_hotbar[GetString(SI_SYNERGY_ABILITY_HUNT)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WW_HUNT_HBCHK
	
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_DEVOUR)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WW_DEVOUR	
	ignor_check[GetString(SI_SYNERGY_ABILITY_DEVOUR)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WW_DEVOUR_IGCHK
	check_hotbar[GetString(SI_SYNERGY_ABILITY_DEVOUR)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WW_DEVOUR_HBCHK		
	-- Vamp
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_EAT)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].VAMP_EAT	
	ignor_check[GetString(SI_SYNERGY_ABILITY_EAT)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].VAMP_EAT_IGCHK
	check_hotbar[GetString(SI_SYNERGY_ABILITY_EAT)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].VAMP_EAT_HBCHK
	-- BH
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_BH)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].HOOD_BLADE	
	ignor_check[GetString(SI_SYNERGY_ABILITY_BH)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].HOOD_BLADE_IGCHK
	check_hotbar[GetString(SI_SYNERGY_ABILITY_BH)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].HOOD_BLADE_HBCHK
	
	-- Trail
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_GATEWAY)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].CR_PORTAL	
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_TIME_BREACH)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SS_PORTAL	
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_KA_PORTAL)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].KA_PORTAL	
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_KA_EXECRATION)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].KA_EXECRATION	
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_DSR_SURGING_WATERS)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DSR_SURGING_WATERS
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_RG_BLOP)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].RG_PURGE_BLOCK	
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_SE_VANTONS_CLARITY)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SE_VANTONS_CLARITY	
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_SE_ATTUNEMENT)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SE_ATTUNEMENT	
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_LC_MIRROR)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].LC_MIRROR	
	ignor_check[GetString(SI_SYNERGY_ABILITY_GATEWAY)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].CR_PORTAL_IGCHK
	ignor_check[GetString(SI_SYNERGY_ABILITY_TIME_BREACH)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SS_PORTAL_IGCHK
	ignor_check[GetString(SI_SYNERGY_ABILITY_KA_PORTAL)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].KA_PORTAL_IGCHK
	ignor_check[GetString(SI_SYNERGY_ABILITY_KA_EXECRATION)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].KA_EXECRATION_IGCHK	
	ignor_check[GetString(SI_SYNERGY_ABILITY_DSR_SURGING_WATERS)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DSR_SURGING_WATERS_IGCHK	
	ignor_check[GetString(SI_SYNERGY_ABILITY_RG_BLOP)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].RG_PURGE_BLOCK_IGCHK		
	ignor_check[GetString(SI_SYNERGY_ABILITY_SE_VANTONS_CLARITY)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SE_VANTONS_CLARITY_IGCHK	
	ignor_check[GetString(SI_SYNERGY_ABILITY_SE_ATTUNEMENT)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SE_ATTUNEMENT_IGCHK	
	ignor_check[GetString(SI_SYNERGY_ABILITY_LC_MIRROR)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].LC_MIRROR_IGCHK		
	check_hotbar[GetString(SI_SYNERGY_ABILITY_GATEWAY)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].CR_PORTAL_HBCHK
	check_hotbar[GetString(SI_SYNERGY_ABILITY_TIME_BREACH)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SS_PORTAL_HBCHK
	check_hotbar[GetString(SI_SYNERGY_ABILITY_KA_PORTAL)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].KA_PORTAL_HBCHK
	check_hotbar[GetString(SI_SYNERGY_ABILITY_KA_EXECRATION)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].KA_EXECRATION_HBCHK
	check_hotbar[GetString(SI_SYNERGY_ABILITY_DSR_SURGING_WATERS)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DSR_SURGING_WATERS_HBCHK
	check_hotbar[GetString(SI_SYNERGY_ABILITY_RG_BLOP)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].RG_PURGE_BLOCK_HBCHK	
	check_hotbar[GetString(SI_SYNERGY_ABILITY_SE_VANTONS_CLARITY)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SE_VANTONS_CLARITY_HBCHK
	check_hotbar[GetString(SI_SYNERGY_ABILITY_SE_ATTUNEMENT)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SE_ATTUNEMENT_HBCHK
	check_hotbar[GetString(SI_SYNERGY_ABILITY_LC_MIRROR)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].LC_MIRROR_HBCHK	
		
	-- Arena
	enabled_synergie[GetString(SI_SYNERGY_SIGIL_RESURRECTION)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_RESURRECTION	
	enabled_synergie[GetString(SI_SYNERGY_SIGIL_DEFENSE)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_DEFENSE	
	enabled_synergie[GetString(SI_SYNERGY_SIGIL_HEALING)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_HEALING	
	enabled_synergie[GetString(SI_SYNERGY_SIGIL_SUSTAIN)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_SUSTAIN	
	enabled_synergie[GetString(SI_SYNERGY_SIGIL_POWER)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_POWER	
	enabled_synergie[GetString(SI_SYNERGY_SIGIL_HASTE)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_HASTE		
	ignor_check[GetString(SI_SYNERGY_SIGIL_RESURRECTION)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_RESURRECTION_IGCHK
	ignor_check[GetString(SI_SYNERGY_SIGIL_DEFENSE)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_DEFENSE_IGCHK
	ignor_check[GetString(SI_SYNERGY_SIGIL_HEALING)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_HEALING_IGCHK
	ignor_check[GetString(SI_SYNERGY_SIGIL_SUSTAIN)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_SUSTAIN_IGCHK
	ignor_check[GetString(SI_SYNERGY_SIGIL_POWER)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_POWER_IGCHK
	ignor_check[GetString(SI_SYNERGY_SIGIL_HASTE)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_HASTE_IGCHK			
	check_hotbar[GetString(SI_SYNERGY_SIGIL_RESURRECTION)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_RESURRECTION_HBCHK
	check_hotbar[GetString(SI_SYNERGY_SIGIL_DEFENSE)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_DEFENSE_HBCHK
	check_hotbar[GetString(SI_SYNERGY_SIGIL_HEALING)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_HEALING_HBCHK
	check_hotbar[GetString(SI_SYNERGY_SIGIL_SUSTAIN)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_SUSTAIN_HBCHK
	check_hotbar[GetString(SI_SYNERGY_SIGIL_POWER)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_POWER_HBCHK
	check_hotbar[GetString(SI_SYNERGY_SIGIL_HASTE)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_HASTE_HBCHK
	
	-- Items
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_URSUS)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ITEM_URSUS	
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_KRAGLEN)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ITEM_KRAGLEN	
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_SANGUINE)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ITEM_SANGUINE		
	enabled_synergie[GetString(SI_SYNERGY_ABILITY_GPREPRISAL)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ITEM_GPREPRISAL		
	ignor_check[GetString(SI_SYNERGY_ABILITY_URSUS)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ITEM_URSUS_IGCHK
	ignor_check[GetString(SI_SYNERGY_ABILITY_KRAGLEN)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ITEM_KRAGLEN_IGCHK
	ignor_check[GetString(SI_SYNERGY_ABILITY_SANGUINE)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ITEM_SANGUINE_IGCHK	
	ignor_check[GetString(SI_SYNERGY_ABILITY_GPREPRISAL)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ITEM_GPREPRISAL_IGCHK		
	check_hotbar[GetString(SI_SYNERGY_ABILITY_URSUS)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ITEM_URSUS_HBCHK
	check_hotbar[GetString(SI_SYNERGY_ABILITY_KRAGLEN)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ITEM_KRAGLEN_HBCHK
	check_hotbar[GetString(SI_SYNERGY_ABILITY_SANGUINE)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ITEM_SANGUINE_HBCHK	
	check_hotbar[GetString(SI_SYNERGY_ABILITY_GPREPRISAL)] = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ITEM_GPREPRISAL_HBCHK	
end

function BSCAS.CheckInfo()
	BSCAS:PrintDebug(" ")	
	BSCAS:PrintDebug("-- Check enabled_synergie table --")	
	BSCAS:PrintDebug("- UNDAUNTED")	
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_BLOODALTAR1", GetString(SI_SYNERGY_ABILITY_BLOODALTAR1)))
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_BLOODALTAR2", GetString(SI_SYNERGY_ABILITY_BLOODALTAR2)))
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_BLACK_WIDOWS1", GetString(SI_SYNERGY_ABILITY_BLACK_WIDOWS1)))
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_BLACK_WIDOWS2", GetString(SI_SYNERGY_ABILITY_BLACK_WIDOWS2)))
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_INNERFIRE", GetString(SI_SYNERGY_ABILITY_INNERFIRE)))
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_BONE1", GetString(SI_SYNERGY_ABILITY_BONE1)))
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_BONE2", GetString(SI_SYNERGY_ABILITY_BONE2)))
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_ORB1", GetString(SI_SYNERGY_ABILITY_ORB1)))
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_ORB2", GetString(SI_SYNERGY_ABILITY_ORB2)))	
	BSCAS:PrintDebug("- Templar")	
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_SHARDS1", GetString(SI_SYNERGY_ABILITY_SHARDS1)))
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_SHARDS2", GetString(SI_SYNERGY_ABILITY_SHARDS2)))
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_PURGE", GetString(SI_SYNERGY_ABILITY_PURGE)))
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_NOVA1", GetString(SI_SYNERGY_ABILITY_NOVA1)))
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_NOVA2", GetString(SI_SYNERGY_ABILITY_NOVA2)))	
	BSCAS:PrintDebug("- Sorc")	
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_ATRO", GetString(SI_SYNERGY_ABILITY_ATRO)))
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_CONDUIT", GetString(SI_SYNERGY_ABILITY_CONDUIT)))
	BSCAS:PrintDebug("- Dragonknight ")	
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_IMPALE", GetString(SI_SYNERGY_ABILITY_IMPALE)))
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_STANDARTE", GetString(SI_SYNERGY_ABILITY_STANDARTE)))
	BSCAS:PrintDebug("- Nightblade")	
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_DARK", GetString(SI_SYNERGY_ABILITY_DARK)))
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_SOUL", GetString(SI_SYNERGY_ABILITY_SOUL)))
	BSCAS:PrintDebug("- Wardn")	
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_HARVEST", GetString(SI_SYNERGY_ABILITY_HARVEST)))
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_ICYESC", GetString(SI_SYNERGY_ABILITY_ICYESC)))	
	BSCAS:PrintDebug("- Necro")	
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_BONEYARD", GetString(SI_SYNERGY_ABILITY_BONEYARD)))
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_TOTEM", GetString(SI_SYNERGY_ABILITY_TOTEM)))
	BSCAS:PrintDebug("- Arcanist")	
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_RUNE", GetString(SI_SYNERGY_ABILITY_RUNE)))
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_PORTAL", GetString(SI_SYNERGY_ABILITY_PORTAL)))
	BSCAS:PrintDebug("- Werewolf")
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_HUNT", GetString(SI_SYNERGY_ABILITY_HUNT)))	
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_DEVOUR", GetString(SI_SYNERGY_ABILITY_DEVOUR)))	
	BSCAS:PrintDebug("- Vamp")	
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_EAT", GetString(SI_SYNERGY_ABILITY_EAT)))
	BSCAS:PrintDebug("- Guild Brotherhood")	
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_BH", GetString(SI_SYNERGY_ABILITY_BH)))
	BSCAS:PrintDebug("- Trail")	
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_LC_MIRROR", GetString(SI_SYNERGY_ABILITY_DESTRUCTIVE_OUTBREAK)))
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_GATEWAY", GetString(SI_SYNERGY_ABILITY_GATEWAY)))
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_TIME_BREACH", GetString(SI_SYNERGY_ABILITY_TIME_BREACH)))
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_KA_PORTAL", GetString(SI_SYNERGY_ABILITY_KA_PORTAL)))
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_KA_EXECRATION", GetString(SI_SYNERGY_ABILITY_KA_EXECRATION)))
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_DSR_SURGING_WATERS", GetString(SI_SYNERGY_ABILITY_DSR_SURGING_WATERS)))	
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_RG_BLOP", GetString(SI_SYNERGY_ABILITY_RG_BLOP)))	
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_SE_VANTONS_CLARITY", GetString(SI_SYNERGY_ABILITY_SE_VANTONS_CLARITY)))
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_SE_ATTUNEMENT", GetString(SI_SYNERGY_ABILITY_SE_ATTUNEMENT)))
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_LC_MIRROR", GetString(SI_SYNERGY_ABILITY_LC_MIRROR)))
	BSCAS:PrintDebug("- Arena")	
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_SIGIL_RESURRECTION", GetString(SI_SYNERGY_SIGIL_RESURRECTION)))
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_SIGIL_DEFENSE", GetString(SI_SYNERGY_SIGIL_DEFENSE)))
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_SIGIL_HEALING", GetString(SI_SYNERGY_SIGIL_HEALING)))
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_SIGIL_SUSTAIN", GetString(SI_SYNERGY_SIGIL_SUSTAIN)))
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_SIGIL_POWER", GetString(SI_SYNERGY_SIGIL_POWER)))
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_SIGIL_HASTE", GetString(SI_SYNERGY_SIGIL_HASTE)))	
	BSCAS:PrintDebug("- Items")	
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_URSUS", GetString(SI_SYNERGY_ABILITY_URSUS)))
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_KRAGLEN", GetString(SI_SYNERGY_ABILITY_KRAGLEN)))
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_SANGUINE", GetString(SI_SYNERGY_ABILITY_SANGUINE)))	
	BSCAS:PrintDebug(zo_strformat("Name[<<1>>][<<2>>]", "SI_SYNERGY_ABILITY_GPREPRISAL", GetString(SI_SYNERGY_ABILITY_GPREPRISAL)))
	BSCAS:PrintDebug(" ")		
end
------------------------------------------------------------------------------
-- Function to check if can use the Synergy
------------------------------------------------------------------------------
local function IgnoreCheck(synergyName)
	if ignor_check[synergyName] ~= nil and ignor_check[synergyName] then
		PrintDebug(zo_strformat("(IgnoreMode) Can Use Synergie[<<1>>]", synergyName))
		return true
	end
	return false
end

local function CanUseSynergy(synergyName)
	PrintDebug(zo_strformat("Can Use Start [<<1>>]", synergyName))
	-- debug area, logg unknown names
	if debug_mode then
		if BSCAS.SV_acc.DEBUG_LIST[synergyName] == nil then
			BSCAS.SV_acc.DEBUG_LIST[synergyName] = iconFilename
			PrintDebug(zo_strformat("1 Unknown synergy added to Debug List[<<1>>]", synergyName))
			return true
		end
	end
	-- HRC Confirm
	if synergyName == GetString(SI_SYNERGY_ABILITY_DESTRUCTIVE_OUTBREAK) and BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].HRC_CONFIRM then
		if BSCAS.SHOW_DIALOG then
			ZO_Dialogs_ShowPlatformDialog("BSC_ADVANCED_SYNERGY_CONFIRM", nil)
			return false			
		end
	end
	-- unknown synergy always allowed
	if enabled_synergie[synergyName] == nil then
		BSCAS.SV_acc.DEBUG_LIST[synergyName] = iconFilename
		PrintDebug(zo_strformat("2 Unknown synergy added to Debug List[<<1>>]", synergyName))	
		return true 
	end
	-- only in combat
	if BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ONLYINCOMBAT and not IsUnitInCombat('player') then
		PrintDebug(zo_strformat("(CombatMode) Can't used Synergie[<<1>>]", synergyName))
		if IgnoreCheck(synergyName) then return true end
		return false	
	end	
	-- check if enabled
	if not enabled_synergie[synergyName] then
		PrintDebug(zo_strformat("(EnableMode) Can't used Synergie[<<1>>]", synergyName))
		return false							
	end
	-- Ignore every check below
	if IgnoreCheck(synergyName) then return true end
	-- check lokke
	if not lokkeCheck() then
		PrintDebug(zo_strformat("(LokkeMode) Can't use Synergie[<<1>>]", synergyName))	
		return false
	end		
	-- check Alkosh
	if not HasAlkosh() then
		PrintDebug(zo_strformat("(AlkoshMode) Can't used Synergie[<<1>>]", synergyName))	
		return false
	end			
	-- check_hotbar = { }	-- (-1 = ALL, 0 = Primary, 1 = Backup)
	local ActiveHotbar = GetActiveHotbarCategory()
	if ActiveHotbar < 2 and check_hotbar[synergyName] ~= nil and check_hotbar[synergyName] ~= -1 and check_hotbar[synergyName] ~= ActiveHotbar then
		PrintDebug(zo_strformat("(HotbarMode) Can't used Synergie [<<1>>] Hotbar[<<2>>]", synergyName, ActiveHotbar))
		return false				
	end			
	-- check hotbar new			
	if ActiveHotbar < 2 and BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NEW_BARCHECK ~= nil and BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NEW_BARCHECK ~= -1 and BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NEW_BARCHECK ~= ActiveHotbar then
		PrintDebug(zo_strformat("(GHotbarMode) Can't used Synergie [<<1>>] Hotbar[<<2>>]", synergyName, ActiveHotbar))
		return false				
	end
	-- Resources check
	if BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].RESOURCES_CHECK or CHECK_RESOURCES then
		if not isLowStamina() and not isLowMagica() then
			return false
		end
	end	
	PrintDebug(zo_strformat("Can Use End [<<1>>]", synergyName))	
	return true
end
------------------------------------------------------------------------------
-- New synergy blocking
------------------------------------------------------------------------------
local function OnSynergyAbilityChanged()
	local hasSynergy, synergyName, iconFilename, prompt = GetCurrentSynergyInfo()
	if hasSynergy then
		synergyName = zo_strformat("<<1>>", synergyName)
		if CanUseSynergy(synergyName) then
			if SYNERGY.lastSynergyName ~= synergyName then
				PlaySound(SOUNDS.ABILITY_SYNERGY_READY)
				if prompt == "" then
					prompt = zo_strformat(SI_USE_SYNERGY, synergyName)
				end
				SYNERGY.action:SetText(prompt)
				SYNERGY.lastSynergyName = synergyName
			end        
			SYNERGY.icon:SetTexture(iconFilename)
			SHARED_INFORMATION_AREA:SetHidden(SYNERGY, false)
		else
			SHARED_INFORMATION_AREA:SetHidden(SYNERGY, true)
			SYNERGY.lastSynergyName = nil -- is for playing sound..
		end
	else
		SHARED_INFORMATION_AREA:SetHidden(SYNERGY, true)
		SYNERGY.lastSynergyName = nil -- is for playing sound..
	end
end
------------------------------------------------------------------------------
-- Synergie stuff for Preset / Menu Options
------------------------------------------------------------------------------
function BSCAS:GetListNames()
	local List = {}	
	for name, v in pairs(BSCAS.SV_acc.SETTING) do	
		table.insert(List, name)
	end	
	return List
end
function BSCAS.AddSetting()
	local name = BSCAS_PresetEditbox.editbox:GetText()
	PrintDebug(zo_strformat("AddNewSetting[<<1>>]", name))
		
	if name == "Default" then return end	
	if BSCAS.SV_acc.SETTING[name] ~= nil then
		PrintDebug("Preset ["..name.."] Already Exist!") 
		ZO_Alert(UI_ALERT_CATEGORY_ERROR, SOUNDS.NEGATIVE_CLICK, "Preset ["..name.."] Already Exist!")
		return 
	end	
	if (name ~= "") then		
		BSCAS.SV_acc.SETTING[name] = default_setting
		BSCAS.SV.SELECTED_PRESET = name
		-- Update the dropbox
		BSCAS_PresetDropdown:UpdateChoices(BSCAS:GetListNames())
		BSCAS_PresetDropdownTank:UpdateChoices(BSCAS:GetListNames())
		BSCAS_PresetDropdownHeal:UpdateChoices(BSCAS:GetListNames())
		BSCAS_PresetDropdownDps:UpdateChoices(BSCAS:GetListNames())		
		BSCAS.LoadSetting(name)		
		-- Update Combobox from WW
		BSCAS:WWUpdateComboBox()
	else
		d("BSCAS - Add Setting failed!")
	end
end
function BSCAS.DeleteSelected()
	local name = BSCAS_PresetDropdown.data.getFunc()
	PrintDebug(zo_strformat("DeleteSelected[<<1>>]", name))
	
	-- cannot delete default
	if name == "Default" then 
		PrintDebug("Preset [Default] cannot deleted!") 
		ZO_Alert(UI_ALERT_CATEGORY_ERROR, SOUNDS.NEGATIVE_CLICK, GetString(SI_SYNERGY_ERROR_NOTDELETE))
		return 
	end
	
	-- remake the list
	local new_list = { }
	for k, v in pairs(BSCAS.SV_acc.SETTING) do		
		if name ~= k then
			new_list[k] = v
		end
	end	
	BSCAS.SV_acc.SETTING = new_list
	
	-- set back to default
	BSCAS.LoadSetting("Default")
	-- Update the dropbox
	BSCAS_PresetDropdown:UpdateChoices(BSCAS:GetListNames())
	
	if BSCAS.SV.SELECTED_PRESET_TANK == name then BSCAS.SV.SELECTED_PRESET_TANK = "Default" end
	BSCAS_PresetDropdownTank:UpdateChoices(BSCAS:GetListNames())
	if BSCAS.SV.SELECTED_PRESET_HEAL == name then BSCAS.SV.SELECTED_PRESET_HEAL = "Default" end
	BSCAS_PresetDropdownHeal:UpdateChoices(BSCAS:GetListNames())
	if BSCAS.SV.SELECTED_PRESET_DPS == name then BSCAS.SV.SELECTED_PRESET_DPS = "Default" end
	BSCAS_PresetDropdownDps:UpdateChoices(BSCAS:GetListNames())
	
	-- Update Combobox from WW
	BSCAS:WWUpdateComboBox()
end
function BSCAS.LoadSetting(name)
	PrintDebug(zo_strformat("LoadSelected[<<1>>]", name))	
	if BSCAS.SV_acc.SETTING[name] == nil then
		ZO_Alert(UI_ALERT_CATEGORY_ERROR, SOUNDS.NEGATIVE_CLICK, GetString(SI_SYNERGY_ERROR_DELETE))
		return
	end		
	BSCAS.SV.SELECTED_PRESET = name		
	BSCAS.UpdateSetting()
end
function BSCAS:PresetExist(Preset)
	for name, v in pairs(BSCAS.SV_acc.SETTING) do
		if name == Preset then return true end
	end
	return false
end
------------------------------------------------------------------------------
-- Enable all portals!
------------------------------------------------------------------------------
function BSCAS.TogglePortals() 
	local zoneId  = GetUnitWorldPosition('player') 
	if not BSCAS:PresetExist(BSCAS.SV.SELECTED_PRESET) then BSCAS.SV.SELECTED_PRESET = "Default" end	
	-- CloudRest
	if zoneId == 1051 then	
		BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].CR_PORTAL = not BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].CR_PORTAL
		PrintPortalInfo(GetString(SI_SYNERGY_ABILITY_GATEWAY), BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].CR_PORTAL)
	end
	-- Sunspire
	if zoneId == 1121 then
		BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SS_PORTAL = not BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SS_PORTAL
		PrintPortalInfo(GetString(SI_SYNERGY_ABILITY_TIME_BREACH), BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SS_PORTAL)
	end
	-- kynes aegis
	if zoneId == 1196 then	
		BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].KA_PORTAL = not BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].KA_PORTAL
		PrintPortalInfo(GetString(SI_SYNERGY_ABILITY_KA_PORTAL), BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].KA_PORTAL)
	end	
	if zoneId == 1344 then	
		BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DSR_SURGING_WATERS = not BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DSR_SURGING_WATERS
		PrintPortalInfo(GetString(SI_SYNERGY_ABILITY_DSR_SURGING_WATERS), BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DSR_SURGING_WATERS)		
	end
	if zoneId == 1478 then	
		BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].LC_MIRROR = not BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].LC_MIRROR
		PrintPortalInfo(GetString(SI_SYNERGY_ABILITY_LC_MIRROR), BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].LC_MIRROR)		
	end
	BSCAS.UpdateSetting()
end
------------------------------------------------------------------------------
--  Role Change LFG_ROLE_DPS, LFG_ROLE_HEAL, LFG_ROLE_INVALID,LFG_ROLE_TANK
------------------------------------------------------------------------------
local function HookRoleChange()
	ZO_PreHook("UpdateSelectedLFGRole", 	
	function(role)  
		--BSCAS:PrintDebug(zo_strformat("role[<<1>>]", role))
		if role == LFG_ROLE_TANK then
			if BSCAS.SV.SELECTED_PRESET_TANK ~= "Default" then
				BSCAS.SV.SELECTED_PRESET = BSCAS.SV.SELECTED_PRESET_TANK
				CHAT_ROUTER:AddSystemMessage(zo_strformat("|cFFFFFF BSCs-AS Loading "..GetString("SI_LFGROLE", LFG_ROLE_TANK).." "..GetString(SI_SYNERGY_NAME_PRE)..": <<1>>|r", BSCAS.SV.SELECTED_PRESET_TANK))
				BSCAS.PlaySound(1, SOUNDS.CHAMPION_RESPEC_ACCEPT)
			end
		elseif role == LFG_ROLE_HEAL then	
			if BSCAS.SV.SELECTED_PRESET_HEAL ~= "Default" then	
				BSCAS.SV.SELECTED_PRESET = BSCAS.SV.SELECTED_PRESET_HEAL
				CHAT_ROUTER:AddSystemMessage(zo_strformat("|cFFFFFF BSCs-AS Loading "..GetString("SI_LFGROLE", LFG_ROLE_HEAL).." "..GetString(SI_SYNERGY_NAME_PRE)..": <<1>>|r", BSCAS.SV.SELECTED_PRESET_HEAL))
				BSCAS.PlaySound(1, SOUNDS.CHAMPION_RESPEC_ACCEPT)
			end
		else			
			if BSCAS.SV.SELECTED_PRESET_DPS ~= "Default" then
				BSCAS.SV.SELECTED_PRESET = BSCAS.SV.SELECTED_PRESET_DPS
				CHAT_ROUTER:AddSystemMessage(zo_strformat("|cFFFFFF BSCs-AS Loading "..GetString("SI_LFGROLE", LFG_ROLE_DPS).." "..GetString(SI_SYNERGY_NAME_PRE)..": <<1>>|r", BSCAS.SV.SELECTED_PRESET_DPS))
				BSCAS.PlaySound(1, SOUNDS.CHAMPION_RESPEC_ACCEPT)
			end
		end	
		BSCAS.UpdateSetting()
	end)
end
------------------------------------------------------------------------------
-- HotbarTest
------------------------------------------------------------------------------
local function ActionSlotsFullUpdate(eventCode,  isHotbarSwap)
	if isHotbarSwap then
		OnSynergyAbilityChanged()
	end
end
------------------------------------------------------------------------------
-- COMBAT_EVENT for Blocking Portals
------------------------------------------------------------------------------
local RG_BLOP = false
local function CombatEvent(_, result, _, _, _, _, _, _, targetName, _, hitValue, _, _, _, _, targetUnitId, abilityId, _)
	-- COMBAT_EVENT for CR Blocking
	--if register_vcr then
	if abilityId == BSCAS.VCR_PORT_DBUFF_ID then
		if not BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].CR_PORTAL_BLOCK_DB then return end
		if result == ACTION_RESULT_EFFECT_GAINED then		
			PrintDebug(zo_strformat("GAINED ID[<<1>>] Name[<<2>>] Duration[<<3>>] TargedNanme[<<4>>]", abilityId, GetAbilityName(abilityId), GetAbilityDuration(abilityId), targetName))
			enabled_synergie[GetString(SI_SYNERGY_ABILITY_GATEWAY)] = false	
			PrintPortalInfo(GetString(SI_SYNERGY_ABILITY_GATEWAY), false)
		elseif result == ACTION_RESULT_EFFECT_FADED then		
			PrintDebug(zo_strformat("FADED ID[<<1>>] Name[<<2>>] TargedNanme[<<3>>]", abilityId, GetAbilityName(abilityId), targetName)) 		
			enabled_synergie[GetString(SI_SYNERGY_ABILITY_GATEWAY)] = true			
			OnSynergyAbilityChanged()
			PrintPortalInfo(GetString(SI_SYNERGY_ABILITY_GATEWAY), true)
		end	
	end 	
	-- COMBAT_EVENT for HRC outbreak
	--if register_hrc then
	if abilityId == BSCAS.HRC_OUTBREAK_DBUFF_ID then
		if result == ACTION_RESULT_EFFECT_FADED then			
			PrintDebug(zo_strformat("FADED ID[<<1>>] Name[<<2>>]", abilityId, GetAbilityName(abilityId))) -- enable dialog again
			bCanShowDialog = true
		end
	end
	-- COMBAT_EVENT for DSR 	
	--if register_dsr then
	if abilityId == BSCAS.DSR_INFESTATION then
		if not BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DSR_SURGING_WATERS_BLOCK_DB then return end		
		if result == ACTION_RESULT_EFFECT_GAINED then
			PrintDebug(zo_strformat("FADED ID[<<1>>] Name[<<2>>] Duration[<<3>>] TargedNanme[<<4>>]", abilityId, GetAbilityName(abilityId), GetAbilityDuration(abilityId), targetName))	
			-- Block 
			enabled_synergie[GetString(SI_SYNERGY_ABILITY_DSR_SURGING_WATERS)] = false				
			PrintPortalInfo(GetString(SI_SYNERGY_ABILITY_DSR_SURGING_WATERS), false)
			-- Unblock again in xx seconds			
			zo_callLater(
			function() 
				enabled_synergie[GetString(SI_SYNERGY_ABILITY_DSR_SURGING_WATERS)] = true		
				OnSynergyAbilityChanged()		
				PrintPortalInfo(GetString(SI_SYNERGY_ABILITY_DSR_SURGING_WATERS), true)
			end, 
			(BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DSR_SURGING_WATERS_CD*1000))
		end
	end
	-- Rockgrove Blob
	if abilityId == ABILITYID_RGBLOP then
		if BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].RG_PURGE_BLOCK then return end	-- can use Synergie? then return..
		if result == ACTION_RESULT_EFFECT_FADED then	
			enabled_synergie[GetString(SI_SYNERGY_ABILITY_RG_BLOP)] = true		
			OnSynergyAbilityChanged()
			RG_BLOP = false
		elseif result == ACTION_RESULT_EFFECT_GAINED then		
			if RG_BLOP then
				BSCAS.PlaySound(2, SOUNDS.DUEL_WON) 
				return
			end	
			RG_BLOP = true		
			enabled_synergie[GetString(SI_SYNERGY_ABILITY_RG_BLOP)] = false
			local timeBlop = BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].RG_PURGE_BLOCK_CD
			if BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].RG_PURGE_BLOCK_ALERT then
				if CombatAlerts ~= nil then
					CombatAlerts.CastAlertsStart(153034, GetFormattedAbilityName(153034), timeBlop, timeBlop, { 1, 0.7, 0, 0.5 }, { timeBlop, "Drop Blop Behind!!", 0.8, 0, 0, 0.9, SOUNDS.DUEL_WON} )
				else
					BSCASUIAlert:SetHidden(false)
					BSCAS.PlaySound(2, SOUNDS.DUEL_WON) 
				end	
			end
			zo_callLater(
				function() 					
					RG_BLOP = false
					BSCASUIAlert:SetHidden(true)
					enabled_synergie[GetString(SI_SYNERGY_ABILITY_RG_BLOP)] = true	
					OnSynergyAbilityChanged()
					if CombatAlerts ~= nil then
						BSCASUIAlert:SetHidden(true)
					end
				end, 
			timeBlop)
		end
		PrintDebug(zo_strformat("ID[<<1>>] Name[<<2>>] changeType[<<3>>]", abilityId, GetAbilityName(abilityId), result))
	end
	
	if abilityId == ABILITYID_CD_LC_MIRROR then
		if not BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].LC_MIRROR_BLOCK_DB then return end	
		if result == ACTION_RESULT_EFFECT_FADED then	
			enabled_synergie[GetString(SI_SYNERGY_ABILITY_RG_BLOP)] = true	
			OnSynergyAbilityChanged()
			PrintPortalInfo(GetString(SI_SYNERGY_ABILITY_LC_MIRROR), true)	
		elseif result == ACTION_RESULT_EFFECT_GAINED then
			enabled_synergie[GetString(SI_SYNERGY_ABILITY_RG_BLOP)] = false	
			OnSynergyAbilityChanged()		
			PrintPortalInfo(GetString(SI_SYNERGY_ABILITY_LC_MIRROR), false)	
		end
		PrintDebug(zo_strformat("ID[<<1>>] Name[<<2>>] changeType[<<3>>]", abilityId, GetAbilityName(abilityId), result))
	end	
end
------------------------------------------------------------------------------
-- Blocking Slayer
------------------------------------------------------------------------------
local function OnEffectChanged( _, changeType, _, _, unitTag, beginTime, endTime, _, _, _, _, _, _, unitName, unitId, abilityId, _)
	if not BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].BERSERK_CHECK then return end
	if changeType == EFFECT_RESULT_FADED then			
		enabled_synergie[GetString(SI_SYNERGY_ABILITY_ATRO)] = true		
		OnSynergyAbilityChanged()
	elseif changeType == EFFECT_RESULT_UPDATED then	
		enabled_synergie[GetString(SI_SYNERGY_ABILITY_ATRO)] = false	
		OnSynergyAbilityChanged()
	end	
	if debug_mode then
		BSCAS:PrintDebug(zo_strformat("ID[<<1>>] Name[<<2>>] changeType[<<3>>]", abilityId, GetAbilityName(abilityId), changeType))
	end
end
------------------------------------------------------------------------------
local DotCOunt = 0
local function CombatEventPURGE(eventCode, result, isError, abilityName, abilityGraphic, abilityActionSlotType, sourceName, sourceType, targetName, targetType, hitValue, powerType, dmgType, blog, sourceUnitId, targetUnitId, abilityId, overflow)	
	if GetAbilityDuration(abilityId) < 1 then return end	
	if dmgType == DAMAGE_TYPE_POISON or dmgType == DAMAGE_TYPE_FIRE then
		if result == ACTION_RESULT_EFFECT_GAINED or result == ACTION_RESULT_EFFECT_GAINED_DURATION then	
			DotCOunt = DotCOunt + 1			
			if DotCOunt == 1 then
				enabled_synergie[GetString(SI_SYNERGY_ABILITY_PURGE)] = true
				PrintPortalInfo(GetString(SI_SYNERGY_ABILITY_PURGE), true)
			end
		end
		--ACTION_RESULT_EFFECT_GAINED_DURATION
		if result == ACTION_RESULT_EFFECT_FADED then
			DotCOunt = DotCOunt - 1
			if DotCOunt < 0 then DotCOunt = 0 end				
			if DotCOunt == 0 then
				enabled_synergie[GetString(SI_SYNERGY_ABILITY_PURGE)] = false
				PrintPortalInfo(GetString(SI_SYNERGY_ABILITY_PURGE), false)
			end
		end			
	end		
end
------------------------------------------------------------------------------
-- on Zone Load
------------------------------------------------------------------------------
local register_vcr = false
local register_hrc = false
local register_dsr = false
local register_rg = false
local register_lc = false
local register_test = false
local current_zone = -1
local function OnPlayerActivated()		
	local zoneId  = GetUnitWorldPosition("player") -- /script d(GetUnitWorldPosition("player"))
	--		
	if BSCAS.SV.PVP_AREA_ENABLED == false then
		if IsInCampaign() or IsActiveWorldBattleground() then
			enabled_synergie = { }
			if zoneId ~= current_zone then
				CHAT_ROUTER:AddSystemMessage(BSCAS.Name.." Now Disabled! (PvP)")
				current_zone = zoneId
			end
			return
		end
	end		
	-- Update the blocking settings
	BSCAS.UpdateSetting()	
	-- CloudRest
	if zoneId == 1051 then
		register_vcr = true
		EVENT_MANAGER:RegisterForEvent("BSCAS_CECloudrest", EVENT_COMBAT_EVENT, CombatEvent)
		EVENT_MANAGER:AddFilterForEvent("BSCAS_CECloudrest", EVENT_COMBAT_EVENT, REGISTER_FILTER_ABILITY_ID, BSCAS.VCR_PORT_DBUFF_ID)		
		EVENT_MANAGER:AddFilterForEvent("BSCAS_CECloudrest", EVENT_COMBAT_EVENT, REGISTER_FILTER_TARGET_COMBAT_UNIT_TYPE, COMBAT_UNIT_TYPE_PLAYER)
		if zoneId ~= current_zone then
			PrintPortalInfo(GetString(SI_SYNERGY_ABILITY_GATEWAY), BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].CR_PORTAL)
		end
	elseif register_vcr then
		register_vcr = false
		EVENT_MANAGER:UnregisterForEvent("BSCAS_CECloudrest", EVENT_COMBAT_EVENT)
	end
	-- Helra Citardel
	if zoneId == 636 then
		register_hrc = true
		EVENT_MANAGER:RegisterForEvent("BSCAS_CEHelrar", EVENT_COMBAT_EVENT, CombatEvent)
		EVENT_MANAGER:AddFilterForEvent("BSCAS_CEHelrar", EVENT_COMBAT_EVENT, REGISTER_FILTER_ABILITY_ID, BSCAS.HRC_OUTBREAK_DBUFF_ID)		
		EVENT_MANAGER:AddFilterForEvent("BSCAS_CEHelrar", EVENT_COMBAT_EVENT, REGISTER_FILTER_TARGET_COMBAT_UNIT_TYPE, COMBAT_UNIT_TYPE_PLAYER)		
	elseif register_hrc then
		register_hrc = false
		EVENT_MANAGER:UnregisterForEvent("BSCAS_CEHelrar", EVENT_COMBAT_EVENT)
	end
	-- Sunspire
	if zoneId == 1121 then
		if zoneId ~= current_zone then
			PrintPortalInfo(GetString(SI_SYNERGY_ABILITY_TIME_BREACH), BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SS_PORTAL)
		end
	end
	-- kynes aegis
	if zoneId == 1196 then	
		if zoneId ~= current_zone then
			PrintPortalInfo(GetString(SI_SYNERGY_ABILITY_KA_PORTAL), BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].KA_PORTAL)
		end
	end
	-- Dreadsail Reef
	if zoneId == 1344 then	
		register_dsr = true
		EVENT_MANAGER:RegisterForEvent("BSCAS_CECDreadsail", EVENT_COMBAT_EVENT, CombatEvent)
		EVENT_MANAGER:AddFilterForEvent("BSCAS_CECDreadsail", EVENT_COMBAT_EVENT, REGISTER_FILTER_ABILITY_ID, BSCAS.DSR_INFESTATION)		
		EVENT_MANAGER:AddFilterForEvent("BSCAS_CECDreadsail", EVENT_COMBAT_EVENT, REGISTER_FILTER_TARGET_COMBAT_UNIT_TYPE, COMBAT_UNIT_TYPE_PLAYER)
		if zoneId ~= current_zone then
			PrintPortalInfo(GetString(SI_SYNERGY_ABILITY_DSR_SURGING_WATERS), BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DSR_SURGING_WATERS)
		end
	elseif register_dsr then
		register_dsr = false
		EVENT_MANAGER:UnregisterForEvent("BSCAS_CECDreadsail", EVENT_COMBAT_EVENT)
	end	
	-- RG
	if zoneId == 1263 then
		register_rg = true		
		RG_BLOP = false
		EVENT_MANAGER:RegisterForEvent("BSCAS_BlockSRG", EVENT_COMBAT_EVENT, CombatEvent)
		EVENT_MANAGER:AddFilterForEvent("BSCAS_BlockSRG", EVENT_COMBAT_EVENT, REGISTER_FILTER_ABILITY_ID, ABILITYID_RGBLOP)		
		EVENT_MANAGER:AddFilterForEvent("BSCAS_BlockSRG", EVENT_COMBAT_EVENT, REGISTER_FILTER_TARGET_COMBAT_UNIT_TYPE, COMBAT_UNIT_TYPE_PLAYER)
	elseif register_rg then
		register_rg = false
		EVENT_MANAGER:UnregisterForEvent("BSCAS_BlockSRG", EVENT_COMBAT_EVENT)		
	end
	if zoneId == 1478 then
		register_lc = true
		EVENT_MANAGER:RegisterForEvent("BSCAS_LCMIRROR", EVENT_COMBAT_EVENT, CombatEvent)
		EVENT_MANAGER:AddFilterForEvent("BSCAS_LCMIRROR", EVENT_COMBAT_EVENT, REGISTER_FILTER_ABILITY_ID, ABILITYID_CD_LC_MIRROR)		
		EVENT_MANAGER:AddFilterForEvent("BSCAS_LCMIRROR", EVENT_COMBAT_EVENT, REGISTER_FILTER_SOURCE_COMBAT_UNIT_TYPE, COMBAT_UNIT_TYPE_PLAYER)
	elseif register_lc then
		register_lc = false
		EVENT_MANAGER:UnregisterForEvent("BSCAS_LCMIRROR", EVENT_COMBAT_EVENT)		
	end
	
	-- Testing
	--if zoneId == 1082 then
	--	register_test = true
	--	EVENT_MANAGER:RegisterForEvent("BSCAS_CETEST", EVENT_COMBAT_EVENT, CombatEventPURGE)	
	--	EVENT_MANAGER:AddFilterForEvent("BSCAS_CETEST", EVENT_COMBAT_EVENT, REGISTER_FILTER_TARGET_COMBAT_UNIT_TYPE, COMBAT_UNIT_TYPE_PLAYER)		
	--elseif register_test then
	--	EVENT_MANAGER:UnregisterForEvent("BSCAS_CETEST", EVENT_COMBAT_EVENT)
	--end	
	current_zone = zoneId	
	BSCAS:CheckEquipment()
	-- Check synergy
	OnSynergyAbilityChanged()
end
------------------------------------------------------------------------------
-- Dialog functions for HRC outbreak check
------------------------------------------------------------------------------
BSCAS.SHOW_DIALOG = true
local function SetupConfirmDialog()
    local customControl = BSCAS_ConfirmationDialog	
    ZO_Dialogs_RegisterCustomDialog("BSC_ADVANCED_SYNERGY_CONFIRM",
    {
        gamepadInfo =
        {
            dialogType = GAMEPAD_DIALOGS.STATIC_LIST,
        },
        customControl = customControl,
        canQueue = false,
        title =
        {
            text = GetString(SI_SYNERGY_NAME_DESTRUCTIVE_OUTBREAK),
        },
        mainText =
        {
            text = GetString(SI_SYNERGY_ALERT_HRC),
        },
        buttons =
        {
            {
                control = customControl:GetNamedChild("Confirm"),
                text = SI_DIALOG_CONFIRM,
                callback = function(dialog)	
					BSCAS.SHOW_DIALOG = false
					zo_callLater(function() BSCAS.SHOW_DIALOG = true end, 3500) -- enable it again
					OnSynergyAbilityChanged()
                end,
            },
            {
                control = customControl:GetNamedChild("Cancel"),
                text = SI_DIALOG_CANCEL,
                callback = function(dialog)	
					BSCAS.SHOW_DIALOG = true					
					OnSynergyAbilityChanged()
                end,
            },
        }
    })
end
-- ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function BSCAS.BlockInit()		
	-- generate the default setting	
	-- set default if not exist
	if BSCAS.SV.SELECTED_PRESET == nil or BSCAS.SV.SELECTED_PRESET == "" then		
		BSCAS.SV.SELECTED_PRESET = "Default"
	end
	-- Check if Current Exist
	if not BSCAS:PresetExist(BSCAS.SV.SELECTED_PRESET) then BSCAS.SV.SELECTED_PRESET = "Default" end	
	-- check if already exist, if not add it
	if BSCAS.SV_acc.SETTING["Default"] == nil then
		BSCAS.SV_acc.SETTING["Default"] = default_setting
	end
	-- Check if all synergies are known
	CheckPresets()
	-- New synergy blocking functions
	SYNERGY.control:UnregisterForEvent(EVENT_PLAYER_ACTIVATED)
	SYNERGY.control:UnregisterForEvent(EVENT_SYNERGY_ABILITY_CHANGED)	
	EVENT_MANAGER:RegisterForEvent("BSCAS_BlockS", EVENT_SYNERGY_ABILITY_CHANGED, OnSynergyAbilityChanged)
	EVENT_MANAGER:RegisterForEvent("BSCAS_BlockS", EVENT_PLAYER_COMBAT_STATE, function(...) OnSynergyAbilityChanged() end)
	-- Build the menu
	BSCAS.InitBlockMenu()	
	--
	SetupConfirmDialog()
	--
	EVENT_MANAGER:RegisterForEvent("BSCAS_BlockS", EVENT_PLAYER_ACTIVATED, OnPlayerActivated)	
	EVENT_MANAGER:RegisterForEvent("BSCAS_BlockS", EVENT_ACTION_SLOTS_FULL_UPDATE, ActionSlotsFullUpdate)	
	HookRoleChange()		
	-- 
	EVENT_MANAGER:RegisterForEvent("BSCAS_BlockS", EVENT_INVENTORY_FULL_UPDATE, function(...) BSCAS:CheckEquipment() end )
	EVENT_MANAGER:AddFilterForEvent("BSCAS_BlockS", EVENT_INVENTORY_FULL_UPDATE, REGISTER_FILTER_BAG_ID, BAG_WORN)
	EVENT_MANAGER:AddFilterForEvent("BSCAS_BlockS", EVENT_INVENTORY_FULL_UPDATE, REGISTER_FILTER_INVENTORY_UPDATE_REASON, INVENTORY_UPDATE_REASON_DEFAULT)
	--
	EVENT_MANAGER:RegisterForEvent("BSCAS_BlockS", EVENT_INVENTORY_SINGLE_SLOT_UPDATE, function(...)  BSCAS:CheckEquipment() end )	
	EVENT_MANAGER:AddFilterForEvent("BSCAS_BlockS", EVENT_INVENTORY_SINGLE_SLOT_UPDATE, REGISTER_FILTER_BAG_ID, BAG_WORN)
	EVENT_MANAGER:AddFilterForEvent("BSCAS_BlockS", EVENT_INVENTORY_SINGLE_SLOT_UPDATE, REGISTER_FILTER_INVENTORY_UPDATE_REASON, INVENTORY_UPDATE_REASON_DEFAULT)	
	--
	for abilityId in pairs(BSCAS.BERSERK_IDS) do
		local eventName = 'BSCAS_BlockS'..abilityId
		EVENT_MANAGER:RegisterForEvent(eventName, EVENT_EFFECT_CHANGED, OnEffectChanged)
		EVENT_MANAGER:AddFilterForEvent(eventName, EVENT_EFFECT_CHANGED, REGISTER_FILTER_ABILITY_ID, abilityId)
		EVENT_MANAGER:AddFilterForEvent(eventName, EVENT_EFFECT_CHANGED, REGISTER_FILTER_UNIT_TAG, 'player')
	end
end