BSCASynergy = BSCASynergy or {}
local BSCAS = BSCASynergy

local optionsTable = {}
local s_sounds = { }
local s_choices = { }

local function AddSendFeedBack()
    table.insert(optionsTable, {
        type = "button",
        name = "Donate",
        tooltip = "Main - EU Server",
        func = function()
              local function PrefillMail()
                ZO_MailSendToField:SetText(BSCAS.Author)
                ZO_MailSendSubjectField:SetText(BSCAS.NameSpaced)
                ZO_MailSendBodyField:TakeFocus()
              end
                SCENE_MANAGER:Show('mailSend')
                zo_callLater(PrefillMail, 250)
        end,
        width = "half",
    })
end

--
local function AddTexture(control, strIcon, strDesciption)
	table.insert(control, {
        type = "texture",
        image =  strIcon,
		tooltip = strDesciption,
        imageWidth = 32,
        imageHeight = 32,
        width = "half",
	})
end

local function AddDivider(control)
	table.insert(control, {
		type = "divider",
	})
end

local function AddTestingSetting()
	table.insert(optionsTable, {
        type = "header",
        name = "Testing Stuff !!",
    })	
	table.insert(optionsTable, {
		type = "checkbox",
		name = "Hel Rar Citardel: Outbreak UI",
		tooltip = "Will show a 'yes' 'no' Handle while you in stoneform to not use the synergie",
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].HRC_CONFIRM end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].HRC_CONFIRM = value 
		end,
	})
end
	
local function AddBaseSetting()
	--
	table.insert(optionsTable, {
        type = "header",
        name = GetString(SI_SYNERGY_NAME_BASE),
    })	
	table.insert(optionsTable, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_USEPVP),
		getFunc = function() return BSCAS.SV.PVP_AREA_ENABLED end,
		setFunc = function(value) 
			BSCAS.SV.PVP_AREA_ENABLED = value 	
			BSCAS.UpdateSetting()
		end,
	})
	AddDivider(optionsTable)	
	table.insert(optionsTable, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_UI_NAME_WWPLUGIN),
		tooltip = GetString(SI_SYNERGY_UI_DESC_WWPLUGIN),
		getFunc = function() return BSCAS.SV.ADD_WW_PLUGIN end,
		setFunc = function(value) 
			BSCAS.SV.ADD_WW_PLUGIN = value
			zo_callLater(function() ReloadUI() end, 300)
		end,
        warning = GetString(SI_SYNERGY_INFO_RELOAD),	
	})
end 

local function AddSpecialSets()
	table.insert(optionsTable, {
        type = "header",
        name = "Special Settings",
    })	
	table.insert(optionsTable, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_LOKKE_CHECK),
		tooltip = GetString(SI_SYNERGY_NAME_LOKKE_INFO),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].LOKKECHECK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].LOKKECHECK = value 
			if value then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].RESOURCES_CHECK = false
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ALKOSHCHECK = false
			end				
			BSCAS.UpdateSetting()
		end,
	})	
	AddDivider(optionsTable)
	table.insert(optionsTable, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_ALKOSH_CHECK),
		tooltip = GetString(SI_SYNERGY_NAME_ALKOSH_INFO),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ALKOSHCHECK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ALKOSHCHECK = value 
			if value then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].RESOURCES_CHECK = false
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].LOKKECHECK = false
			end				
			BSCAS.UpdateSetting()
		end,
	})	
	table.insert(optionsTable, {
		type = "slider",
		name = GetString(SI_SYNERGY_NAME_ALKOSH_REAPPLY),
		tooltip = GetString(SI_SYNERGY_NAME_ALKOSH_REAPPLY_TIP),
		disabled = function() return not BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ALKOSHCHECK end,
		min = 0,
		max = 10,
		step = 1,
		default = 3,	
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ALKOSH_REAPPLY end,
		setFunc = function(value)
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ALKOSH_REAPPLY = value
		end,
	})	
	AddDivider(optionsTable)
	table.insert(optionsTable, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_ONLY_COMBAT),
		tooltip = GetString(SI_SYNERGY_INFO_ONLY_COMBAT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ONLYINCOMBAT end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ONLYINCOMBAT = value
		end,
	})
	--
	AddDivider(optionsTable)
	table.insert(optionsTable, {
		type = "dropdown",
		name =  GetString(SI_SYNERGY_NAME_HOTBAR),
		tooltip = GetString(SI_SYNERGY_MI_HOTBAR_INFO),
        choices = {"ALL", "PRIMARY", "BACKUP"},		
		getFunc = function()
			if BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NEW_BARCHECK == HOTBAR_CATEGORY_PRIMARY then
				return "PRIMARY" 
			elseif BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NEW_BARCHECK == HOTBAR_CATEGORY_BACKUP then
				return "BACKUP"
			else			
				return "ALL" 
			end
		end,
		setFunc = function(v) 
			if v == "PRIMARY" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NEW_BARCHECK = HOTBAR_CATEGORY_PRIMARY 
			elseif v == "BACKUP" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NEW_BARCHECK = HOTBAR_CATEGORY_BACKUP 
			else
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NEW_BARCHECK = -1 
			end			
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})	
	table.insert(optionsTable, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_BERSERK),
		tooltip = GetString(SI_SYNERGY_INFO_BERSERK),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].BERSERK_CHECK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].BERSERK_CHECK = value
			BSCAS.UpdateSetting()
		end,
	})
end

-- Resource setting
local function AddResourceSetting()	
	table.insert(optionsTable, {
        type = "header",
        name = GetString(SI_SYNERGY_NAME_RESOURCE),
    })		
	table.insert(optionsTable, {
		type = "checkbox",
		name = "Set Check",
		tooltip =  GetString(SI_SYNERGY_NAME_RESOURCE_TIP_SET),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].RESOURCES_CHECK_SETS end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].RESOURCES_CHECK_SETS = value
			BSCAS:CheckEquipment()
		end,
	})	
	table.insert(optionsTable, {
		type = "description",	
        text = zo_strformat("Set's are Checked: <<1>>, <<2>>, <<3>>, <<4>>", select(2, GetItemLinkSetInfo("|H0:item:186565:362:50:0:0:0:0:0:0:0:0:0:0:0:2048:130:0:0:0:10000:0|h|h")), 	
		select(2, GetItemLinkSetInfo("|H0:item:173609:362:50:0:0:0:0:0:0:0:0:0:0:0:2048:122:0:0:0:10000:0|h|h")), 
		select(2, GetItemLinkSetInfo("|H1:item:95453:364:50:45883:370:50:31:0:0:0:0:0:0:0:1:35:0:1:0:0:0|h|h")),
		select(2, GetItemLinkSetInfo("|H1:item:171437:364:50:45875:370:50:0:0:0:0:0:0:0:0:1:0:0:1:0:0:0|h|h"))),
        width = "full",
	})	
	AddDivider(optionsTable)
	table.insert(optionsTable, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_RESOURCE_ENABLE),
		tooltip = "",
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].RESOURCES_CHECK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].RESOURCES_CHECK = value
			if value then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].LOKKECHECK = false 
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ALKOSHCHECK = false
			end
		end,
	})			
	table.insert(optionsTable, {
		type = "slider",
		name = GetString(SI_SYNERGY_NAME_RESOURCE_SLIDER_S),
		tooltip = GetString(SI_SYNERGY_NAME_RESOURCE_TIP),
		disabled = function() return not BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].RESOURCES_CHECK and not BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].RESOURCES_CHECK_SETS end,
		min = 0,
		max = 100,
		step = 5,
		default = 80,	
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].RESOURCES_VALUE_S end,
		setFunc = function(value)
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].RESOURCES_VALUE_S = value
		end,
	})	
	table.insert(optionsTable, {
		type = "slider",
		name = GetString(SI_SYNERGY_NAME_RESOURCE_SLIDER_M),
		tooltip = GetString(SI_SYNERGY_NAME_RESOURCE_TIP),
		disabled = function() return not BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].RESOURCES_CHECK and not BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].RESOURCES_CHECK_SETS end,
		min = 0,
		max = 100,
		step = 5,
		default = 80,	
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].RESOURCES_VALUE_M end,
		setFunc = function(value)
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].RESOURCES_VALUE_M = value
		end,
	})		
end

local PresetString = ""
local function AddPresetSetting()
	table.insert(optionsTable, {
        type = "header",
		name = GetString(SI_SYNERGY_NAME_PRE_H),
    })
	------------------------------------------------------------------------------
	-- Saved Setting selection	
	table.insert(optionsTable, {
		type = "editbox",
		name = GetString(SI_SYNERGY_NAME_PRE_N),
		getFunc = function() return BSCAS.SV.SELECTED_PRESET end,		
        setFunc = function(value) end,
		reference = "BSCAS_PresetEditbox",
	})
	table.insert(optionsTable, {
		type = "button",
		name = GetString(SI_SYNERGY_NAME_PRE_B_S),
		func = BSCAS.AddSetting,
	})
    
	--------------------------------------
	table.insert(optionsTable, {
		type = 'dropdown',
		name = GetString(SI_SYNERGY_NAME_PRE_S),
		choices = BSCAS:GetListNames(),
		getFunc = function() return BSCAS.SV.SELECTED_PRESET end,
		setFunc = function(value)
			CHAT_ROUTER:AddSystemMessage(zo_strformat("|cFFFFFF BSCs-AS Loading "..GetString(SI_SYNERGY_NAME_PRE)..": <<1>>|r", value))
			BSCAS.PlaySound(1, SOUNDS.CHAMPION_RESPEC_ACCEPT)
			BSCAS.LoadSetting(value)
		end,
		scrollable = 12,
		reference = "BSCAS_PresetDropdown",
	})
	table.insert(optionsTable, {
		type = "button",
		name = GetString(SI_SYNERGY_NAME_PRE_B_D),
		func = BSCAS.DeleteSelected,
		isDangerous = true,
		warning = GetString(SI_SYNERGY_NAME_PRE_B_D).."?",
	})
	AddDivider(optionsTable)
	table.insert(optionsTable, {
		type = "editbox",
		name = GetString(SI_SYNERGY_NAME_PRE_EB),
		tooltip = GetString(SI_SYNERGY_NAME_PRE_EB_I),
		isMultiline = true,
		isExtraWide = true,
		maxChars = 6000,
		default = BSCAS:ExportBlocked(),
		getFunc = function() 
			return BSCAS:ExportBlocked()
		end,
		setFunc = function(value)
			PresetString = value
		end,
	})
	table.insert(optionsTable, {
		type = "button",
		name = GetString(SI_SYNERGY_NAME_PRE_IMP),
		func = function()			
			BSCAS:ImportBlocked(PresetString)
			PresetString = ""
		end,
		isDangerous = true,
		warning = GetString(SI_SYNERGY_NAME_PRE_W),
	})
end

local function AddUndauntedSetting()
	--Undaunted	
	local control = {}	
		
	AddTexture(control, ICON_UNDAUNTED_ALTAR_0, GetString(SI_SYNERGY_DESC_BLOODALTAR))		
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_BLOODALTAR), 
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ALTAR end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ALTAR = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ALTAR_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ALTAR_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	--
	table.insert(control, {
		type = "dropdown",
		name = GetString(SI_SYNERGY_NAME_HOTBAR),
		tooltip = GetString(SI_SYNERGY_MI_HOTBAR_INFO),
		disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ALTAR_IGCHK end,
        choices = {"ALL", "PRIMARY", "BACKUP"},		
		getFunc = function()
			if BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ALTAR_HBCHK == HOTBAR_CATEGORY_PRIMARY then
				return "PRIMARY" 
			elseif BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ALTAR_HBCHK == HOTBAR_CATEGORY_BACKUP then
				return "BACKUP"
			else			
				return "ALL" 
			end
		end,
		setFunc = function(v) 
			if v == "PRIMARY" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ALTAR_HBCHK = HOTBAR_CATEGORY_PRIMARY 
			elseif v == "BACKUP" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ALTAR_HBCHK = HOTBAR_CATEGORY_BACKUP 
			else
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ALTAR_HBCHK = -1 
			end			
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	---------------------------------------------------------------------------------------------------------------------------
	AddDivider(control)
	---------------------------------------------------------------------------------------------------------------------------	
	AddTexture(control, ICON_UNDAUNTED_WEBS_0, GetString(SI_SYNERGY_DESC_WEBS))
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_WEBS),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_WEBS end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_WEBS = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_WEBS_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_WEBS_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})	
	--
	table.insert(control, {
		type = "dropdown",
		name = GetString(SI_SYNERGY_NAME_HOTBAR),
		tooltip = GetString(SI_SYNERGY_MI_HOTBAR_INFO),
		disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_WEBS_IGCHK end,
        choices = {"ALL", "PRIMARY", "BACKUP"},		
		getFunc = function()
			if BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_WEBS_HBCHK == HOTBAR_CATEGORY_PRIMARY then
				return "PRIMARY" 
			elseif BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_WEBS_HBCHK == HOTBAR_CATEGORY_BACKUP then
				return "BACKUP"
			else			
				return "ALL" 
			end
		end,
		setFunc = function(v) 
			if v == "PRIMARY" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_WEBS_HBCHK = HOTBAR_CATEGORY_PRIMARY 
			elseif v == "BACKUP" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_WEBS_HBCHK = HOTBAR_CATEGORY_BACKUP 
			else
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_WEBS_HBCHK = -1 
			end			
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	---------------------------------------------------------------------------------------------------------------------------
	AddDivider(control)
	---------------------------------------------------------------------------------------------------------------------------	
	AddTexture(control, ICON_UNDAUNTED_FIRE_0, GetString(SI_SYNERGY_DESC_INNERFIRE))
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_INNERFIRE),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_FIRE end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_FIRE = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_FIRE_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_FIRE_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	--
	table.insert(control, {
		type = "dropdown",
		name = GetString(SI_SYNERGY_NAME_HOTBAR),
		tooltip = GetString(SI_SYNERGY_MI_HOTBAR_INFO),
		disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_FIRE_IGCHK end,
        choices = {"ALL", "PRIMARY", "BACKUP"},		
		getFunc = function()
			if BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_FIRE_HBCHK == HOTBAR_CATEGORY_PRIMARY then
				return "PRIMARY" 
			elseif BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_FIRE_HBCHK == HOTBAR_CATEGORY_BACKUP then
				return "BACKUP"
			else			
				return "ALL" 
			end
		end,
		setFunc = function(v) 
			if v == "PRIMARY" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_FIRE_HBCHK = HOTBAR_CATEGORY_PRIMARY 
			elseif v == "BACKUP" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_FIRE_HBCHK = HOTBAR_CATEGORY_BACKUP 
			else
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_FIRE_HBCHK = -1 
			end			
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	---------------------------------------------------------------------------------------------------------------------------
	AddDivider(control)
	---------------------------------------------------------------------------------------------------------------------------	
	AddTexture(control, ICON_UNDAUNTED_BONE_0, GetString(SI_SYNERGY_DESC_BONE))	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_BONE),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_BONE end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_BONE = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_BONE_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_BONE_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	--
	table.insert(control, {
		type = "dropdown",
		name = GetString(SI_SYNERGY_NAME_HOTBAR),
		tooltip = GetString(SI_SYNERGY_MI_HOTBAR_INFO),
		disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_BONE_IGCHK end,
        choices = {"ALL", "PRIMARY", "BACKUP"},		
		getFunc = function()
			if BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_BONE_HBCHK == HOTBAR_CATEGORY_PRIMARY then
				return "PRIMARY" 
			elseif BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_BONE_HBCHK == HOTBAR_CATEGORY_BACKUP then
				return "BACKUP"
			else			
				return "ALL" 
			end
		end,
		setFunc = function(v) 
			if v == "PRIMARY" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_BONE_HBCHK = HOTBAR_CATEGORY_PRIMARY 
			elseif v == "BACKUP" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_BONE_HBCHK = HOTBAR_CATEGORY_BACKUP 
			else
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_BONE_HBCHK = -1 
			end			
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	---------------------------------------------------------------------------------------------------------------------------
	AddDivider(control)
	---------------------------------------------------------------------------------------------------------------------------	
	AddTexture(control, ICON_UNDAUNTED_ORB_0, GetString(SI_SYNERGY_DESC_ORB))	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_ORB),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ORB end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ORB = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ORB_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ORB_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	--
	table.insert(control, {
		type = "dropdown",
		name = GetString(SI_SYNERGY_NAME_HOTBAR),
		tooltip = GetString(SI_SYNERGY_MI_HOTBAR_INFO),
		disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ORB_IGCHK end,
        choices = {"ALL", "PRIMARY", "BACKUP"},		
		getFunc = function()
			if BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ORB_HBCHK == HOTBAR_CATEGORY_PRIMARY then
				return "PRIMARY" 
			elseif BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ORB_HBCHK == HOTBAR_CATEGORY_BACKUP then
				return "BACKUP"
			else			
				return "ALL" 
			end
		end,
		setFunc = function(v) 
			if v == "PRIMARY" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ORB_HBCHK = HOTBAR_CATEGORY_PRIMARY 
			elseif v == "BACKUP" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ORB_HBCHK = HOTBAR_CATEGORY_BACKUP 
			else
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ORB_HBCHK = -1 
			end			
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	---------------------------------------------------------------------------------------------------------------------------
	AddDivider(control)
	---------------------------------------------------------------------------------------------------------------------------	
	AddTexture(control, ICON_UNDAUNTED_ORB_2, GetString(SI_SYNERGY_DESC_ORB2))	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_ORB2),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ORB_HEALING end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ORB_HEALING = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ORB_HEALING_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ORB_HEALING_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	--
	table.insert(control, {
		type = "dropdown",
		name = GetString(SI_SYNERGY_NAME_HOTBAR),
		tooltip = GetString(SI_SYNERGY_MI_HOTBAR_INFO),
		disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ORB_HEALING_IGCHK end,
        choices = {"ALL", "PRIMARY", "BACKUP"},		
		getFunc = function()
			if BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ORB_HEALING_HBCHK == HOTBAR_CATEGORY_PRIMARY then
				return "PRIMARY" 
			elseif BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ORB_HEALING_HBCHK == HOTBAR_CATEGORY_BACKUP then
				return "BACKUP"
			else			
				return "ALL" 
			end
		end,
		setFunc = function(v) 
			if v == "PRIMARY" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ORB_HEALING_HBCHK = HOTBAR_CATEGORY_PRIMARY 
			elseif v == "BACKUP" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ORB_HEALING_HBCHK = HOTBAR_CATEGORY_BACKUP 
			else
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].UNDAUNTED_ORB_HEALING_HBCHK = -1 
			end			
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})	
	---------------------------------------------------------------------------------------------------------------------------	
    table.insert(optionsTable, {
        type = "submenu",
		--tooltip = ""
        name = GetString(SI_SYNERGY_NAME_TREE_UNDAUNTED),
		controls = control,
    })
end
---------------------------------------------------------------------------------------------------------------------------
local function Class_Templar(control)
	--Templar
	table.insert(control, {
        type = "header",
        name = GetString(SI_SYNERGY_NAME_TREE_TEMPLAR),
    })
	AddTexture(control, ICON_TEMPLAR_SPEAR_2, GetString(SI_SYNERGY_DESC_SHARDS1))	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_SHARDS),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_SHARDS end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_SHARDS = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_SHARDS_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_SHARDS_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	--
	table.insert(control, {
		type = "dropdown",
		name = GetString(SI_SYNERGY_NAME_HOTBAR),
		tooltip = GetString(SI_SYNERGY_MI_HOTBAR_INFO),
		disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_SHARDS_IGCHK end,
        choices = {"ALL", "PRIMARY", "BACKUP"},		
		getFunc = function()
			if BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_SHARDS_HBCHK == HOTBAR_CATEGORY_PRIMARY then
				return "PRIMARY" 
			elseif BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_SHARDS_HBCHK == HOTBAR_CATEGORY_BACKUP then
				return "BACKUP"
			else			
				return "ALL" 
			end
		end,
		setFunc = function(v) 
			if v == "PRIMARY" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_SHARDS_HBCHK = HOTBAR_CATEGORY_PRIMARY 
			elseif v == "BACKUP" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_SHARDS_HBCHK = HOTBAR_CATEGORY_BACKUP 
			else
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_SHARDS_HBCHK = -1 
			end			
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	---------------------------------------------------------------------------------------------------------------------------
	AddDivider(control)
	---------------------------------------------------------------------------------------------------------------------------
	AddTexture(control, ICON_TEMPLAR_SPEAR_1, GetString(SI_SYNERGY_DESC_SHARDS))	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_SHARDS1),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_SHARDS_DMG end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_SHARDS_DMG = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})		
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_SHARDS_DMG_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_SHARDS_DMG_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	--
	table.insert(control, {
		type = "dropdown",
		name = GetString(SI_SYNERGY_NAME_HOTBAR),
		tooltip = GetString(SI_SYNERGY_MI_HOTBAR_INFO),
		disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_SHARDS_DMG_IGCHK end,
        choices = {"ALL", "PRIMARY", "BACKUP"},		
		getFunc = function()
			if BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_SHARDS_DMG_HBCHK == HOTBAR_CATEGORY_PRIMARY then
				return "PRIMARY" 
			elseif BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_SHARDS_DMG_HBCHK == HOTBAR_CATEGORY_BACKUP then
				return "BACKUP"
			else			
				return "ALL" 
			end
		end,
		setFunc = function(v) 
			if v == "PRIMARY" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_SHARDS_DMG_HBCHK = HOTBAR_CATEGORY_PRIMARY 
			elseif v == "BACKUP" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_SHARDS_DMG_HBCHK = HOTBAR_CATEGORY_BACKUP 
			else
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_SHARDS_DMG_HBCHK = -1 
			end			
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	---------------------------------------------------------------------------------------------------------------------------
	AddDivider(control)
	---------------------------------------------------------------------------------------------------------------------------
	AddTexture(control, ICON_TEMPLAR_RITUAL_0, GetString(SI_SYNERGY_DESC_PURGE))	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_PURGE),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_PURGE end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_PURGE = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_PURGE_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_PURGE_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	--
	table.insert(control, {
		type = "dropdown",
		name = GetString(SI_SYNERGY_NAME_HOTBAR), 
		tooltip = GetString(SI_SYNERGY_MI_HOTBAR_INFO),
		disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_PURGE_IGCHK end,
        choices = {"ALL", "PRIMARY", "BACKUP"},		
		getFunc = function()
			if BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_PURGE_HBCHK == HOTBAR_CATEGORY_PRIMARY then
				return "PRIMARY" 
			elseif BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_PURGE_HBCHK == HOTBAR_CATEGORY_BACKUP then
				return "BACKUP"
			else			
				return "ALL" 
			end
		end,
		setFunc = function(v) 
			if v == "PRIMARY" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_PURGE_HBCHK = HOTBAR_CATEGORY_PRIMARY 
			elseif v == "BACKUP" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_PURGE_HBCHK = HOTBAR_CATEGORY_BACKUP 
			else
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_PURGE_HBCHK = -1 
			end			
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	--table.insert(control, {
	--	type = "checkbox",
	--	name = "Smart Purge", --GetString(SI_SYNERGY_IGNORE), 
	--	tooltip = "", --GetString(SI_SYNERGY_IGNORE_TT),
	--	getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_NOVA_IGCHK end,
	--	setFunc = function(value) 
	--		BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_NOVA_IGCHK = value 
	--		BSCAS.UpdateSetting()
	--	end,
    --   width = "full",
	--})
	--
	---------------------------------------------------------------------------------------------------------------------------
	AddDivider(control)
	---------------------------------------------------------------------------------------------------------------------------
	AddTexture(control, ICON_TEMPLAR_NOVA_0, GetString(SI_SYNERGY_DESC_NOVA))	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_NOVA),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_NOVA end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_NOVA = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_NOVA_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_NOVA_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	--
	table.insert(control, {
		type = "dropdown",
		name = GetString(SI_SYNERGY_NAME_HOTBAR),
		tooltip = GetString(SI_SYNERGY_MI_HOTBAR_INFO),
		disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_NOVA_IGCHK end,
        choices = {"ALL", "PRIMARY", "BACKUP"},		
		getFunc = function()
			if BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_NOVA_HBCHK == HOTBAR_CATEGORY_PRIMARY then
				return "PRIMARY" 
			elseif BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_NOVA_HBCHK == HOTBAR_CATEGORY_BACKUP then
				return "BACKUP"
			else			
				return "ALL" 
			end
		end,
		setFunc = function(v) 
			if v == "PRIMARY" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_NOVA_HBCHK = HOTBAR_CATEGORY_PRIMARY 
			elseif v == "BACKUP" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_NOVA_HBCHK = HOTBAR_CATEGORY_BACKUP 
			else
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].TEMPLAR_NOVA_HBCHK = -1 
			end			
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
end
---------------------------------------------------------------------------------------------------------------------------
local function Class_Sorcerer(control)
	table.insert(control, {
        type = "header",
        name = GetString(SI_SYNERGY_NAME_TREE_SORC),
    })		
	AddTexture(control, ICON_SORC_CONDUIT_0, GetString(SI_SYNERGY_DESC_CONDUIT))	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_CONDUIT),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SORC_CONDUIT end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SORC_CONDUIT = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SORC_CONDUIT_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SORC_CONDUIT_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	--
	table.insert(control, {
		type = "dropdown",
		name = GetString(SI_SYNERGY_NAME_HOTBAR),
		tooltip = GetString(SI_SYNERGY_MI_HOTBAR_INFO),
		disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SORC_CONDUIT_IGCHK end,
        choices = {"ALL", "PRIMARY", "BACKUP"},		
		getFunc = function()
			if BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SORC_CONDUIT_HBCHK == HOTBAR_CATEGORY_PRIMARY then
				return "PRIMARY" 
			elseif BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SORC_CONDUIT_HBCHK == HOTBAR_CATEGORY_BACKUP then
				return "BACKUP"
			else			
				return "ALL" 
			end
		end,
		setFunc = function(v) 
			if v == "PRIMARY" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SORC_CONDUIT_HBCHK = HOTBAR_CATEGORY_PRIMARY 
			elseif v == "BACKUP" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SORC_CONDUIT_HBCHK = HOTBAR_CATEGORY_BACKUP 
			else
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SORC_CONDUIT_HBCHK = -1 
			end			
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	---------------------------------------------------------------------------------------------------------------------------
	AddDivider(control)
	---------------------------------------------------------------------------------------------------------------------------
	
	AddTexture(control, ICON_SORC_ATRO_0, GetString(SI_SYNERGY_DESC_ATRO))	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_ATRO),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SORC_ATRO end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SORC_ATRO = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SORC_ATRO_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SORC_ATRO_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	--
	table.insert(control, {
		type = "dropdown",
		name = GetString(SI_SYNERGY_NAME_HOTBAR),
		tooltip = GetString(SI_SYNERGY_MI_HOTBAR_INFO),
		disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SORC_ATRO_IGCHK end,
        choices = {"ALL", "PRIMARY", "BACKUP"},		
		getFunc = function()
			if BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SORC_ATRO_HBCHK == HOTBAR_CATEGORY_PRIMARY then
				return "PRIMARY" 
			elseif BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SORC_ATRO_HBCHK == HOTBAR_CATEGORY_BACKUP then
				return "BACKUP"
			else			
				return "ALL" 
			end
		end,
		setFunc = function(v) 
			if v == "PRIMARY" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SORC_ATRO_HBCHK = HOTBAR_CATEGORY_PRIMARY 
			elseif v == "BACKUP" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SORC_ATRO_HBCHK = HOTBAR_CATEGORY_BACKUP 
			else
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SORC_ATRO_HBCHK = -1 
			end			
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
end
---------------------------------------------------------------------------------------------------------------------------
local function Class_Dragonknight(control)
	table.insert(control, {
        type = "header",
        name = GetString(SI_SYNERGY_NAME_TREE_DK),
    })	
	AddTexture(control, ICON_DK_CLAW_0, GetString(SI_SYNERGY_DESC_IMPALE))	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_IMPALE),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DK_IMPALE end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DK_IMPALE = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DK_IMPALE_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DK_IMPALE_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	table.insert(control, {
		type = "dropdown",
		name = GetString(SI_SYNERGY_NAME_HOTBAR),
		tooltip = GetString(SI_SYNERGY_MI_HOTBAR_INFO),
		disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DK_IMPALE_IGCHK end,
        choices = {"ALL", "PRIMARY", "BACKUP"},		
		getFunc = function()
			if BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DK_STANDARTE_IGCHK == HOTBAR_CATEGORY_PRIMARY then
				return "PRIMARY" 
			elseif BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DK_STANDARTE_IGCHK == HOTBAR_CATEGORY_BACKUP then
				return "BACKUP"
			else			
				return "ALL" 
			end
		end,
		setFunc = function(v) 
			if v == "PRIMARY" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DK_STANDARTE_IGCHK = HOTBAR_CATEGORY_PRIMARY 
			elseif v == "BACKUP" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DK_STANDARTE_IGCHK = HOTBAR_CATEGORY_BACKUP 
			else
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DK_STANDARTE_IGCHK = -1 
			end			
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})	
	---------------------------------------------------------------------------------------------------------------------------
	AddDivider(control)
	---------------------------------------------------------------------------------------------------------------------------	
	AddTexture(control, ICON_DK_STANDARTE_0, GetString(SI_SYNERGY_DESC_STANDARTE))	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_STANDARTE),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DK_STANDARTE end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DK_STANDARTE = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DK_STANDARTE_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DK_STANDARTE_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	--
	table.insert(control, {
		type = "dropdown",
		name = GetString(SI_SYNERGY_NAME_HOTBAR),
		tooltip = GetString(SI_SYNERGY_MI_HOTBAR_INFO),
		disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DK_STANDARTE_IGCHK end,
        choices = {"ALL", "PRIMARY", "BACKUP"},		
		getFunc = function()
			if BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DK_STANDARTE_HBCHK == HOTBAR_CATEGORY_PRIMARY then
				return "PRIMARY" 
			elseif BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DK_STANDARTE_HBCHK == HOTBAR_CATEGORY_BACKUP then
				return "BACKUP"
			else			
				return "ALL" 
			end
		end,
		setFunc = function(v) 
			if v == "PRIMARY" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DK_STANDARTE_HBCHK = HOTBAR_CATEGORY_PRIMARY 
			elseif v == "BACKUP" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DK_STANDARTE_HBCHK = HOTBAR_CATEGORY_BACKUP 
			else
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DK_STANDARTE_HBCHK = -1 
			end			
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
end
---------------------------------------------------------------------------------------------------------------------------
local function Class_Nightblade(control)
	table.insert(control, {
        type = "header",
        name = GetString(SI_SYNERGY_NAME_TREE_NB),
    })	
	AddTexture(control, ICON_NB_HIDE_0, GetString(SI_SYNERGY_DESC_DARK))	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_DARK),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NB_DARK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NB_DARK = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NB_DARK_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NB_DARK_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	--
	table.insert(control, {
		type = "dropdown",
		name = GetString(SI_SYNERGY_NAME_HOTBAR),
		tooltip = GetString(SI_SYNERGY_MI_HOTBAR_INFO),
		disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NB_DARK_IGCHK end,
        choices = {"ALL", "PRIMARY", "BACKUP"},		
		getFunc = function()
			if BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NB_DARK_HBCHK == HOTBAR_CATEGORY_PRIMARY then
				return "PRIMARY" 
			elseif BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NB_DARK_HBCHK == HOTBAR_CATEGORY_BACKUP then
				return "BACKUP"
			else			
				return "ALL" 
			end
		end,
		setFunc = function(v) 
			if v == "PRIMARY" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NB_DARK_HBCHK = HOTBAR_CATEGORY_PRIMARY 
			elseif v == "BACKUP" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NB_DARK_HBCHK = HOTBAR_CATEGORY_BACKUP 
			else
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NB_DARK_HBCHK = -1 
			end			
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	---------------------------------------------------------------------------------------------------------------------------
	AddDivider(control)
	---------------------------------------------------------------------------------------------------------------------------	
	AddTexture(control, ICON_NB_SOUL_0, GetString(SI_SYNERGY_DESC_SOUL))	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_SOUL),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NB_SOUL end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NB_SOUL = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NB_SOUL_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NB_SOUL_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	--
	table.insert(control, {
		type = "dropdown",
		name = GetString(SI_SYNERGY_NAME_HOTBAR),
		tooltip = GetString(SI_SYNERGY_MI_HOTBAR_INFO),
		disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NB_SOUL_IGCHK end,
        choices = {"ALL", "PRIMARY", "BACKUP"},		
		getFunc = function()
			if BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NB_SOUL_HBCHK == HOTBAR_CATEGORY_PRIMARY then
				return "PRIMARY" 
			elseif BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NB_SOUL_HBCHK == HOTBAR_CATEGORY_BACKUP then
				return "BACKUP"
			else			
				return "ALL" 
			end
		end,
		setFunc = function(v) 
			if v == "PRIMARY" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NB_SOUL_HBCHK = HOTBAR_CATEGORY_PRIMARY 
			elseif v == "BACKUP" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NB_SOUL_HBCHK = HOTBAR_CATEGORY_BACKUP 
			else
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NB_SOUL_HBCHK = -1 
			end			
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
end
---------------------------------------------------------------------------------------------------------------------------
local function Class_Wardn(control)
	-- warden
	table.insert(control, {
        type = "header",
        name = GetString(SI_SYNERGY_NAME_TREE_WARDN),
    })	
	AddTexture(control, ICON_WARDEN_HARVEST_0, GetString(SI_SYNERGY_DESC_HARVEST))	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_HARVEST),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WARDEN_HARVEST end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WARDEN_HARVEST = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WARDEN_HARVEST_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WARDEN_HARVEST_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	--
	table.insert(control, {
		type = "dropdown",
		name = GetString(SI_SYNERGY_NAME_HOTBAR),
		tooltip = GetString(SI_SYNERGY_MI_HOTBAR_INFO),
		disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WARDEN_HARVEST_IGCHK end,
        choices = {"ALL", "PRIMARY", "BACKUP"},		
		getFunc = function()
			if BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WARDEN_HARVEST_HBCHK == HOTBAR_CATEGORY_PRIMARY then
				return "PRIMARY" 
			elseif BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WARDEN_HARVEST_HBCHK == HOTBAR_CATEGORY_BACKUP then
				return "BACKUP"
			else			
				return "ALL" 
			end
		end,
		setFunc = function(v) 
			if v == "PRIMARY" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WARDEN_HARVEST_HBCHK = HOTBAR_CATEGORY_PRIMARY 
			elseif v == "BACKUP" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WARDEN_HARVEST_HBCHK = HOTBAR_CATEGORY_BACKUP 
			else
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WARDEN_HARVEST_HBCHK = -1 
			end			
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	---------------------------------------------------------------------------------------------------------------------------
	AddDivider(control)
	---------------------------------------------------------------------------------------------------------------------------	
	AddTexture(control, ICON_WARDEN_ICE_0, GetString(SI_SYNERGY_DESC_ICYESC))	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_ICYESC),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WARDEN_ICYESC end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WARDEN_ICYESC = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WARDEN_ICYESC_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WARDEN_ICYESC_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	--
	table.insert(control, {
		type = "dropdown",
		name = GetString(SI_SYNERGY_NAME_HOTBAR),
		tooltip = GetString(SI_SYNERGY_MI_HOTBAR_INFO),
		disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WARDEN_ICYESC_IGCHK end,
        choices = {"ALL", "PRIMARY", "BACKUP"},		
		getFunc = function()
			if BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WARDEN_ICYESC_HBCHK == HOTBAR_CATEGORY_PRIMARY then
				return "PRIMARY" 
			elseif BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WARDEN_ICYESC_HBCHK == HOTBAR_CATEGORY_BACKUP then
				return "BACKUP"
			else			
				return "ALL" 
			end
		end,
		setFunc = function(v) 
			if v == "PRIMARY" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WARDEN_ICYESC_HBCHK = HOTBAR_CATEGORY_PRIMARY 
			elseif v == "BACKUP" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WARDEN_ICYESC_HBCHK = HOTBAR_CATEGORY_BACKUP 
			else
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WARDEN_ICYESC_HBCHK = -1 
			end			
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
end
---------------------------------------------------------------------------------------------------------------------------
local function Class_Necromance(control)
	-- Necro
	table.insert(control, {
        type = "header",
        name = GetString(SI_SYNERGY_NAME_TREE_NECRO),
    })
	AddTexture(control, ICON_NECRO_GRAVE_0, GetString(SI_SYNERGY_DESC_BONEYARD))	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_BONEYARD),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NECRO_BONEYARD end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NECRO_BONEYARD = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NECRO_BONEYARD_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NECRO_BONEYARD_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	table.insert(control, {
		type = "dropdown",
		name = GetString(SI_SYNERGY_NAME_HOTBAR), 
		tooltip = GetString(SI_SYNERGY_MI_HOTBAR_INFO),
		disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NECRO_BONEYARD_IGCHK end,
        choices = {"ALL", "PRIMARY", "BACKUP"},		
		getFunc = function()
			if BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NECRO_BONEYARD_HBCHK == HOTBAR_CATEGORY_PRIMARY then
				return "PRIMARY" 
			elseif BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NECRO_BONEYARD_HBCHK == HOTBAR_CATEGORY_BACKUP then
				return "BACKUP"
			else			
				return "ALL" 
			end
		end,
		setFunc = function(v) 
			if v == "PRIMARY" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NECRO_BONEYARD_HBCHK = HOTBAR_CATEGORY_PRIMARY 
			elseif v == "BACKUP" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NECRO_BONEYARD_HBCHK = HOTBAR_CATEGORY_BACKUP 
			else
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NECRO_BONEYARD_HBCHK = -1 
			end			
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	---------------------------------------------------------------------------------------------------------------------------
	AddDivider(control)
	---------------------------------------------------------------------------------------------------------------------------
	AddTexture(control, ICON_NECRO_TOTEM_0, GetString(SI_SYNERGY_DESC_TOTEM))	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_TOTEM),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NECRO_TOTEM end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NECRO_TOTEM = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NECRO_TOTEM_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NECRO_TOTEM_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	table.insert(control, {
		type = "dropdown",
		name = GetString(SI_SYNERGY_NAME_HOTBAR),
		tooltip = GetString(SI_SYNERGY_MI_HOTBAR_INFO),
		disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NECRO_TOTEM_IGCHK end,
        choices = {"ALL", "PRIMARY", "BACKUP"},		
		getFunc = function()
			if BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NECRO_TOTEM_HBCHK == HOTBAR_CATEGORY_PRIMARY then
				return "PRIMARY" 
			elseif BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NECRO_TOTEM_HBCHK == HOTBAR_CATEGORY_BACKUP then
				return "BACKUP"
			else			
				return "ALL" 
			end
		end,
		setFunc = function(v) 
			if v == "PRIMARY" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NECRO_TOTEM_HBCHK = HOTBAR_CATEGORY_PRIMARY 
			elseif v == "BACKUP" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NECRO_TOTEM_HBCHK = HOTBAR_CATEGORY_BACKUP 
			else
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].NECRO_TOTEM_HBCHK = -1 
			end			
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
end
---------------------------------------------------------------------------------------------------------------------------
local function Class_Arcanist(control)
	-- Necro
	table.insert(control, {
        type = "header",
        name = GetString(SI_SYNERGY_NAME_TREE_ARCANIST),
    })
	AddTexture(control, ICON_ARCANIST_RUNE, GetString(SI_SYNERGY_DESC_RUNE))	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_RUNE),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARCANIST_RUNE end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARCANIST_RUNE = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARCANIST_RUNE_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARCANIST_RUNE_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	table.insert(control, {
		type = "dropdown",
		name = GetString(SI_SYNERGY_NAME_HOTBAR),
		tooltip = GetString(SI_SYNERGY_MI_HOTBAR_INFO),
		disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARCANIST_RUNE_IGCHK end,
        choices = {"ALL", "PRIMARY", "BACKUP"},		
		getFunc = function()
			if BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARCANIST_RUNE_HBCHK == HOTBAR_CATEGORY_PRIMARY then
				return "PRIMARY" 
			elseif BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARCANIST_RUNE_HBCHK == HOTBAR_CATEGORY_BACKUP then
				return "BACKUP"
			else			
				return "ALL" 
			end
		end,
		setFunc = function(v) 
			if v == "PRIMARY" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARCANIST_RUNE_HBCHK = HOTBAR_CATEGORY_PRIMARY 
			elseif v == "BACKUP" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARCANIST_RUNE_HBCHK = HOTBAR_CATEGORY_BACKUP 
			else
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARCANIST_RUNE_HBCHK = -1 
			end			
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	---------------------------------------------------------------------------------------------------------------------------
	AddDivider(control)
	---------------------------------------------------------------------------------------------------------------------------
	AddTexture(control, ICON_ARCANIST_PORTAL, GetString(SI_SYNERGY_DESC_PORTAL))	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_PORTAL),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARCANIST_PORTAL end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARCANIST_PORTAL = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARCANIST_PORTAL_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARCANIST_PORTAL_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	table.insert(control, {
		type = "dropdown",
		name = GetString(SI_SYNERGY_NAME_HOTBAR),
		tooltip = GetString(SI_SYNERGY_MI_HOTBAR_INFO),
		disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARCANIST_PORTAL_IGCHK end,
        choices = {"ALL", "PRIMARY", "BACKUP"},		
		getFunc = function()
			if BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARCANIST_PORTAL_HBCHK == HOTBAR_CATEGORY_PRIMARY then
				return "PRIMARY" 
			elseif BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARCANIST_PORTAL_HBCHK == HOTBAR_CATEGORY_BACKUP then
				return "BACKUP"
			else			
				return "ALL" 
			end
		end,
		setFunc = function(v) 
			if v == "PRIMARY" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARCANIST_PORTAL_HBCHK = HOTBAR_CATEGORY_PRIMARY 
			elseif v == "BACKUP" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARCANIST_PORTAL_HBCHK = HOTBAR_CATEGORY_BACKUP 
			else
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARCANIST_PORTAL_HBCHK = -1 
			end			
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
end
---------------------------------------------------------------------------------------------------------------------------
local function AddClassesSetting()
	local control = {}		
	---------------------------------------------------------------------------------------------------------------------------
	Class_Templar(control) --Templar
	---------------------------------------------------------------------------------------------------------------------------
	Class_Sorcerer(control) --Sorc	
	---------------------------------------------------------------------------------------------------------------------------
	Class_Dragonknight(control) -- DK 
	---------------------------------------------------------------------------------------------------------------------------	
	Class_Nightblade(control) -- NB 
	---------------------------------------------------------------------------------------------------------------------------
	Class_Wardn(control) -- warden
	---------------------------------------------------------------------------------------------------------------------------
	Class_Necromance(control) -- Necro
	---------------------------------------------------------------------------------------------------------------------------
	if GetAPIVersion() > 101037 then
		Class_Arcanist(control) -- Arcanist
	end
	---------------------------------------------------------------------------------------------------------------------------
    table.insert(optionsTable, {
        type = "submenu",
		--tooltip = ""
        name = GetString(SI_SYNERGY_NAME_CLASSES),
		controls = control,
    })
end

local function Werwolf(control)
	-- Werwolf
	table.insert(control, {
        type = "header",
        name = GetString(SI_SYNERGY_NAME_TREE_WOLF),
    })
	AddTexture(control, ICON_WOLF, GetString(SI_SYNERGY_DESC_HUNT))	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_HUNT),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WW_HUNT end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WW_HUNT = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WW_HUNT_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WW_HUNT_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	table.insert(control, {
		type = "dropdown",
		name = GetString(SI_SYNERGY_NAME_HOTBAR),
		tooltip = GetString(SI_SYNERGY_MI_HOTBAR_INFO),
		disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WW_HUNT_IGCHK end,
        choices = {"ALL", "PRIMARY", "BACKUP"},		
		getFunc = function()
			if BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WW_HUNT_HBCHK == HOTBAR_CATEGORY_PRIMARY then
				return "PRIMARY" 
			elseif BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WW_HUNT_HBCHK == HOTBAR_CATEGORY_BACKUP then
				return "BACKUP"
			else			
				return "ALL" 
			end
		end,
		setFunc = function(v) 
			if v == "PRIMARY" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WW_HUNT_HBCHK = HOTBAR_CATEGORY_PRIMARY 
			elseif v == "BACKUP" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WW_HUNT_HBCHK = HOTBAR_CATEGORY_BACKUP 
			else
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WW_HUNT_HBCHK = -1 
			end			
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	---	
	AddTexture(control, ICON_WOLF_DEVOUR, GetString(SI_SYNERGY_DESC_DEVOUR))	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_DEVOUR),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WW_DEVOUR end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WW_DEVOUR = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WW_DEVOUR_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WW_DEVOUR_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	table.insert(control, {
		type = "dropdown",
		name = GetString(SI_SYNERGY_NAME_HOTBAR), 
		tooltip = GetString(SI_SYNERGY_MI_HOTBAR_INFO),
		disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WW_DEVOUR_IGCHK end,
        choices = {"ALL", "PRIMARY", "BACKUP"},		
		getFunc = function()
			if BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WW_DEVOUR_HBCHK == HOTBAR_CATEGORY_PRIMARY then
				return "PRIMARY" 
			elseif BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WW_DEVOUR_HBCHK == HOTBAR_CATEGORY_BACKUP then
				return "BACKUP"
			else			
				return "ALL" 
			end
		end,
		setFunc = function(v) 
			if v == "PRIMARY" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WW_DEVOUR_HBCHK = HOTBAR_CATEGORY_PRIMARY 
			elseif v == "BACKUP" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WW_DEVOUR_HBCHK = HOTBAR_CATEGORY_BACKUP 
			else
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].WW_DEVOUR_HBCHK = -1 
			end			
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
end

local function Vampier(control)
	-- Vampier
	table.insert(control, {
        type = "header",
        name = GetString(SI_SYNERGY_NAME_TREE_VAMP),
    })
	AddTexture(control, ICON_VAMP, GetString(SI_SYNERGY_DESC_EAT))	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_ABILITY_EAT),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].VAMP_EAT end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].VAMP_EAT = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].VAMP_EAT_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].VAMP_EAT_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	table.insert(control, {
		type = "dropdown",
		name = GetString(SI_SYNERGY_NAME_HOTBAR), 
		tooltip = GetString(SI_SYNERGY_MI_HOTBAR_INFO),
		disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].VAMP_EAT_IGCHK end,
        choices = {"ALL", "PRIMARY", "BACKUP"},		
		getFunc = function()
			if BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].VAMP_EAT_HBCHK == HOTBAR_CATEGORY_PRIMARY then
				return "PRIMARY" 
			elseif BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].VAMP_EAT_HBCHK == HOTBAR_CATEGORY_BACKUP then
				return "BACKUP"
			else			
				return "ALL" 
			end
		end,
		setFunc = function(v) 
			if v == "PRIMARY" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].VAMP_EAT_HBCHK = HOTBAR_CATEGORY_PRIMARY 
			elseif v == "BACKUP" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].VAMP_EAT_HBCHK = HOTBAR_CATEGORY_BACKUP 
			else
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].VAMP_EAT_HBCHK = -1 
			end			
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
end

local function AddTransformSetting()
	local control = {}	
	
	Werwolf(control)
	Vampier(control)
	
	-- Dark Brotherhood
	table.insert(control, {
        type = "header",
        name = GetString(SI_SYNERGY_NAME_TREE_BH),
    })
	AddTexture(control, ICON_BROTHERHOOD, GetString())	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_ABILITY_BH),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].HOOD_BLADE end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].HOOD_BLADE = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].HOOD_BLADE_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].HOOD_BLADE_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	table.insert(control, {
		type = "dropdown",
		name = GetString(SI_SYNERGY_NAME_HOTBAR),
		tooltip = GetString(SI_SYNERGY_MI_HOTBAR_INFO),
		disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].HOOD_BLADE_IGCHK end,
        choices = {"ALL", "PRIMARY", "BACKUP"},		
		getFunc = function()
			if BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].HOOD_BLADE_HBCHK == HOTBAR_CATEGORY_PRIMARY then
				return "PRIMARY" 
			elseif BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].HOOD_BLADE_HBCHK == HOTBAR_CATEGORY_BACKUP then
				return "BACKUP"
			else			
				return "ALL" 
			end
		end,
		setFunc = function(v) 
			if v == "PRIMARY" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].HOOD_BLADE_HBCHK = HOTBAR_CATEGORY_PRIMARY 
			elseif v == "BACKUP" then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].HOOD_BLADE_HBCHK = HOTBAR_CATEGORY_BACKUP 
			else
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].HOOD_BLADE_HBCHK = -1 
			end			
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	
	--
    table.insert(optionsTable, {
        type = "submenu",
		--tooltip = ""
        name = GetString(SI_SYNERGY_NAME_TRANSFORM),
		controls = control,
    })
end

local function AddRaidSetting()
	local control = {}	
	---------------------------------------------------------------------------------------------------------------------------
	-- CR
	table.insert(control, {
        type = "header",
		name = zo_strformat("<<1>>", GetZoneNameById(1051)),
    })
	AddTexture(control, ICON_VCR_GATE, GetString(SI_SYNERGY_DESC_GATEWAY))	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_ABILITY_GATEWAY),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].CR_PORTAL end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].CR_PORTAL = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})
	table.insert(control, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].CR_PORTAL end,
		name = GetString(SI_SYNERGY_DEBUFF_TRAIL_CR),
		tooltip = GetString(SI_SYNERGY_DEBUFF_TRAIL_CR_DESC),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].CR_PORTAL_BLOCK_DB end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].CR_PORTAL_BLOCK_DB = value 			
		end,
	})
	table.insert(control, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].CR_PORTAL end,
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].CR_PORTAL_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].CR_PORTAL_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	-- HRC
	table.insert(control, {
        type = "header",
		name = zo_strformat("<<1>>", GetZoneNameById(636)),
    })	
	AddTexture(control, ICON_HRC_BREAKOUT, GetString(SI_SYNERGY_ABILITY_DESTRUCTIVE_OUTBREAK))	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_DESTRUCTIVE_OUTBREAK),
		--tooltip = GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].HRC_CONFIRM end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].HRC_CONFIRM = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})	
	---------------------------------------------------------------------------------------------------------------------------
	-- SS
	table.insert(control, {
        type = "header",
		name = zo_strformat("<<1>>", GetZoneNameById(1121)),
    })
	AddTexture(control, ICON_VSS_TIMESHIFT, GetString(SI_SYNERGY_DESC_TIME_BREACH))	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_ABILITY_TIME_BREACH),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SS_PORTAL end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SS_PORTAL = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SS_PORTAL_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SS_PORTAL_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	---------------------------------------------------------------------------------------------------------------------------
	-- KA
	table.insert(control, {
        type = "header",
		name = zo_strformat("<<1>>", GetZoneNameById(1196)),
    })
	AddTexture(control, ICON_VKA_PORTAL, GetString(SI_SYNERGY_DESC_KA_PORTAL))
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_ABILITY_KA_PORTAL),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].KA_PORTAL end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].KA_PORTAL = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].KA_PORTAL_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].KA_PORTAL_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	---------------------------------------------------------------------------------------------------------------------------
	AddDivider(control)
	---------------------------------------------------------------------------------------------------------------------------	
	AddTexture(control, ICON_VKA_EXECRATION, GetString(SI_SYNERGY_DESC_KA_EXECRATION))
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_ABILITY_KA_EXECRATION),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].KA_EXECRATION end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].KA_EXECRATION = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].KA_EXECRATION_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].KA_EXECRATION_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	---------------------------------------------------------------------------------------------------------------------------
	-- RG
	table.insert(control, {
        type = "header",
		name = zo_strformat("<<1>>", GetZoneNameById(1263)),
    })	
	AddTexture(control, ICON_RG_BLOP, "")
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_ABILITY_RG_BLOP),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].RG_PURGE_BLOCK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].RG_PURGE_BLOCK = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})	
	table.insert(control, {
		type = "slider",
		name = GetString(SI_SYNERGY_CB_ENABLE_MS),
		tooltip = GetString(SI_SYNERGY_CB_ENABLE_TT_MS),
		disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].RG_PURGE_BLOCK end,
		min = 0,
		max = 4000,
		step = 100,
		default = 2000,	
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].RG_PURGE_BLOCK_CD end,
		setFunc = function(value) BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].RG_PURGE_BLOCK_CD = value end,
	})	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_CB_ALERT_BLOP),
		tooltip = GetString(SI_SYNERGY_CB_ALERT_BLOP_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].RG_PURGE_BLOCK_ALERT end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].RG_PURGE_BLOCK_ALERT = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].RG_PURGE_BLOCK_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].RG_PURGE_BLOCK_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	---------------------------------------------------------------------------------------------------------------------------
	-- DSR
	table.insert(control, {
        type = "header",
		name = zo_strformat("<<1>>", GetZoneNameById(1344)),
    })	
	AddTexture(control, ICON_DSR_SURGING_WATERS, GetString(SI_SYNERGY_DESC_DSR_SURGING_WATERS))
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_ABILITY_DSR_SURGING_WATERS),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DSR_SURGING_WATERS end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DSR_SURGING_WATERS = value 
			if BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DSR_SURGING_WATERS_BLOCK_DB then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DSR_SURGING_WATERS_BLOCK_DB = false
			end
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})	
	table.insert(control, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DSR_SURGING_WATERS end,
		name = GetString(SI_SYNERGY_DEBUFF_TRAIL_CR),
		tooltip = GetString(SI_SYNERGY_DEBUFF_TRAIL_CR_DESC),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DSR_SURGING_WATERS_BLOCK_DB end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DSR_SURGING_WATERS_BLOCK_DB = value 			
		end,
	})
	table.insert(control, {
		type = "slider",
		name = GetString(SI_SYNERGY_CB_ENABLE_S),
		tooltip = GetString(SI_SYNERGY_CB_ENABLE_TT_S),
		disabled = function() return not BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DSR_SURGING_WATERS_BLOCK_DB end,
		min = 0,
		max = 60,
		step = 1,
		default = 20,	
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DSR_SURGING_WATERS_CD end,
		setFunc = function(value) BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DSR_SURGING_WATERS_CD = value end,
	})		
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DSR_SURGING_WATERS_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].DSR_SURGING_WATERS_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	---------------------------------------------------------------------------------------------------------------------------
	-- SE
	table.insert(control, {
        type = "header",
		name = zo_strformat("<<1>>", GetZoneNameById(1427)),
    })	
	AddTexture(control, ICON_SE_VANTONS_CLARITY, GetString(SI_SYNERGY_DESC_SE_VANTONS_CLARITY))
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_ABILITY_SE_VANTONS_CLARITY),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SE_VANTONS_CLARITY end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SE_VANTONS_CLARITY = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SE_VANTONS_CLARITY_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SE_VANTONS_CLARITY_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	--
	AddDivider(control)
	--
	AddTexture(control, ICON_SE_ATTUNEMENT, GetString(SI_SYNERGY_DESC_SE_ATTUNEMENT))
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_ABILITY_SE_ATTUNEMENT),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SE_ATTUNEMENT end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SE_ATTUNEMENT = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SE_ATTUNEMENT_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].SE_ATTUNEMENT_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	---------------------------------------------------------------------------------------------------------------------------
	-- LC
	table.insert(control, {
        type = "header",
		name = zo_strformat("<<1>>", GetZoneNameById(1478)),
    })
	AddTexture(control, ICON_LC_MIRROR, GetString(SI_SYNERGY_DESC_LC_MIRROR))
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_ABILITY_LC_MIRROR),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].LC_MIRROR end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].LC_MIRROR = value 
			if BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].LC_MIRROR_BLOCK_DB then
				BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].LC_MIRROR_BLOCK_DB = false
			end
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})	
	table.insert(control, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].LC_MIRROR end,
		name = GetString(SI_SYNERGY_DEBUFF_TRAIL_CR),
		tooltip = GetString(SI_SYNERGY_DEBUFF_TRAIL_CR_DESC),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].LC_MIRROR_BLOCK_DB end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].LC_MIRROR_BLOCK_DB = value 			
		end,
	})
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].LC_MIRROR_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].LC_MIRROR_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})	
	--
    table.insert(optionsTable, {
        type = "submenu",
        name = GetString(SI_SYNERGY_NAME_RAID),
		controls = control,
    })
end

local function AddArenaSetting()
	local control = {}	
	-- Arena
	AddTexture(control, ICON_ARENA_RESURRECTION, GetString(SI_SYNERGY_DESC_RESURRECTION))	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_RESURRECTION),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		--disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_RESURRECTION_IGCHK end,
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_RESURRECTION end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_RESURRECTION = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_RESURRECTION_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_RESURRECTION_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	---------------------------------------------------------------------------------------------------------------------------
	AddDivider(control)
	---------------------------------------------------------------------------------------------------------------------------
	
	AddTexture(control, ICON_ARENA_DEFENSE, GetString(SI_SYNERGY_DESC_DEFENSE))	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_DEFENSE),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		--disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_DEFENSE_IGCHK end,
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_DEFENSE end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_DEFENSE = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_DEFENSE_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_DEFENSE_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	---------------------------------------------------------------------------------------------------------------------------
	AddDivider(control)
	---------------------------------------------------------------------------------------------------------------------------
	
	AddTexture(control, ICON_ARENA_HEALING, GetString(SI_SYNERGY_DESC_HEALING))	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_HEALING),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		--disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_HEALING_IGCHK end,
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_HEALING end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_HEALING = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_HEALING_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_HEALING_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	---------------------------------------------------------------------------------------------------------------------------
	AddDivider(control)
	---------------------------------------------------------------------------------------------------------------------------
	
	AddTexture(control, ICON_ARENA_SUSTAIN, GetString(SI_SYNERGY_DESC_SUSTAIN))	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_SUSTAIN),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		--disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_SUSTAIN_IGCHK end,
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_SUSTAIN end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_SUSTAIN = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_SUSTAIN_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_SUSTAIN_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	---------------------------------------------------------------------------------------------------------------------------
	AddDivider(control)
	---------------------------------------------------------------------------------------------------------------------------
	
	AddTexture(control, ICON_ARENA_POWER, GetString(SI_SYNERGY_DESC_POWER))	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_POWER),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		--disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_POWER_IGCHK end,
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_POWER end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_POWER = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_POWER_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_POWER_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	---------------------------------------------------------------------------------------------------------------------------
	AddDivider(control)
	---------------------------------------------------------------------------------------------------------------------------
	
	AddTexture(control, ICON_ARENA_SPEED, GetString(SI_SYNERGY_DESC_HASTE))	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_NAME_HASTE),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		--disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_HASTE_IGCHK end,
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_HASTE end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_HASTE = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_HASTE_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ARENA_HASTE_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	
	--
    table.insert(optionsTable, {
        type = "submenu",
		--tooltip = ""
        name = GetString(SI_SYNERGY_NAME_ARENA),
		controls = control,
    })
end

local function AddItemSetting()	
	local control = {}
	--
	AddTexture(control, ICON_ITEM_URSUS, GetString(SI_SYNERGY_ITEM_DESC_URSUS))	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_ITEM_NAME_URSUS),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		--disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ITEM_URSUS_IGCHK end,
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ITEM_URSUS end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ITEM_URSUS = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ITEM_URSUS_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ITEM_URSUS_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	---------------------------------------------------------------------------------------------------------------------------
	AddDivider(control)
	---------------------------------------------------------------------------------------------------------------------------
	
	--
	AddTexture(control, ICON_ITEM_KRAGLEN, GetString(SI_SYNERGY_ITEM_DESC_KRAGLEN))	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_ITEM_NAME_KRAGLEN),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		--disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ITEM_KRAGLEN_IGCHK end,
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ITEM_KRAGLEN end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ITEM_KRAGLEN = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ITEM_KRAGLEN_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ITEM_KRAGLEN_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	---------------------------------------------------------------------------------------------------------------------------
	AddDivider(control)
	---------------------------------------------------------------------------------------------------------------------------
	
	--
	AddTexture(control, ICON_ITEM_SANGUINE, GetString(SI_SYNERGY_ITEM_DESC_SANGUINE))	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_ITEM_NAME_SANGUINE),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		--disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ITEM_SANGUINE_IGCHK end,
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ITEM_SANGUINE end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ITEM_SANGUINE = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ITEM_SANGUINE_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ITEM_SANGUINE_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	---------------------------------------------------------------------------------------------------------------------------
	AddDivider(control)
	---------------------------------------------------------------------------------------------------------------------------	
	AddTexture(control, ICON_ITEM_SANGUINE, GetString(SI_SYNERGY_ITEM_DESC_GPREPRISAL))	
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_ITEM_NAME_GPREPRISAL),
		tooltip = GetString(SI_SYNERGY_TOOLTIP),
		--disabled = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ITEM_GPREPRISAL_IGCHK end,
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ITEM_GPREPRISAL end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ITEM_GPREPRISAL = value 
			BSCAS.UpdateSetting()
		end,
        width = "half",
	})
	table.insert(control, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_IGNORE), 
		tooltip = GetString(SI_SYNERGY_IGNORE_TT),
		getFunc = function() return BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ITEM_GPREPRISAL_IGCHK end,
		setFunc = function(value) 
			BSCAS.SV_acc.SETTING[BSCAS.SV.SELECTED_PRESET].ITEM_GPREPRISAL_IGCHK = value 
			BSCAS.UpdateSetting()
		end,
        width = "full",
	})
	
	
	--
    table.insert(optionsTable, {
        type = "submenu",
		--tooltip = ""
        name = GetString(SI_SYNERGY_NAME_ITEMS),
		controls = control,
    })
end

local function AddAutoLoadPreset()
	table.insert(optionsTable, {
        type = "header",
		name = GetString(SI_SYNERGY_NAME_PRE).." - ".. GetString(SI_GROUP_LIST_PANEL_PREFERRED_ROLES_LABEL).." (Default = no change)",--,
    })	
	--------------------------------------
	table.insert(optionsTable, {
		type = 'dropdown',
		name = "|t23:23:EsoUI/Art/LFG/LFG_tank_up_64.dds|t|r"..GetString("SI_LFGROLE", LFG_ROLE_TANK),
		choices = BSCAS:GetListNames(),
		getFunc = function() return BSCAS.SV.SELECTED_PRESET_TANK end,
		setFunc = function(value)
			BSCAS.SV.SELECTED_PRESET_TANK = value
			if GetSelectedLFGRole() == LFG_ROLE_TANK then
				CHAT_ROUTER:AddSystemMessage(zo_strformat("|cFFFFFF BSCs-AS Loading "..GetString("SI_LFGROLE", LFG_ROLE_TANK).." "..GetString(SI_SYNERGY_NAME_PRE)..": <<1>>|r", value))
				BSCAS.PlaySound(1, SOUNDS.CHAMPION_RESPEC_ACCEPT)
				BSCAS.SV.SELECTED_PRESET = value
				BSCAS.UpdateSetting()
			end
		end,
		scrollable = 12,
		reference = "BSCAS_PresetDropdownTank",
	})
	--------------------------------------
	table.insert(optionsTable, {
		type = 'dropdown',
		name = "|t23:23:EsoUI/Art/LFG/LFG_healer_up_64.dds|t|r"..GetString("SI_LFGROLE", LFG_ROLE_HEAL),
		choices = BSCAS:GetListNames(),
		getFunc = function() return BSCAS.SV.SELECTED_PRESET_HEAL end,
		setFunc = function(value)
			BSCAS.SV.SELECTED_PRESET_HEAL = value
			if GetSelectedLFGRole() == LFG_ROLE_HEAL then
				CHAT_ROUTER:AddSystemMessage(zo_strformat("|cFFFFFF BSCs-AS Loading "..GetString("SI_LFGROLE", LFG_ROLE_HEAL).." "..GetString(SI_SYNERGY_NAME_PRE)..": <<1>>|r", value))
				BSCAS.PlaySound(1, SOUNDS.CHAMPION_RESPEC_ACCEPT)
				BSCAS.SV.SELECTED_PRESET = value
				BSCAS.UpdateSetting()
			end
		end,
		scrollable = 12,
		reference = "BSCAS_PresetDropdownHeal",
	})
	--------------------------------------
	table.insert(optionsTable, {
		type = 'dropdown',
		name = "|t23:23:EsoUI/Art/LFG/LFG_dps_up_64.dds|t|r"..GetString("SI_LFGROLE", LFG_ROLE_DPS),
		choices = BSCAS:GetListNames(),
		getFunc = function() return BSCAS.SV.SELECTED_PRESET_DPS end,
		setFunc = function(value)
			BSCAS.SV.SELECTED_PRESET_DPS = value
			if GetSelectedLFGRole() == LFG_ROLE_DPS then
				CHAT_ROUTER:AddSystemMessage(zo_strformat("|cFFFFFF BSCs-AS Loading "..GetString("SI_LFGROLE", LFG_ROLE_DPS).." "..GetString(SI_SYNERGY_NAME_PRE)..": <<1>>|r", value))
				BSCAS.PlaySound(1, SOUNDS.CHAMPION_RESPEC_ACCEPT)
				BSCAS.SV.SELECTED_PRESET = value
				BSCAS.UpdateSetting()
			end
		end,
		scrollable = 12,
		reference = "BSCAS_PresetDropdownDps",
	})	
end

--
function BSCAS.InitBlockMenu()
	-- the panel for the addons menu
	local panelData = {
		type = "panel",
		name = BSCAS.NameMenu.."1. Blocking",
		displayName = BSCAS.NameSpaced.." - Blocking",
		author = BSCAS.Author,
		version = BSCAS.VersionDisplay,
		registerForRefresh = true,
		slashCommand = "/bscasb",
	}	
	
	for k, v in pairs(BSCAS.SOUNDLIST) do
		table.insert(s_choices, v)
		table.insert(s_sounds, k)
	end
	
	AddSendFeedBack()

	-- Testing
	--AddTestingSetting()
	-- Char settings
	AddBaseSetting()	
	AddAutoLoadPreset()
	-- accwide settings below
	AddPresetSetting()
	AddSpecialSets()
	AddResourceSetting()
	AddUndauntedSetting()
	AddClassesSetting()
    AddTransformSetting()
	AddRaidSetting()
	AddArenaSetting()
	AddItemSetting()
		
    local addonpanel = LibAddonMenu2:RegisterAddonPanel(BSCAS.NameSpaced.."Blocking", panelData)
    LibAddonMenu2:RegisterOptionControls(BSCAS.NameSpaced.."Blocking", optionsTable)
		
	CALLBACK_MANAGER:RegisterCallback("LAM-PanelOpened", function(currentpanel) if addonpanel == currentpanel then BSCASUIAlert:SetHidden(false) BSCASUIAlert:SetMovable(true) end end )
	CALLBACK_MANAGER:RegisterCallback("LAM-PanelClosed", function(currentpanel) if addonpanel == currentpanel then BSCASUIAlert:SetHidden(true) BSCASUIAlert:SetMovable(false) end end )
end