BSCASynergy = BSCASynergy or {}
local BSCAS = BSCASynergy

local M_SLAYPER_PLAY_SOUND = false
local M_SLAYER_TIME_START = 0
local M_SLAYER_TIME_END = 0
local MAX_FILL_WIDTH = 0

local bUpdateUI = true
--
local debug_mode = false
function BSCAS.MSlayerDebugMode()
	if debug_mode then
		debug_mode = false
		BSCAS:PrintDebug("Debug Mode (Slayer) Disabled!")
	else
		debug_mode = true
		BSCAS:PrintDebug("Debug Mode (Slayer) Enabled!")
	end
end

function BSCAS.MSlayerUpdateUI()	
	-- Restore icon text Size etc
	-------------------------------------------------------------------------------------------------------------------------
	-- BackFrame "border"
	local UIFrame = BSCASMSlayerUI:GetNamedChild("Frame")
	UIFrame:SetHidden(false)
	UIFrame:SetDimensions(BSCAS.SV.UIMS_WIDTH, BSCAS.SV.UIMS_HIGHT)
	-------------------------------------------------------------------------------------------------------------------------
	-- icon of the buff if enabled
	local UIIcon = BSCASMSlayerUI:GetNamedChild("Icon")
	if BSCAS.SV.MSLAYER_ENABLE_ICON then	
		UIIcon:SetHidden(false)
	else
		UIIcon:SetHidden(true)		
	end
	UIIcon:SetTexture(GetAbilityIcon(BSCAS.LOKKE_ID))	
	UIIcon:SetDimensions(BSCAS.SV.UIMS_HIGHT -4, BSCAS.SV.UIMS_HIGHT -4) -- 2 border
	-------------------------------------------------------------------------------------------------------------------------
	-- BuffName text	
	local UIBuffName = BSCASMSlayerUI:GetNamedChild("BuffName")
	UIBuffName:ClearAnchors()
	if BSCAS.SV.MSLAYER_ENABLE_ICON then	
		UIBuffName:SetAnchor(LEFT, UIIcon, RIGHT, 8, 0)
	else
		UIBuffName:SetAnchor(LEFT, UIFrame, LEFT, 8, 0)
	end
	if BSCAS.SV.MSLAYER_ENABLE_NAME then
		UIBuffName:SetHidden(false)
	else
		UIBuffName:SetHidden(true)
	end
	UIBuffName:SetFont("$(MEDIUM_FONT)|$(KB_" .. BSCAS.FontCheck(math.floor(BSCAS.SV.UIMS_HIGHT / 2)) .. ")|soft-shadow-thin")	
	UIBuffName:SetDimensions(200, BSCAS.SV.UIMS_HIGHT -4)
	UIBuffName:SetText(zo_strformat("<<1>>", GetAbilityName(BSCAS.LOKKE_ID)))
	-------------------------------------------------------------------------------------------------------------------------
	-- cooldown text
	local UICooldown = BSCASMSlayerUI:GetNamedChild("Cooldown")
	UICooldown:ClearAnchors()
	UICooldown:SetAnchor(RIGHT, UIFrame, RIGHT, -10, 0)	
	UICooldown:SetHidden(false)
	UICooldown:SetFont("$(BOLD_FONT)|$(KB_" .. BSCAS.FontCheck(math.floor(BSCAS.SV.UIMS_HIGHT / 2)) .. ")|soft-shadow-thick")
	UICooldown:SetText(string.format("%.1fs", 0))		
	UICooldown:SetDimensions(64, BSCAS.SV.UIMS_HIGHT -4) 	
	-------------------------------------------------------------------------------------------------------------------------
	-- StatusBar
	local UIFill = BSCASMSlayerUI:GetNamedChild("Fill")
	UIFill:ClearAnchors()
	UIFill:SetHidden(false)
	if BSCAS.SV.MSLAYER_ENABLE_ICON then
		MAX_FILL_WIDTH = BSCAS.SV.UIMS_WIDTH - BSCAS.SV.UIMS_HIGHT
		UIFill:SetAnchor(LEFT, UIIcon, RIGHT, 0, 0)
	else
		MAX_FILL_WIDTH = BSCAS.SV.UIMS_WIDTH -4
		UIFill:SetAnchor(LEFT, UIFrame, LEFT, 2, 0)
	end
	UIFill:SetDimensions(MAX_FILL_WIDTH, BSCAS.SV.UIMS_HIGHT -4) -- clear it	
	UIFill:SetCenterColor(255, 0, 0, 0.40)
	-------------------------------------------------------------------------------------------------------------------------
		
	BSCASMSlayerUI:SetAlpha(BSCAS.SV.UIMS_ALPHA)
end

local function ToggleUI(oldState, newState)
	if not BSCAS.SV.MSLAYER_CHECK then return end

	if newState == SCENE_SHOWN and not BSCAS.SV.MSLAYER_ENABLE_AUTO_HIDE then
		BSCASMSlayerUI:SetHidden(false)
	elseif newState == SCENE_HIDDEN then
		BSCASMSlayerUI:SetHidden(true)
	end
end
function BSCAS.MSlayerOnMoveStop()
	BSCAS.SV.UIMS_LEFT = BSCASMSlayerUI:GetLeft()
	BSCAS.SV.UIMS_TOP = BSCASMSlayerUI:GetTop()
end
local function RestorePosition()
	-- Position
	BSCASMSlayerUI:ClearAnchors()
	BSCASMSlayerUI:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, BSCAS.SV.UIMS_LEFT, BSCAS.SV.UIMS_TOP)
	BSCASMSlayerUI:SetMovable(not BSCAS.SV.MSLAYER_LOCK_UI)
end
-- EVENT_EFFECT_CHANGED (eventCode, changeType, effectSlot, effectName, unitTag, beginTime, endTime, stackCount, iconName, buffType, effectType, abilityType, statusEffectType, unitName, unitId, abilityId, sourceType)
local function OnEffectChanged( _, changeType, _, _, unitTag, beginTime, endTime, _, _, _, _, _, _, unitName, unitId, abilityId, _)
	if changeType == EFFECT_RESULT_FADED then			
		M_SLAYER_TIME_START = 0
		M_SLAYER_TIME_END = 0
		M_SLAYPER_PLAY_SOUND = false	
	elseif changeType == EFFECT_RESULT_UPDATED then	
		M_SLAYER_TIME_START = beginTime
		M_SLAYER_TIME_END = endTime
		M_SLAYPER_PLAY_SOUND = true					
		bUpdateUI = true
	end	
	if debug_mode then
		BSCAS:PrintDebug(zo_strformat("ID[<<1>>] Name[<<2>>] changeType[<<3>>]", abilityId, GetAbilityName(abilityId), changeType))
	end
end
local function UpdateCooldown()	
	local M_SLAYER_DURATION = M_SLAYER_TIME_END - (GetGameTimeMilliseconds()/1000)	
	if not bUpdateUI then return end	
	if M_SLAYER_DURATION <= 0 then M_SLAYER_DURATION = 0 end

	local M_SLAYER_UI_FILL = MAX_FILL_WIDTH
	local BG_R = 255
	local BG_G = 0
	
	if M_SLAYER_DURATION > 0 then 
		if BSCAS.SV.MSLAYER_ENABLE_AUTO_HIDE then BSCASMSlayerUI:SetHidden(false) end
		M_SLAYER_UI_FILL = M_SLAYER_DURATION/(M_SLAYER_TIME_END-M_SLAYER_TIME_START) * MAX_FILL_WIDTH
		if M_SLAYER_UI_FILL < 0 then M_SLAYER_UI_FILL = 0 end
		BG_R = (M_SLAYER_UI_FILL > (MAX_FILL_WIDTH / 2) and (M_SLAYER_UI_FILL *2/(MAX_FILL_WIDTH / 4))) or 1
		BG_G = (M_SLAYER_UI_FILL < (MAX_FILL_WIDTH / 2) and (M_SLAYER_UI_FILL *2/(MAX_FILL_WIDTH / 3))) or 1		
	else
		bUpdateUI = false
		if BSCAS.SV.MSLAYER_ENABLE_AUTO_HIDE then BSCASMSlayerUI:SetHidden(true) end
	end		
	BSCASMSlayerUI:GetNamedChild("Cooldown"):SetText(string.format("%.1fs", M_SLAYER_DURATION))		
	BSCASMSlayerUI:GetNamedChild("Fill"):SetWidth(M_SLAYER_UI_FILL)
	BSCASMSlayerUI:GetNamedChild("Fill"):SetCenterColor(BG_R, BG_G, 0, 0.60)
	
	-- sound
	if M_SLAYER_DURATION <= BSCAS.SV.MSLAYER_SOUND_INC and BSCAS.SV.MSLAYER_SOUND_PLAY then	
		if M_SLAYPER_PLAY_SOUND == true then
			M_SLAYPER_PLAY_SOUND = false			
			BSCAS.PlaySound(BSCAS.SV.MSLAYER_SOUND_LOOP, BSCAS.SV.MSLAYER_SOUND_ID) 				
		end
	end
end

function BSCAS.MSlayerEnable()	
	if BSCAS.SV.MSLAYER_CHECK then 
		for abilityId in pairs(BSCAS.SLAYER_IDS) do
			local eventName = 'BSCAS_MSOEC'..abilityId
			EVENT_MANAGER:RegisterForEvent(eventName, EVENT_EFFECT_CHANGED, OnEffectChanged)
			EVENT_MANAGER:AddFilterForEvent(eventName, EVENT_EFFECT_CHANGED, REGISTER_FILTER_ABILITY_ID, abilityId)
			EVENT_MANAGER:AddFilterForEvent(eventName, EVENT_EFFECT_CHANGED, REGISTER_FILTER_UNIT_TAG, 'player')
		end
		--
		EVENT_MANAGER:RegisterForUpdate('BSCAS_MSlayerUpdate', BSCAS.UPDATE_INTERVAL, UpdateCooldown)
	else
		for abilityId in pairs(BSCAS.SLAYER_IDS) do
			local eventName = 'BSCAS_MSOEC'..abilityId
			EVENT_MANAGER:UnregisterForEvent(eventName, EVENT_EFFECT_CHANGED)
		end
		EVENT_MANAGER:UnregisterForUpdate('BSCAS_MSlayerUpdate')
	end	
end

function BSCAS.MSlayerInit()	
	-- Build the menu
	BSCAS.InitMSlayerMenu()
	--
	RestorePosition()
	BSCAS.MSlayerUpdateUI()	
	--
	SCENE_MANAGER:GetScene("hud"):RegisterCallback("StateChange", ToggleUI)
	SCENE_MANAGER:GetScene("hudui"):RegisterCallback("StateChange", ToggleUI)
	--
	if BSCAS.SV.MSLAYER_CHECK then BSCASMSlayerUI:SetHidden(false) else BSCASMSlayerUI:SetHidden(true) end
	--
	BSCAS.MSlayerEnable()
end