BSCASynergy = BSCASynergy or {}
local BSCAS = BSCASynergy

local optionsTable = {}
local s_sounds = { }
local s_choices = { }

local function AddSendFeedBack()
    table.insert(optionsTable, {
        type = "button",
        name = "Donate",
        tooltip = "Main - EU Server",
        func = function()
              local function PrefillMail()
                ZO_MailSendToField:SetText(BSCAS.Author)
                ZO_MailSendSubjectField:SetText(BSCAS.NameSpaced)
                ZO_MailSendBodyField:TakeFocus()
              end
                SCENE_MANAGER:Show('mailSend')
                zo_callLater(PrefillMail, 250)
        end,
        width = "half",
        warning = "",	
    })
end

local function ShowBSCASUIMS()
	if BSCASMSlayerUI:IsHidden() then BSCASMSlayerUI:SetHidden(false) else BSCASMSlayerUI:SetHidden(true) end
end

local function AddMSlayerSetting()	
	table.insert(optionsTable, {
        type = "header",
        name = GetString(SI_SYNERGY_NAME_MSLAYER),
    })
			
	-- slayer
	table.insert(optionsTable, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_MSLAYERUI),
		tooltip = "", --GetString(SI_SYNERGY_TOOLTIP),
		getFunc = function() return BSCAS.SV.MSLAYER_CHECK end,
		setFunc = function(value) 
			BSCAS.SV.MSLAYER_CHECK = value
			BSCAS.MSlayerUpdateUI() -- new
			BSCAS.MSlayerEnable()
		end,
	})
	-- UI
	--table.insert(optionsTable, {
	--	type = "button",
	--	disabled = function() return not BSCAS.SV.MSLAYER_CHECK end,
	--	name = GetString(SI_SYNERGY_UI_SHOW),
	--	func = ShowBSCASUIMS,
	--})
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.MSLAYER_CHECK end,
		name = GetString(SI_SYNERGY_UI_LOCK),
		getFunc = function() return BSCAS.SV.MSLAYER_LOCK_UI end,
		setFunc = function(v) 
			BSCAS.SV.MSLAYER_LOCK_UI = v
			BSCASMSlayerUI:SetMovable(not BSCAS.SV.MSLAYER_LOCK_UI)
		end,
	})	
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.MSLAYER_CHECK end,
		name = GetString(SI_SYNERGY_SLAYER_HIDE),
		getFunc = function() return BSCAS.SV.MSLAYER_ENABLE_AUTO_HIDE end,
		setFunc = function(v) 
			BSCAS.SV.MSLAYER_ENABLE_AUTO_HIDE = v
		end,	
	})		
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.MSLAYER_CHECK end,
		name = GetString(SI_SYNERGY_SLAYER_DNAME),
		getFunc = function() return BSCAS.SV.MSLAYER_ENABLE_NAME end,
		setFunc = function(value) 
			BSCAS.SV.MSLAYER_ENABLE_NAME = value
			BSCAS.MSlayerUpdateUI() -- new
		end,
	})	
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.MSLAYER_CHECK end,
		name = GetString(SI_SYNERGY_SLAYER_DICON),
		getFunc = function() return BSCAS.SV.MSLAYER_ENABLE_ICON end,
		setFunc = function(value) 
			BSCAS.SV.MSLAYER_ENABLE_ICON = value
			BSCAS.MSlayerUpdateUI() -- new
		end,
	})	
	table.insert(optionsTable, {
		type = "slider",
		disabled = function() return not BSCAS.SV.MSLAYER_CHECK end,
		name = GetString(SI_SYNERGY_UI_WIDTH),
		tooltip = "",
		min = 100,
		max = 600,
		step = 1,
		default = 1,	
		getFunc = function() return BSCAS.SV.UIMS_WIDTH end,
		setFunc = function(value)
			BSCAS.SV.UIMS_WIDTH = value
			BSCAS.MSlayerUpdateUI() -- new
		end,
	})
	table.insert(optionsTable, {
		type = "slider",
		disabled = function() return not BSCAS.SV.MSLAYER_CHECK end,
		name = GetString(SI_SYNERGY_UI_HIGHT),
		tooltip = "",
		min = 20,
		max = 250,
		step = 1,
		default = 1,	
		getFunc = function() return BSCAS.SV.UIMS_HIGHT end,
		setFunc = function(value)
			BSCAS.SV.UIMS_HIGHT = value
			BSCAS.MSlayerUpdateUI() -- new
		end,
	})
	table.insert(optionsTable, {
		type = "slider",
		disabled = function() return not BSCAS.SV.MSLAYER_CHECK end,
		name = GetString(SI_SYNERGY_UI_ALPHA),
		tooltip = "",
		min = 0.1,
		max = 1,
		step = 0.1,
		default = 1,	
		getFunc = function() return BSCAS.SV.UIMS_ALPHA end,
		setFunc = function(value)
			BSCAS.SV.UIMS_ALPHA = value
			BSCAS.MSlayerUpdateUI() -- new
		end,
	})	
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.MSLAYER_CHECK end,
		name = GetString(SI_SYNERGY_NAME_SOUND_ON_OFF),
		getFunc = function() return BSCAS.SV.MSLAYER_SOUND_PLAY end,
		setFunc = function(value) 
			BSCAS.SV.MSLAYER_SOUND_PLAY = value
			BSCAS.MSlayerUpdateUI() -- new
		end,
	})
	--
	table.insert( optionsTable, { 
		type = "dropdown", 
		disabled = function() return not BSCAS.SV.MSLAYER_CHECK or not BSCAS.SV.MSLAYER_SOUND_PLAY end,
		name = GetString(SI_SYNERGY_NAME_SOUND_CHOOSE),
		choices = s_choices,
		getFunc = function()
			for i = 1, #s_sounds do
				if s_sounds[i] == BSCAS.SV.MSLAYER_SOUND_ID then return s_choices[i] end
			end
			return "Duel_Accepted"
		end,
		setFunc = function(value)
			for i = 1, #s_choices do
				if s_choices[i] == value then
					BSCAS.SV.MSLAYER_SOUND_ID = s_sounds[i]
					BSCAS.PlaySound(BSCAS.SV.MSLAYER_SOUND_LOOP, BSCAS.SV.MSLAYER_SOUND_ID)
					return
				end
			end
		end,
		scrollable = 12,
		default = "Duel_Accepted",
	})	
	table.insert(optionsTable, {
		type = "slider",
		disabled = function() return not BSCAS.SV.MSLAYER_CHECK or not BSCAS.SV.MSLAYER_SOUND_PLAY end,
		name = GetString(SI_SYNERGY_SOUND_VOLL),
		min = 1,
		max = 10,
		step = 1,
		default = 1,	
		getFunc = function() return BSCAS.SV.MSLAYER_SOUND_LOOP end,
		setFunc = function(value)
			BSCAS.SV.MSLAYER_SOUND_LOOP = value
		end,
	})
	table.insert(optionsTable, {
		 type = "button",
		 disabled = function() return not BSCAS.SV.MSLAYER_CHECK or not BSCAS.SV.MSLAYER_SOUND_PLAY end,
		 name = GetString(SI_SYNERGY_SOUND_TEST),
		 func = function(value)
			  BSCAS.PlaySound(BSCAS.SV.MSLAYER_SOUND_LOOP, BSCAS.SV.MSLAYER_SOUND_ID)
		 end,
	})
	table.insert(optionsTable, {
		type = "slider",
		disabled = function() return not BSCAS.SV.MSLAYER_CHECK end,
		name = GetString(SI_SYNERGY_NAME_SOUND_TIME),
		min = 0,
		max = 5,
		step = 1,
		default = 1,	
		getFunc = function() return BSCAS.SV.MSLAYER_SOUND_INC end,
		setFunc = function(value)
			BSCAS.SV.MSLAYER_SOUND_INC = value
		end,
	})
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.MSLAYER_CHECK end,
		name = GetString(SI_SYNERGY_UI_MARK),
		tooltip = GetString(SI_SYNERGY_UI_MARK_DESC),
		getFunc = function() return BSCAS.SV.MSLAYER_ENABLE_MARK end,
		setFunc = function(value) 
			BSCAS.SV.MSLAYER_ENABLE_MARK = value
			BSCAS.MSlayerUpdateUI() -- new
		end,
	})
end

function BSCAS.InitMSlayerMenu()
	-- the panel for the addons menu
	local panelData = {
		type = "panel",
		name = BSCAS.NameMenu.."3. Slayer UI",
		displayName = BSCAS.NameSpaced.." - Slayer UI",
		author = BSCAS.Author,
		version = BSCAS.VersionDisplay,
		registerForRefresh = true,
		slashCommand = "/bscass",
	}	
	
	for k, v in pairs(BSCAS.SOUNDLIST) do
		table.insert(s_choices, v)
		table.insert(s_sounds, k)
	end
	
	AddSendFeedBack()
	
	AddMSlayerSetting()
	
    local addonpanel = LibAddonMenu2:RegisterAddonPanel(BSCAS.NameSpaced.."Slayer", panelData)
    LibAddonMenu2:RegisterOptionControls(BSCAS.NameSpaced.."Slayer", optionsTable)
		
	CALLBACK_MANAGER:RegisterCallback("LAM-PanelOpened", function(currentpanel) if addonpanel == currentpanel then BSCASMSlayerUI:SetHidden(false) end end )
	CALLBACK_MANAGER:RegisterCallback("LAM-PanelClosed", function(currentpanel) if addonpanel == currentpanel then BSCASMSlayerUI:SetHidden(true) end end )
end