BSCASynergy = BSCASynergy or {}
local BSCAS = BSCASynergy

local optionsTable = {}

local function AddSendFeedBack()
    table.insert(optionsTable, {
        type = "button",
        name = "Donate",
        tooltip = "Main - EU Server",
        func = function()
              local function PrefillMail()
                ZO_MailSendToField:SetText(BSCAS.Author)
                ZO_MailSendSubjectField:SetText(BSCAS.NameSpaced)
                ZO_MailSendBodyField:TakeFocus()
              end
                SCENE_MANAGER:Show('mailSend')
                zo_callLater(PrefillMail, 250)
        end,
        width = "half",
        warning = "",	
    })
end

local function AddTexture(control, strIcon, strDesciption)
	table.insert(control, {
        type = "texture",
        image =  strIcon,
		tooltip = strDesciption,
        imageWidth = 32,
        imageHeight = 32,
        width = "half",
	})
end

local function AddDivider(control)
	table.insert(control, {
		type = "divider",
	})
end

local function ShowBSCUI()
	if BSCASTackingUI:IsHidden() then BSCASTackingUI:SetHidden(false) else BSCASTackingUI:SetHidden(true) end
end

local function AddBasicSetting()
	table.insert(optionsTable, {
        type = "header",
		name = GetString(SI_SYNERGY_UI_TRACK_SETTINGS),
    })	
	table.insert(optionsTable, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_UI_TRACK_ENABLE),
		getFunc = function() return BSCAS.SV.TRACKING_ENABLED end,
		setFunc = function(v) 
			BSCAS.SV.TRACKING_ENABLED = v
			BSCAS.TrackEnable()
		end,
	})	
	--table.insert(optionsTable, {
	--	type = "button",
	--	disabled = function() return not BSCAS.SV.TRACKING_ENABLED end,
	--	name = GetString(SI_SYNERGY_UI_SHOW),
	--	func = ShowBSCUI,
	--})
	table.insert(optionsTable, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_UI_LOCK),
		getFunc = function() return BSCAS.SV.TRACKING_LOCK_UI end,
		setFunc = function(v) 
			BSCAS.SV.TRACKING_LOCK_UI = v
			BSCASTackingUI:SetMovable(not BSCAS.SV.TRACKING_LOCK_UI)
		end,
	})	
	table.insert(optionsTable, {
		type = "dropdown",
		disabled = function() return not BSCAS.SV.TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_UI_TRACK_ORIENT),
		choices = {"Horizontal", "Vertical"},
		getFunc = function() return BSCAS.SV.TRACKING_UI_ORIENT end,
		setFunc = function(v)
			BSCAS.SV.TRACKING_UI_ORIENT = v
			BSCAS.TrackUpdateUI()
		end,
	})
	table.insert(optionsTable, {
		type = "slider",
		disabled = function() return not BSCAS.SV.TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_UI_TRACK_SIZE),
		min = 0,
		max = 100,
		step = 1,
		getFunc = function() return BSCAS.SV.TRACKING_UI_SIZE end,
		setFunc = function(v)
			BSCAS.SV.TRACKING_UI_SIZE = v
			BSCAS.TrackUpdateUI()
		end,
		default = 40,
	})
	
	table.insert(optionsTable, {
		type = "slider",
		disabled = function() return not BSCAS.SV.TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_UI_TRACK_SIZE_OUTLINE),
		min = 0,
		max = 10,
		step = 1,
		getFunc = function() return BSCAS.SV.TRACKING_UI_SIZE_OUTLINE end,
		setFunc = function(v)
			BSCAS.SV.TRACKING_UI_SIZE_OUTLINE = v
			BSCAS.TrackUpdateUI()
		end,
		default = 3,
	})	
	
	table.insert(optionsTable, {
		type = "slider",
		disabled = function() return not BSCAS.SV.TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_UI_ALPHA),
		tooltip = "",
		min = 0.1,
		max = 1,
		step = 0.1,
		default = 1,	
		getFunc = function() return BSCAS.SV.TRACKING_UI_ALPHA end,
		setFunc = function(value)
			BSCAS.SV.TRACKING_UI_ALPHA = value
			BSCAS.TrackUpdateUI() -- new
		end,
	})	
end

local function AddFontSettings()
		table.insert(optionsTable, {
        type = "header",
		name = "Font Settings",--GetString(SI_SYNERGY_NAME_TREE_UNDAUNTED),
    })
	table.insert(optionsTable, {
		type = "dropdown",
		name = "Font", 
		tooltip = "",
        choices = {"MEDIUM_FONT", "BOLD_FONT", "CHAT_FONT", "GAMEPAD_LIGHT_FONT", "GAMEPAD_MEDIUM_FONT", "GAMEPAD_BOLD_FONT", "ANTIQUE_FONT", "HANDWRITTEN_FONT", "STONE_TABLET_FONT"},		
		getFunc = function()
			return BSCAS.SV.TRACKING_UI_FONT 
		end,
		setFunc = function(v) 
			BSCAS.SV.TRACKING_UI_FONT = v		
			BSCAS.TrackUpdateUI()
		end,
        width = "full",
	})
	table.insert(optionsTable, {
		type = "dropdown",
		name = "Font Style", 
		tooltip = "",
        choices = { "soft-shadow-thick", "soft-shadow-thin", "soft-shadow-thick", "thick-outline", "shadow" },		
		getFunc = function()
			return BSCAS.SV.TRACKING_UI_FONT_STYLE 
		end,
		setFunc = function(v) 
			BSCAS.SV.TRACKING_UI_FONT_STYLE = v
			BSCAS.TrackUpdateUI()
		end,
        width = "full",
	})
	
	--table.insert(optionsTable, {
	--	type = "slider",
		--disabled = function() return not BSCAS.SV.TRACKING_ENABLED end,
	--	name = GetString(SI_SYNERGY_UI_TRACK_SIZE_OUTLINE),
	--	min = 0,
	--	max = 10,
	--	step = 1,
	--	getFunc = function() return BSCAS.SV.TRACKING_UI_SIZE_OUTLINE end,
	--	setFunc = function(v)
	--		BSCAS.SV.TRACKING_UI_SIZE_OUTLINE = v
			--BSCAS.TrackUpdateUI()
	--	end,
	--	default = 3,
	--})	
	
	
	table.insert(optionsTable, {
		type = "colorpicker",
		name = "Color Cooldown Ready",
		tooltip = "",
		getFunc = function() return unpack(BSCAS.SV.TRACKING_UI_FONT_COLOR_N) end,	--(alpha is optional)
		setFunc = function(r,g,b,a) 
			BSCAS.SV.TRACKING_UI_FONT_COLOR_N = {r, g, b, a}
			BSCAS.TrackUpdateUI()
		end,	--(alpha is optional)
        width = "full",
	})
	table.insert(optionsTable, {
		type = "colorpicker",
		name = "Color Cooldown Running",
		tooltip = "",
		getFunc = function() return unpack(BSCAS.SV.TRACKING_UI_FONT_COLOR_C) end,	--(alpha is optional)
		setFunc = function(r,g,b,a) 
			BSCAS.SV.TRACKING_UI_FONT_COLOR_C = {r, g, b, a}
			BSCAS.TrackUpdateUI()
		end,	--(alpha is optional)
        width = "full",
	})
end

local function AddTrackingSettings()
	table.insert(optionsTable, {
        type = "header",
		name = GetString(SI_SYNERGY_NAME_TREE_UNDAUNTED),
    })
	-- undaunted
	AddTexture(optionsTable, ICON_UNDAUNTED_ALTAR_0, "")
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_BLOODALTAR), 
		getFunc = function() return BSCAS.SV.TRACKING_UI_TSG_LIST.BLOODALTAR end,
		setFunc = function(value) 
			BSCAS.SV.TRACKING_UI_TSG_LIST.BLOODALTAR = value 
			BSCAS.TrackUpdateUI()
		end,
        width = "half",
	})		
	AddTexture(optionsTable, ICON_UNDAUNTED_WEBS_0, "")	
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_WEBS),
		getFunc = function() return BSCAS.SV.TRACKING_UI_TSG_LIST.SPIDERS end,
		setFunc = function(value) 
			BSCAS.SV.TRACKING_UI_TSG_LIST.SPIDERS = value 
			BSCAS.TrackUpdateUI()
		end,
        width = "half",
	})	
	AddTexture(optionsTable, ICON_UNDAUNTED_FIRE_0, GetString(SI_SYNERGY_DESC_INNERFIRE))
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_INNERFIRE),
		getFunc = function() return BSCAS.SV.TRACKING_UI_TSG_LIST.INNERFIRE end,
		setFunc = function(value) 
			BSCAS.SV.TRACKING_UI_TSG_LIST.INNERFIRE = value 
			BSCAS.TrackUpdateUI()
		end,
        width = "half",
	})	
	AddTexture(optionsTable, ICON_UNDAUNTED_BONE_0, "")
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_BONE),
		getFunc = function() return BSCAS.SV.TRACKING_UI_TSG_LIST.BONESHIELD end,
		setFunc = function(value) 
			BSCAS.SV.TRACKING_UI_TSG_LIST.BONESHIELD = value 
			BSCAS.TrackUpdateUI()
		end,
        width = "half",
	})			
	AddTexture(optionsTable, ICON_UNDAUNTED_ORB_2, "")
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_ORB2),
		getFunc = function() return BSCAS.SV.TRACKING_UI_TSG_LIST.SHARTSORBS end,
		setFunc = function(value) 
			BSCAS.SV.TRACKING_UI_TSG_LIST.SHARTSORBS = value 
			BSCAS.TrackUpdateUI()
		end,
        width = "half",
	})
	--Templar
	table.insert(optionsTable, {
        type = "header",
        name = GetString(SI_SYNERGY_NAME_TREE_TEMPLAR),
    })
	AddTexture(optionsTable, ICON_TEMPLAR_RITUAL_0, "")	
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_PURGE),
		getFunc = function() return BSCAS.SV.TRACKING_UI_TSG_LIST.PURIFY end,
		setFunc = function(value) 
			BSCAS.SV.TRACKING_UI_TSG_LIST.PURIFY = value 
			BSCAS.TrackUpdateUI()
		end,
        width = "half",
	})
	--Sorc
	table.insert(optionsTable, {
        type = "header",
        name = GetString(SI_SYNERGY_NAME_TREE_SORC),
    })		
	AddTexture(optionsTable, ICON_SORC_CONDUIT_0, "")	
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_CONDUIT),
		getFunc = function() return BSCAS.SV.TRACKING_UI_TSG_LIST.CONDUIT end,
		setFunc = function(value) 
			BSCAS.SV.TRACKING_UI_TSG_LIST.CONDUIT = value 
			BSCAS.TrackUpdateUI()
		end,
        width = "half",
	})	
	AddTexture(optionsTable, ICON_SORC_ATRO_0, "")	
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_ATRO),
		getFunc = function() return BSCAS.SV.TRACKING_UI_TSG_LIST.ATRONACH end,
		setFunc = function(value) 
			BSCAS.SV.TRACKING_UI_TSG_LIST.ATRONACH = value 
			BSCAS.TrackUpdateUI()
		end,
        width = "half",
	})	
	-- DK 
	table.insert(optionsTable, {
        type = "header",
        name = GetString(SI_SYNERGY_NAME_TREE_DK),
    })	
	AddTexture(optionsTable, ICON_DK_CLAW_0, "")	
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_IMPALE),
		getFunc = function() return BSCAS.SV.TRACKING_UI_TSG_LIST.SHACKLE end,
		setFunc = function(value) 
			BSCAS.SV.TRACKING_UI_TSG_LIST.SHACKLE = value 
			BSCAS.TrackUpdateUI()
		end,
        width = "half",
	})
	-- warden
	table.insert(optionsTable, {
        type = "header",
        name = GetString(SI_SYNERGY_NAME_TREE_WARDN),
    })	
	AddTexture(optionsTable, ICON_WARDEN_HARVEST_0, "")	
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_HARVEST),
		getFunc = function() return BSCAS.SV.TRACKING_UI_TSG_LIST.HARVEST end,
		setFunc = function(value) 
			BSCAS.SV.TRACKING_UI_TSG_LIST.HARVEST = value 
			BSCAS.TrackUpdateUI()
		end,
        width = "half",
	})
	-- Necro
	table.insert(optionsTable, {
        type = "header",
        name = GetString(SI_SYNERGY_NAME_TREE_NECRO),
    })
	AddTexture(optionsTable, ICON_NECRO_GRAVE_0, "")	
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_BONEYARD),
		getFunc = function() return BSCAS.SV.TRACKING_UI_TSG_LIST.GRAVEROBBER end,
		setFunc = function(value) 
			BSCAS.SV.TRACKING_UI_TSG_LIST.GRAVEROBBER = value 
			BSCAS.TrackUpdateUI()
		end,
        width = "half",
	})
	AddTexture(optionsTable, ICON_NECRO_TOTEM_0, "")	
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_TOTEM),
		getFunc = function() return BSCAS.SV.TRACKING_UI_TSG_LIST.PUREAGONY end,
		setFunc = function(value) 
			BSCAS.SV.TRACKING_UI_TSG_LIST.PUREAGONY = value 
			BSCAS.TrackUpdateUI()
		end,
        width = "half",
	})
	if GetAPIVersion() > 101037 then
		-- Arcanist
		table.insert(optionsTable, {
			type = "header",
			name = GetString(SI_SYNERGY_NAME_TREE_ARCANIST),
		})
		AddTexture(optionsTable, ICON_ARCANIST_RUNE, "")	
		table.insert(optionsTable, {
			type = "checkbox",
			disabled = function() return not BSCAS.SV.TRACKING_ENABLED end,
			name = GetString(SI_SYNERGY_NAME_RUNE),
			getFunc = function() return BSCAS.SV.TRACKING_UI_TSG_LIST.RUNE end,
			setFunc = function(value) 
				BSCAS.SV.TRACKING_UI_TSG_LIST.RUNE = value 
				BSCAS.TrackUpdateUI()
			end,
			width = "half",
		})
		AddTexture(optionsTable, ICON_ARCANIST_PORTAL, "")	
		table.insert(optionsTable, {
			type = "checkbox",
			disabled = function() return not BSCAS.SV.TRACKING_ENABLED end,
			name = GetString(SI_SYNERGY_NAME_PORTAL),
			getFunc = function() return BSCAS.SV.TRACKING_UI_TSG_LIST.PORTAL end,
			setFunc = function(value) 
				BSCAS.SV.TRACKING_UI_TSG_LIST.PORTAL = value 
				BSCAS.TrackUpdateUI()
			end,
			width = "half",
		})	
	end
	-- Werwolf
	table.insert(optionsTable, {
        type = "header",
        name = GetString(SI_SYNERGY_NAME_TREE_WOLF),
    })
	AddTexture(optionsTable, ICON_WOLF, "")	
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_HUNT),
		getFunc = function() return BSCAS.SV.TRACKING_UI_TSG_LIST.HOWLING end,
		setFunc = function(value) 
			BSCAS.SV.TRACKING_UI_TSG_LIST.HOWLING = value 
			BSCAS.TrackUpdateUI()
		end,
        width = "half",
	})
	-- Item Sets
	table.insert(optionsTable, {
        type = "header",
        name = GetString(SI_SYNERGY_NAME_ITEMS),
    })
	
	AddTexture(optionsTable, ICON_ITEM_URSUS, GetString(SI_SYNERGY_ITEM_DESC_URSUS))
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_ITEM_NAME_URSUS),
		getFunc = function() return BSCAS.SV.TRACKING_UI_TSG_LIST.URSUS end,
		setFunc = function(value) 
			BSCAS.SV.TRACKING_UI_TSG_LIST.URSUS = value 
			BSCAS.TrackUpdateUI()
		end,
        width = "half",
	})
	
	AddTexture(optionsTable, ICON_ITEM_KRAGLEN, GetString(SI_SYNERGY_ITEM_DESC_KRAGLEN))		
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_ITEM_NAME_KRAGLEN),
		getFunc = function() return BSCAS.SV.TRACKING_UI_TSG_LIST.KRAGLEN end,
		setFunc = function(value) 
			BSCAS.SV.TRACKING_UI_TSG_LIST.KRAGLEN = value 
			BSCAS.TrackUpdateUI()
		end,
        width = "half",
	})
	
	AddTexture(optionsTable, ICON_ITEM_SANGUINE, GetString(SI_SYNERGY_ITEM_DESC_SANGUINE))
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_ITEM_NAME_SANGUINE),
		getFunc = function() return BSCAS.SV.TRACKING_UI_TSG_LIST.LADYTHORN end,
		setFunc = function(value) 
			BSCAS.SV.TRACKING_UI_TSG_LIST.LADYTHORN = value 
			BSCAS.TrackUpdateUI()
		end,
        width = "half",
	})
	
	AddTexture(optionsTable, ICON_ITEM_GPREPRISAL, GetString(SI_SYNERGY_ITEM_DESC_GPREPRISAL))
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_ITEM_NAME_GPREPRISAL),
		getFunc = function() return BSCAS.SV.TRACKING_UI_TSG_LIST.GPREPRISAL end,
		setFunc = function(value) 
			BSCAS.SV.TRACKING_UI_TSG_LIST.GPREPRISAL = value 
			BSCAS.TrackUpdateUI()
		end,
        width = "half",
	})
	-- Trail Portal
	table.insert(optionsTable, {
        type = "header",
        name = GetString(SI_SYNERGY_NAME_RAID),
    })
	AddTexture(optionsTable, ICON_VCR_GATE, "")
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_ABILITY_GATEWAY),
		getFunc = function() return BSCAS.SV.TRACKING_UI_TSG_LIST.CR_PRTAL end,
		setFunc = function(value) 
			BSCAS.SV.TRACKING_UI_TSG_LIST.CR_PRTAL = value 
			BSCAS.TrackUpdateUI()
		end,
        width = "half",
	})
	--
	AddTexture(optionsTable, ICON_DSR_DINFESTATION, GetString(SI_SYNERGY_DESC_DSR_SURGING_WATERS))
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_ABILITY_DSR_SURGING_WATERS),
		getFunc = function() return BSCAS.SV.TRACKING_UI_TSG_LIST.DSR_REEF end,
		setFunc = function(value) 
			BSCAS.SV.TRACKING_UI_TSG_LIST.DSR_REEF = value 
			BSCAS.TrackUpdateUI()
		end,
        width = "half",
	})	
	--
	AddTexture(optionsTable, ICON_SE_AGONY, GetString(SI_SYNERGY_DESC_SE_VANTONS_CLARITY))
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_ABILITY_SE_VANTONS_CLARITY),
		getFunc = function() return BSCAS.SV.TRACKING_UI_TSG_LIST.SE_PORTAL end,
		setFunc = function(value) 
			BSCAS.SV.TRACKING_UI_TSG_LIST.SE_PORTAL = value 
			BSCAS.TrackUpdateUI()
		end,
        width = "half",
	})	
	--
	AddTexture(optionsTable, ICON_LC_MIRROR, "")
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_ABILITY_LC_MIRROR),
		getFunc = function() return BSCAS.SV.TRACKING_UI_TSG_LIST.LC_MIRROR end,
		setFunc = function(value) 
			BSCAS.SV.TRACKING_UI_TSG_LIST.LC_MIRROR = value 
			BSCAS.TrackUpdateUI()
		end,
        width = "half",
	})		
end


function BSCAS.InitTrackingMenu()
	-- the panel for the addons menu
	local panelData = {
		type = "panel",
		name = BSCAS.NameMenu.."4. Tracking UI",
		displayName = BSCAS.NameSpaced.." - Tracking UI",
		author = BSCAS.Author,
		version = BSCAS.VersionDisplay,
		registerForRefresh = true,
		slashCommand = "/bscast",
	}	
	
	AddSendFeedBack()
	
	AddBasicSetting()
	AddFontSettings()
	AddTrackingSettings()
	
    local addonpanel = LibAddonMenu2:RegisterAddonPanel(BSCAS.NameSpaced.."Tracking", panelData)
    LibAddonMenu2:RegisterOptionControls(BSCAS.NameSpaced.."Tracking", optionsTable)
		
	CALLBACK_MANAGER:RegisterCallback("LAM-PanelOpened", function(currentpanel) if addonpanel == currentpanel then BSCASTackingUI:SetHidden(false) end end )
	CALLBACK_MANAGER:RegisterCallback("LAM-PanelClosed", function(currentpanel) if addonpanel == currentpanel then BSCASTackingUI:SetHidden(true) end end )
end