BSCASynergy = BSCASynergy or {}
local BSCAS = BSCASynergy

local optionsTable = {}

local function AddSendFeedBack()
    table.insert(optionsTable, {
        type = "button",
        name = "Donate",
        tooltip = "Main - EU Server",
        func = function()
              local function PrefillMail()
                ZO_MailSendToField:SetText(BSCAS.Author)
                ZO_MailSendSubjectField:SetText(BSCAS.NameSpaced)
                ZO_MailSendBodyField:TakeFocus()
              end
                SCENE_MANAGER:Show('mailSend')
                zo_callLater(PrefillMail, 250)
        end,
        width = "half",
        warning = "",	
    })
end

local function AddTexture(control, strIcon, strDesciption)
	table.insert(control, {
        type = "texture",
        image =  strIcon,
		tooltip = strDesciption,
        imageWidth = 32,
        imageHeight = 32,
        width = "half",
	})
end

local function AddDivider(control)
	table.insert(control, {
		type = "divider",
	})
end

local function AddBasicSetting()
	table.insert(optionsTable, {
        type = "header",
		name = GetString(SI_SYNERGY_UI_TRACK_SETTINGS),
    })	
	table.insert(optionsTable, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_UI_TRACK_ENABLE),
		getFunc = function() return BSCAS.SV.GROUP_TRACKING_ENABLED end,
		setFunc = function(v) 
			BSCAS.SV.GROUP_TRACKING_ENABLED = v
			BSCAS.GroupTrackEnable()
			BSCAS.GTrackUpdateSetting()
		end,
	})	
	table.insert(optionsTable, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_UI_TRACK_ENABLE).."|t23:23:EsoUI/Art/LFG/LFG_tank_up_64.dds|t|r"..GetString("SI_LFGROLE", LFG_ROLE_TANK),
		disabled = function() return not BSCAS.SV.GROUP_TRACKING_ENABLED end,
		getFunc = function() return BSCAS.SV.GROUP_TRACKING_TANK end,
		setFunc = function(v) 
			BSCAS.SV.GROUP_TRACKING_TANK = v
			BSCAS.GTrackUpdateSetting()
		end,
	})		
	table.insert(optionsTable, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_UI_TRACK_ENABLE).."|t23:23:EsoUI/Art/LFG/LFG_healer_up_64.dds|t|r"..GetString("SI_LFGROLE", LFG_ROLE_HEAL),
		disabled = function() return not BSCAS.SV.GROUP_TRACKING_ENABLED end,
		getFunc = function() return BSCAS.SV.GROUP_TRACKING_HEAL end,
		setFunc = function(v) 
			BSCAS.SV.GROUP_TRACKING_HEAL = v
			BSCAS.GTrackUpdateSetting()
		end,
	})		
	table.insert(optionsTable, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_UI_TRACK_ENABLE).."|t23:23:EsoUI/Art/LFG/LFG_dps_up_64.dds|t|r"..GetString("SI_LFGROLE", LFG_ROLE_DPS),
		disabled = function() return not BSCAS.SV.GROUP_TRACKING_ENABLED end,
		getFunc = function() return BSCAS.SV.GROUP_TRACKING_DPS end,
		setFunc = function(v) 
			BSCAS.SV.GROUP_TRACKING_DPS = v
			BSCAS.GTrackUpdateSetting()
		end,
	})			
end

local function AddTrackingSettings()
	table.insert(optionsTable, {
        type = "header",
		name = GetString(SI_SYNERGY_NAME_TREE_UNDAUNTED),
    })
	-- undaunted
	AddTexture(optionsTable, ICON_UNDAUNTED_ALTAR_0, "")
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.GROUP_TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_BLOODALTAR), 
		getFunc = function() return BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.BLOODALTAR end,
		setFunc = function(value) 
			BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.BLOODALTAR = value 
			BSCAS.GTrackUpdateSetting()
		end,
        width = "half",
	})		
	AddTexture(optionsTable, ICON_UNDAUNTED_WEBS_0, "")	
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.GROUP_TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_WEBS),
		getFunc = function() return BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.SPIDERS end,
		setFunc = function(value) 
			BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.SPIDERS = value 
			BSCAS.GTrackUpdateSetting()
		end,
        width = "half",
	})
	AddTexture(optionsTable, ICON_UNDAUNTED_FIRE_0, GetString(SI_SYNERGY_DESC_INNERFIRE))
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.GROUP_TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_INNERFIRE),
		getFunc = function() return BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.INNERFIRE end,
		setFunc = function(value) 
			BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.INNERFIRE = value 
			BSCAS.GTrackUpdateSetting()
		end,
        width = "half",
	})	
	AddTexture(optionsTable, ICON_UNDAUNTED_BONE_0, "")
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.GROUP_TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_BONE),
		getFunc = function() return BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.BONESHIELD end,
		setFunc = function(value) 
			BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.BONESHIELD = value 
			BSCAS.GTrackUpdateSetting()
		end,
        width = "half",
	})			
	AddTexture(optionsTable, ICON_UNDAUNTED_ORB_2, "")
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.GROUP_TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_ORB2),
		getFunc = function() return BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.SHARTSORBS end,
		setFunc = function(value) 
			BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.SHARTSORBS = value 
			BSCAS.GTrackUpdateSetting()
		end,
        width = "half",
	})
	--Templar
	table.insert(optionsTable, {
        type = "header",
        name = GetString(SI_SYNERGY_NAME_TREE_TEMPLAR),
    })
	AddTexture(optionsTable, ICON_TEMPLAR_RITUAL_0, "")	
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.GROUP_TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_PURGE),
		getFunc = function() return BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.PURIFY end,
		setFunc = function(value) 
			BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.PURIFY = value 
			BSCAS.GTrackUpdateSetting()
		end,
        width = "half",
	})
	--Sorc
	table.insert(optionsTable, {
        type = "header",
        name = GetString(SI_SYNERGY_NAME_TREE_SORC),
    })		
	AddTexture(optionsTable, ICON_SORC_CONDUIT_0, "")	
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.GROUP_TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_CONDUIT),
		getFunc = function() return BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.CONDUIT end,
		setFunc = function(value) 
			BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.CONDUIT = value 
			BSCAS.GTrackUpdateSetting()
		end,
        width = "half",
	})	
	AddTexture(optionsTable, ICON_SORC_ATRO_0, "")	
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.GROUP_TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_ATRO),
		getFunc = function() return BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.ATRONACH end,
		setFunc = function(value) 
			BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.ATRONACH = value 
			BSCAS.GTrackUpdateSetting()
		end,
        width = "half",
	})	
	-- DK 
	table.insert(optionsTable, {
        type = "header",
        name = GetString(SI_SYNERGY_NAME_TREE_DK),
    })	
	AddTexture(optionsTable, ICON_DK_CLAW_0, "")	
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.GROUP_TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_IMPALE),
		getFunc = function() return BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.SHACKLE end,
		setFunc = function(value) 
			BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.SHACKLE = value 
			BSCAS.GTrackUpdateSetting()
		end,
        width = "half",
	})
	-- warden
	table.insert(optionsTable, {
        type = "header",
        name = GetString(SI_SYNERGY_NAME_TREE_WARDN),
    })	
	AddTexture(optionsTable, ICON_WARDEN_HARVEST_0, "")	
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.GROUP_TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_HARVEST),
		getFunc = function() return BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.HARVEST end,
		setFunc = function(value) 
			BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.HARVEST = value 
			BSCAS.GTrackUpdateSetting()
		end,
        width = "half",
	})
	-- Necro
	table.insert(optionsTable, {
        type = "header",
        name = GetString(SI_SYNERGY_NAME_TREE_NECRO),
    })
	AddTexture(optionsTable, ICON_NECRO_GRAVE_0, "")	
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.GROUP_TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_BONEYARD),
		getFunc = function() return BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.GRAVEROBBER end,
		setFunc = function(value) 
			BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.GRAVEROBBER = value 
			BSCAS.GTrackUpdateSetting()
		end,
        width = "half",
	})
	AddTexture(optionsTable, ICON_NECRO_TOTEM_0, "")	
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.GROUP_TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_TOTEM),
		getFunc = function() return BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.PUREAGONY end,
		setFunc = function(value) 
			BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.PUREAGONY = value 
			BSCAS.GTrackUpdateSetting()
		end,
        width = "half",
	})
	if GetAPIVersion() > 101037 then
		-- Arcanist
		table.insert(optionsTable, {
			type = "header",
			name = GetString(SI_SYNERGY_NAME_TREE_ARCANIST),
		})
		AddTexture(optionsTable, ICON_ARCANIST_RUNE, "")	
		table.insert(optionsTable, {
			type = "checkbox",
			disabled = function() return not BSCAS.SV.GROUP_TRACKING_ENABLED end,
			name = GetString(SI_SYNERGY_NAME_RUNE),
			getFunc = function() return BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.RUNE end,
			setFunc = function(value) 
				BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.RUNE = value 
				BSCAS.GTrackUpdateSetting()
			end,
			width = "half",
		})
		AddTexture(optionsTable, ICON_ARCANIST_PORTAL, "")	
		table.insert(optionsTable, {
			type = "checkbox",
			disabled = function() return not BSCAS.SV.GROUP_TRACKING_ENABLED end,
			name = GetString(SI_SYNERGY_NAME_PORTAL),
			getFunc = function() return BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.PORTAL end,
			setFunc = function(value) 
				BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.PORTAL = value 
				BSCAS.GTrackUpdateSetting()
			end,
			width = "half",
		})
	end
	-- Werwolf
	table.insert(optionsTable, {
        type = "header",
        name = GetString(SI_SYNERGY_NAME_TREE_WOLF),
    })
	AddTexture(optionsTable, ICON_WOLF, "")	
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.GROUP_TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_HUNT),
		getFunc = function() return BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.HOWLING end,
		setFunc = function(value) 
			BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.HOWLING = value 
			BSCAS.GTrackUpdateSetting()
		end,
        width = "half",
	})
	-- Item Sets
	table.insert(optionsTable, {
        type = "header",
        name = GetString(SI_SYNERGY_NAME_ITEMS),
    })
	
	AddTexture(optionsTable, ICON_ITEM_URSUS, GetString(SI_SYNERGY_ITEM_DESC_URSUS))
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.GROUP_TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_ITEM_NAME_URSUS),
		getFunc = function() return BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.URSUS end,
		setFunc = function(value) 
			BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.URSUS = value 
			BSCAS.GTrackUpdateSetting()
		end,
        width = "half",
	})
	
	AddTexture(optionsTable, ICON_ITEM_KRAGLEN, GetString(SI_SYNERGY_ITEM_DESC_KRAGLEN))		
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.GROUP_TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_ITEM_NAME_KRAGLEN),
		getFunc = function() return BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.KRAGLEN end,
		setFunc = function(value) 
			BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.KRAGLEN = value 
			BSCAS.GTrackUpdateSetting()
		end,
        width = "half",
	})
	
	AddTexture(optionsTable, ICON_ITEM_SANGUINE, GetString(SI_SYNERGY_ITEM_DESC_SANGUINE))
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.GROUP_TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_ITEM_NAME_SANGUINE),
		getFunc = function() return BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.LADYTHORN end,
		setFunc = function(value) 
			BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.LADYTHORN = value 
			BSCAS.GTrackUpdateSetting()
		end,
        width = "half",
	})
	
	AddTexture(optionsTable, ICON_ITEM_GPREPRISAL, GetString(SI_SYNERGY_ITEM_DESC_GPREPRISAL))
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.GROUP_TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_ITEM_NAME_GPREPRISAL),
		getFunc = function() return BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.GPREPRISAL end,
		setFunc = function(value) 
			BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.GPREPRISAL = value 
			BSCAS.GTrackUpdateSetting()
		end,
        width = "half",
	})
	-- Trail Portal
	table.insert(optionsTable, {
        type = "header",
        name = GetString(SI_SYNERGY_NAME_RAID),
    })
	AddTexture(optionsTable, ICON_VCR_GATE, "")
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.GROUP_TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_ABILITY_GATEWAY),
		getFunc = function() return BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.CR_PRTAL end,
		setFunc = function(value) 
			BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.CR_PRTAL = value 
			BSCAS.GTrackUpdateSetting()
		end,
        width = "half",
	})
	--
	AddTexture(optionsTable, ICON_DSR_DINFESTATION, GetString(SI_SYNERGY_DESC_DSR_SURGING_WATERS))
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.GROUP_TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_ABILITY_DSR_SURGING_WATERS),
		getFunc = function() return BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.DSR_REEF end,
		setFunc = function(value) 
			BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.DSR_REEF = value 
			BSCAS.GTrackUpdateSetting()
		end,
        width = "half",
	})	
	--
	AddTexture(optionsTable, ICON_SE_AGONY, GetString(SI_SYNERGY_DESC_SE_VANTONS_CLARITY))
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.GROUP_TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_ABILITY_SE_VANTONS_CLARITY),
		getFunc = function() return BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.SE_PORTAL end,
		setFunc = function(value) 
			BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.SE_PORTAL = value 
			BSCAS.GTrackUpdateSetting()
		end,
        width = "half",
	})	
	--
	AddTexture(optionsTable, ICON_LC_MIRROR, "")
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.GROUP_TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_ABILITY_LC_MIRROR),
		getFunc = function() return BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.LC_MIRROR end,
		setFunc = function(value) 
			BSCAS.SV.GROUP_TRACKING_UI_TSG_LIST.LC_MIRROR = value 
			BSCAS.GTrackUpdateSetting()
		end,
        width = "half",
	})
end

function BSCAS.InitGroupTrackingMenu()
	-- the panel for the addons menu
	local panelData = {
		type = "panel",
		name = BSCAS.NameMenu.."5. Group Tracking UI",
		displayName = BSCAS.NameSpaced.." - Group Tracking UI",
		author = BSCAS.Author,
		version = BSCAS.VersionDisplay,
		registerForRefresh = true,
		slashCommand = "/bscasg",
	}		
	AddSendFeedBack()	
	AddBasicSetting()
	AddTrackingSettings()
	
    local addonpanel = LibAddonMenu2:RegisterAddonPanel(BSCAS.NameSpaced.."GTracking", panelData)
    LibAddonMenu2:RegisterOptionControls(BSCAS.NameSpaced.."GTracking", optionsTable)
		
	--CALLBACK_MANAGER:RegisterCallback("LAM-PanelOpened", function(currentpanel) if addonpanel == currentpanel then BSCASTackingUI:SetHidden(false) end end )
	--CALLBACK_MANAGER:RegisterCallback("LAM-PanelClosed", function(currentpanel) if addonpanel == currentpanel then BSCASTackingUI:SetHidden(true) end end )
end