BSCASynergy = BSCASynergy or {}
local BSCAS = BSCASynergy

local optionsTable = {}

local function AddSendFeedBack()
    table.insert(optionsTable, {
        type = "button",
        name = "Donate",
        tooltip = "Main - EU Server",
        func = function()
              local function PrefillMail()
                ZO_MailSendToField:SetText(BSCAS.Author)
                ZO_MailSendSubjectField:SetText(BSCAS.NameSpaced)
                ZO_MailSendBodyField:TakeFocus()
              end
                SCENE_MANAGER:Show('mailSend')
                zo_callLater(PrefillMail, 250)
        end,
        width = "half",
        warning = "",	
    })
end
local function AddTexture(control, strIcon, strDesciption)
	table.insert(control, {
        type = "texture",
        image =  strIcon,
		tooltip = strDesciption,
        imageWidth = 32,
        imageHeight = 32,
        width = "half",
	})
end
local function AddDivider(control)
	table.insert(control, {
		type = "divider",
	})
end
-- ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
local function GetListNames()
	local List = {}	
	for name, v in pairs(BSCAS.SV.TARGET_TRACKING_UI_PLAYER) do	
		table.insert(List, name)
	end	
	return List
end

-- ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
local default_setting = 
{
	ENABLED		= false,
	BLOODALTAR 	= false, -- undaunted
	INNERFIRE 	= false, -- undaunted
	SPIDERS		= false, -- undaunted
	BONESHIELD 	= false, -- undaunted
	SHARTSORBS	= true, -- templar + orbs
	PURIFY		= false, -- templar
	CONDUIT 	= true, -- sorc
	ATRONACH	= true, -- sorc
	SHACKLE		= false, -- dk
	HARVEST		= true, -- Warden
	GRAVEROBBER = true, -- Necro
	PUREAGONY	= false, -- Necro
	RUNE		= true, -- Arcanist
	UI_LEFT = 200,
	UI_TOP  = 200,
}
-- ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
local function CreateTestSetting()
	if BSCAS.SV.TARGET_TRACKING_UI_PLAYER[GetUnitDisplayName('player')] then return end
	BSCAS.SV.TARGET_TRACKING_UI_PLAYER[GetUnitDisplayName('player')] = default_setting
end
-- ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
local SelectedDDG = ""
local function AddPlayerToTracking()
	local name = zo_strformat("<<1>>", BSCAS_TTrackingDropdownG.data.getFunc())
	if name == nil or name == "" then return end
	if BSCAS.SV.TARGET_TRACKING_UI_PLAYER[name] ~= nil then return end	
	BSCAS.SV.TARGET_TRACKING_UI_PLAYER[name] = default_setting
	BSCAS.SV.TARGET_TRACKING_SELECTED_PLAYER = name
	--
	BSCAS_TTrackingDropdown:UpdateChoices(GetListNames())
	BSCAS.TTrackUpdateSetting()
end
local function RemovePlayerToTracking()
	local name = BSCAS_TTrackingDropdown.data.getFunc()
	if name == nil or name == "" then return end
	if name == GetUnitDisplayName('player') then return end
	-- remake the list
	local new_list = { }
	for k, v in pairs(BSCAS.SV.TARGET_TRACKING_UI_PLAYER) do		
		if name ~= k then
			new_list[k] = v
		end
	end	
	BSCAS.SV.TARGET_TRACKING_UI_PLAYER = new_list
	BSCAS.SV.TARGET_TRACKING_SELECTED_PLAYER = GetUnitDisplayName('player')
	--	
	BSCAS_TTrackingDropdown:UpdateChoices(GetListNames())
	BSCAS.TTrackUpdateSetting()
end
local function AddBasicSetting()
	table.insert(optionsTable, {
        type = "header",
		name = GetString(SI_SYNERGY_UI_TRACK_SETTINGS),
    })	
	table.insert(optionsTable, {
		type = "checkbox",
		name = GetString(SI_SYNERGY_TARGET_ENABLE), 
		getFunc = function() return BSCAS.SV.TARGET_TRACKING_ENABLED end,
		setFunc = function(value) 
			BSCAS.SV.TARGET_TRACKING_ENABLED = value 
			BSCAS.TargetTrackEnable()
			BSCAS.TTrackUpdateSetting()
		end,
	})
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.TARGET_TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_TARGET_ACCOUNT), 
		getFunc = function() return BSCAS.SV.TARGET_TRACKING_USEACCNAME end,
		setFunc = function(value) 
			BSCAS.SV.TARGET_TRACKING_USEACCNAME = value 
			BSCAS_TTrackingDropdownG:UpdateChoices(BSCAS:GetGroupListNames())
			BSCAS.TTrackUpdateSetting()			
			BSCAS_TTrackingDropdown:UpdateChoices(GetListNames())
		end,
	})
	AddDivider(optionsTable)
	table.insert(optionsTable, {
		type = 'dropdown',
		name = GetString(SI_SYNERGY_TARGET_PGROUP), 
		disabled = function() return not BSCAS.SV.TARGET_TRACKING_ENABLED end,
		choices = BSCAS:GetGroupListNames(),
		getFunc = function() return SelectedDDG end,
		setFunc = function(value)
			SelectedDDG = value
		end,
		scrollable = 12,
		reference = "BSCAS_TTrackingDropdownG",
        width = "half",
	})
	table.insert(optionsTable, {
		type = "button",
		name = GetString(SI_SYNERGY_TARGET_BUTTON_ADD), 
		disabled = function() return not BSCAS.SV.TARGET_TRACKING_ENABLED end,
		func = function(value) 
			AddPlayerToTracking()
		end,
        width = "half",
	})  
	AddDivider(optionsTable)  	
	table.insert(optionsTable, {
		type = 'dropdown',
		disabled = function() return not BSCAS.SV.TARGET_TRACKING_ENABLED end,
		choices = GetListNames(),
		getFunc = function() return BSCAS.SV.TARGET_TRACKING_SELECTED_PLAYER end,
		setFunc = function(value)
			if not BSCAS.SV.TARGET_TRACKING_UI_PLAYER[value] then return end
			BSCAS.SV.TARGET_TRACKING_SELECTED_PLAYER = value
		end,
		scrollable = 12,
		reference = "BSCAS_TTrackingDropdown",
        width = "half",
	})
	table.insert(optionsTable, {
		type = "button",
		name = GetString(SI_SYNERGY_TARGET_BUTTON_REMOVE), 
		disabled = function() return not BSCAS.SV.TARGET_TRACKING_ENABLED end,
		func = function(value) 
			RemovePlayerToTracking()
		end,
        width = "half",
	}) 
	AddDivider(optionsTable)  
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.TARGET_TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_TARGET_ENABLE_CHAR), 
		getFunc = function() return BSCAS.SV.TARGET_TRACKING_UI_PLAYER[BSCAS.SV.TARGET_TRACKING_SELECTED_PLAYER].ENABLED end,
		setFunc = function(value) 
			BSCAS.SV.TARGET_TRACKING_UI_PLAYER[BSCAS.SV.TARGET_TRACKING_SELECTED_PLAYER].ENABLED = value 
			BSCAS.TTrackUpdateSetting()
		end,
	})
end
local function AddTrackingSettings()
	table.insert(optionsTable, {
        type = "header",
		name = GetString(SI_SYNERGY_NAME_TREE_UNDAUNTED),
    })
	-- undaunted
	AddTexture(optionsTable, ICON_UNDAUNTED_ALTAR_0, "")
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.TARGET_TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_BLOODALTAR), 
		getFunc = function() return BSCAS.SV.TARGET_TRACKING_UI_PLAYER[BSCAS.SV.TARGET_TRACKING_SELECTED_PLAYER].BLOODALTAR end,
		setFunc = function(value) 
			BSCAS.SV.TARGET_TRACKING_UI_PLAYER[BSCAS.SV.TARGET_TRACKING_SELECTED_PLAYER].BLOODALTAR = value 
			BSCAS.TTrackUpdateSetting()
		end,
        width = "half",
	})		
	AddTexture(optionsTable, ICON_UNDAUNTED_WEBS_0, "")	
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.TARGET_TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_WEBS),
		getFunc = function() return BSCAS.SV.TARGET_TRACKING_UI_PLAYER[BSCAS.SV.TARGET_TRACKING_SELECTED_PLAYER].SPIDERS end,
		setFunc = function(value) 
			BSCAS.SV.TARGET_TRACKING_UI_PLAYER[BSCAS.SV.TARGET_TRACKING_SELECTED_PLAYER].SPIDERS = value 
			BSCAS.TTrackUpdateSetting()
		end,
        width = "half",
	})	
	AddTexture(optionsTable, ICON_UNDAUNTED_FIRE_0, GetString(SI_SYNERGY_DESC_INNERFIRE))
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.GROUP_TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_INNERFIRE),
		getFunc = function() return BSCAS.SV.TARGET_TRACKING_UI_PLAYER[BSCAS.SV.TARGET_TRACKING_SELECTED_PLAYER].INNERFIRE end,
		setFunc = function(value) 
			BSCAS.SV.TARGET_TRACKING_UI_PLAYER[BSCAS.SV.TARGET_TRACKING_SELECTED_PLAYER].INNERFIRE = value 
			BSCAS.TTrackUpdateSetting()
		end,
        width = "half",
	})	
	AddTexture(optionsTable, ICON_UNDAUNTED_BONE_0, "")
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.TARGET_TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_BONE),
		getFunc = function() return BSCAS.SV.TARGET_TRACKING_UI_PLAYER[BSCAS.SV.TARGET_TRACKING_SELECTED_PLAYER].BONESHIELD end,
		setFunc = function(value) 
			BSCAS.SV.TARGET_TRACKING_UI_PLAYER[BSCAS.SV.TARGET_TRACKING_SELECTED_PLAYER].BONESHIELD = value 
			BSCAS.TTrackUpdateSetting()
		end,
        width = "half",
	})			
	AddTexture(optionsTable, ICON_UNDAUNTED_ORB_2, "")
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.TARGET_TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_ORB2),
		getFunc = function() return BSCAS.SV.TARGET_TRACKING_UI_PLAYER[BSCAS.SV.TARGET_TRACKING_SELECTED_PLAYER].SHARTSORBS end,
		setFunc = function(value) 
			BSCAS.SV.TARGET_TRACKING_UI_PLAYER[BSCAS.SV.TARGET_TRACKING_SELECTED_PLAYER].SHARTSORBS = value 
			BSCAS.TTrackUpdateSetting()
		end,
        width = "half",
	})
	--Templar
	table.insert(optionsTable, {
        type = "header",
        name = GetString(SI_SYNERGY_NAME_TREE_TEMPLAR),
    })
	AddTexture(optionsTable, ICON_TEMPLAR_RITUAL_0, "")	
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.TARGET_TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_PURGE),
		getFunc = function() return BSCAS.SV.TARGET_TRACKING_UI_PLAYER[BSCAS.SV.TARGET_TRACKING_SELECTED_PLAYER].PURIFY end,
		setFunc = function(value) 
			BSCAS.SV.TARGET_TRACKING_UI_PLAYER[BSCAS.SV.TARGET_TRACKING_SELECTED_PLAYER].PURIFY = value 
			BSCAS.TTrackUpdateSetting()
		end,
        width = "half",
	})
	--Sorc
	table.insert(optionsTable, {
        type = "header",
        name = GetString(SI_SYNERGY_NAME_TREE_SORC),
    })		
	AddTexture(optionsTable, ICON_SORC_CONDUIT_0, "")	
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.TARGET_TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_CONDUIT),
		getFunc = function() return BSCAS.SV.TARGET_TRACKING_UI_PLAYER[BSCAS.SV.TARGET_TRACKING_SELECTED_PLAYER].CONDUIT end,
		setFunc = function(value) 
			BSCAS.SV.TARGET_TRACKING_UI_PLAYER[BSCAS.SV.TARGET_TRACKING_SELECTED_PLAYER].CONDUIT = value 
			BSCAS.TTrackUpdateSetting()
		end,
        width = "half",
	})	
	AddTexture(optionsTable, ICON_SORC_ATRO_0, "")	
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.TARGET_TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_ATRO),
		getFunc = function() return BSCAS.SV.TARGET_TRACKING_UI_PLAYER[BSCAS.SV.TARGET_TRACKING_SELECTED_PLAYER].ATRONACH end,
		setFunc = function(value) 
			BSCAS.SV.TARGET_TRACKING_UI_PLAYER[BSCAS.SV.TARGET_TRACKING_SELECTED_PLAYER].ATRONACH = value 
			BSCAS.TTrackUpdateSetting()
		end,
        width = "half",
	})	
	-- DK 
	table.insert(optionsTable, {
        type = "header",
        name = GetString(SI_SYNERGY_NAME_TREE_DK),
    })	
	AddTexture(optionsTable, ICON_DK_CLAW_0, "")	
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.TARGET_TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_IMPALE),
		getFunc = function() return BSCAS.SV.TARGET_TRACKING_UI_PLAYER[BSCAS.SV.TARGET_TRACKING_SELECTED_PLAYER].SHACKLE end,
		setFunc = function(value) 
			BSCAS.SV.TARGET_TRACKING_UI_PLAYER[BSCAS.SV.TARGET_TRACKING_SELECTED_PLAYER].SHACKLE = value 
			BSCAS.TTrackUpdateSetting()
		end,
        width = "half",
	})
	-- warden
	table.insert(optionsTable, {
        type = "header",
        name = GetString(SI_SYNERGY_NAME_TREE_WARDN),
    })	
	AddTexture(optionsTable, ICON_WARDEN_HARVEST_0, "")	
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.TARGET_TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_HARVEST),
		getFunc = function() return BSCAS.SV.TARGET_TRACKING_UI_PLAYER[BSCAS.SV.TARGET_TRACKING_SELECTED_PLAYER].HARVEST end,
		setFunc = function(value) 
			BSCAS.SV.TARGET_TRACKING_UI_PLAYER[BSCAS.SV.TARGET_TRACKING_SELECTED_PLAYER].HARVEST = value 
			BSCAS.TTrackUpdateSetting()
		end,
        width = "half",
	})
	-- Necro
	table.insert(optionsTable, {
        type = "header",
        name = GetString(SI_SYNERGY_NAME_TREE_NECRO),
    })
	AddTexture(optionsTable, ICON_NECRO_GRAVE_0, "")	
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.TARGET_TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_BONEYARD),
		getFunc = function() return BSCAS.SV.TARGET_TRACKING_UI_PLAYER[BSCAS.SV.TARGET_TRACKING_SELECTED_PLAYER].GRAVEROBBER end,
		setFunc = function(value) 
			BSCAS.SV.TARGET_TRACKING_UI_PLAYER[BSCAS.SV.TARGET_TRACKING_SELECTED_PLAYER].GRAVEROBBER = value 
			BSCAS.TTrackUpdateSetting()
		end,
        width = "half",
	})
	AddTexture(optionsTable, ICON_NECRO_TOTEM_0, "")	
	table.insert(optionsTable, {
		type = "checkbox",
		disabled = function() return not BSCAS.SV.TARGET_TRACKING_ENABLED end,
		name = GetString(SI_SYNERGY_NAME_TOTEM),
		getFunc = function() return BSCAS.SV.TARGET_TRACKING_UI_PLAYER[BSCAS.SV.TARGET_TRACKING_SELECTED_PLAYER].PUREAGONY end,
		setFunc = function(value) 
			BSCAS.SV.TARGET_TRACKING_UI_PLAYER[BSCAS.SV.TARGET_TRACKING_SELECTED_PLAYER].PUREAGONY = value 
			BSCAS.TTrackUpdateSetting()
		end,
        width = "half",
	})
	if GetAPIVersion() > 101037 then
		-- Arcanist
		table.insert(optionsTable, {
			type = "header",
			name = GetString(SI_SYNERGY_NAME_TREE_ARCANIST),
		})
		AddTexture(optionsTable, ICON_ARCANIST_RUNE, "")	
		table.insert(optionsTable, {
			type = "checkbox",
			disabled = function() return not BSCAS.SV.TARGET_TRACKING_ENABLED end,
			name = GetString(SI_SYNERGY_NAME_RUNE),
			getFunc = function() return BSCAS.SV.TARGET_TRACKING_UI_PLAYER[BSCAS.SV.TARGET_TRACKING_SELECTED_PLAYER].RUNE end,
			setFunc = function(value) 
				BSCAS.SV.TARGET_TRACKING_UI_PLAYER[BSCAS.SV.TARGET_TRACKING_SELECTED_PLAYER].RUNE = value 
				BSCAS.TTrackUpdateSetting()
			end,
			width = "half",
		})
	end
end
function BSCAS.InitTargetTrackingMenu()
	CreateTestSetting()
	-- the panel for the addons menu
	local panelData = {
		type = "panel",
		name = BSCAS.NameMenu.."6. Target Tracking UI",
		displayName = BSCAS.NameSpaced.." - Target Tracking UI",
		author = BSCAS.Author,
		version = BSCAS.VersionDisplay,
		registerForRefresh = true,
		slashCommand = "/bscast",
	}		
	AddSendFeedBack()	
	AddBasicSetting()
	AddTrackingSettings()
	
    local addonpanel = LibAddonMenu2:RegisterAddonPanel(BSCAS.NameSpaced.."TTracking", panelData)
    LibAddonMenu2:RegisterOptionControls(BSCAS.NameSpaced.."TTracking", optionsTable)
		
	--CALLBACK_MANAGER:RegisterCallback("LAM-PanelOpened", function(currentpanel) if addonpanel == currentpanel then BSCASTackingUI:SetHidden(false) end end )
	--CALLBACK_MANAGER:RegisterCallback("LAM-PanelClosed", function(currentpanel) if addonpanel == currentpanel then BSCASTackingUI:SetHidden(true) end end )
end