BSCASynergy = BSCASynergy or {}
local BSCAS = BSCASynergy
local SelectedPreset = ""
local fixedPreset = ""
local bIsInit = false
local bSaved = false
function BSCAS:WWUpdateComboBox()
	if not bIsInit then return end
	BSCAS.WWUI:GetNamedChild("Combo").m_comboBox:ClearItems()
	for name, v in pairs(BSCAS.SV_acc.SETTING) do	
		BSCAS.WWUI:GetNamedChild("Combo").m_comboBox:AddItem(ZO_ComboBox:CreateItemEntry(name, function() BSCAS:WWSelectedCB(name) end))
	end		
end
function BSCAS:WWSelectedCB(name)
	SelectedPreset = name
end
function BSCAS:InitWWPlugin()
	bIsInit = true
	-- Add Dropdown to Wizzards Setup Menu
	local parent = WizardsWardrobeModifyDialogCondition
	local frame = WINDOW_MANAGER:CreateControlFromVirtual("BSCASynergyWWUIPInfo", parent, "BSCASynergyWWUIP")
	frame:ClearAnchors()
	frame:SetAnchor(TOP, parent, BOTTOM, 0, 25) 
	frame:GetNamedChild("Label"):SetText("BSC Advanced Synergy Preset")
	frame:GetNamedChild("Combo").m_comboBox:SetSortsItems(false)
	frame:GetNamedChild("Combo").m_comboBox:ClearItems()
	for name, v in pairs(BSCAS.SV_acc.SETTING) do	
		frame:GetNamedChild("Combo").m_comboBox:AddItem(ZO_ComboBox:CreateItemEntry(name, function() BSCAS:WWSelectedCB(name) end))
	end			
	BSCAS.WWUI = frame

	-- Load Saved Preset If Exist Into UI
	ZO_PostHook(WizardsWardrobe.gui, "ShowModifyDialog", function(setupControl, index)  
		local zone = WizardsWardrobe.selection.zone
		local pageId = WizardsWardrobe.selection.pageId		
		-- Get saved select
		local Preset = "Default"		
		if WizardsWardrobe.setups[zone.tag][pageId][index].BSCASPreset ~= nil then
			Preset = WizardsWardrobe.setups[zone.tag][pageId][index].BSCASPreset
		end
		-- Check If Preset Exist..
		if not BSCAS:PresetExist(Preset) then Preset = "Default" end		
		-- Set Current Selected if exist
		BSCAS.WWUI:GetNamedChild("Combo").m_comboBox:SetSelectedItemText(Preset)				
		-- Save Also the PreSet
		WizardsWardrobeModifyDialogSave:SetHandler("OnMouseUp", function(self)
			-- Save select Preset
			if SelectedPreset == "" then SelectedPreset = Preset end
			WizardsWardrobe.setups[zone.tag][pageId][index].BSCASPreset = SelectedPreset
			SelectedPreset = ""
			bSaved = true
		end)
	end)
	
	-- Load The Selected Preset for Synergies
	ZO_PostHook(WizardsWardrobe, "LoadSetup", function(zone, pageId, index, auto)  
		if not zone or not pageId or not index then
			return false
		end
		local Preset = ""
		if WizardsWardrobe.setups[zone.tag][pageId][index] == nil then return end -- setup is empty
		if WizardsWardrobe.setups[zone.tag][pageId][index].BSCASPreset ~= nil then
			Preset = WizardsWardrobe.setups[zone.tag][pageId][index].BSCASPreset 
		end
		-- Check If Preset Exist..
		if not BSCAS:PresetExist(Preset) then return end	
		-- If Preset is not the same then load it..
		if BSCAS.SV.SELECTED_PRESET ~= Preset then
			BSCAS.LoadSetting(Preset)
			CHAT_ROUTER:AddSystemMessage(zo_strformat("|cFFFFFF BSCs-AS Loading "..GetString(SI_SYNERGY_NAME_PRE)..": <<1>>|r", BSCAS.SV.SELECTED_PRESET))
			BSCAS.PlaySound(1, SOUNDS.CHAMPION_RESPEC_ACCEPT)
		end
	end)
	
	-- fix for save..
	ZO_PreHook(Setup, "FromStorage", function( tb, tag, pageId, index)	
		if WizardsWardrobe.setups[tag] and WizardsWardrobe.setups[tag][pageId] and WizardsWardrobe.setups[tag][pageId][index] then
			if WizardsWardrobe.setups[tag][pageId][index].BSCASPreset ~= nil then
				fixedPreset = WizardsWardrobe.setups[tag][pageId][index].BSCASPreset
				zo_callLater(function() fixedPreset = "" end, 300)
			end
		end
	end)	
	ZO_PostHook(Setup, "ToStorage", function( tb, tag, pageId, index)		
		zo_callLater(
			function() 
				if not bSaved and fixedPreset ~= "" then
					WizardsWardrobe.setups[tag][pageId][index].BSCASPreset = fixedPreset
				end
				bSaved = false
				fixedPreset = ""
			end, 
		200)
	end)
end